/* utils.c generated by valac 0.42.7, the Vala compiler
 * generated from utils.vala, do not modify */

/*
Peek Copyright (c) 2015-2018 by Philipp Wolfer <ph.wolfer@gmail.com>

This file is part of Peek.

This software is licensed under the GNU General Public License
(version 3 or later). See the LICENSE file in this distribution.
*/


#include <glib.h>
#include <glib-object.h>
#include "../../application.h"
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <stdio.h>
#include <glib/gstdio.h>
#include <unistd.h>
#include <gobject/gvaluecollector.h>

#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
typedef struct _PeekParamSpecUtils PeekParamSpecUtils;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PeekParamSpecUtils {
	GParamSpec parent_instance;
};


static gpointer peek_utils_parent_class = NULL;

#define PEEK_UTILS_NUMBER_FORMAT "%02" G_GINT64_MODIFIER "d"
#define PEEK_UTILS_TIME_FORMAT PEEK_UTILS_NUMBER_FORMAT ":" PEEK_UTILS_NUMBER_FORMAT
static gchar* peek_utils_read_instream_as_utf8 (GInputStream* stream);
static void peek_utils_finalize (PeekUtils * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


gchar*
peek_utils_get_temp_dir (void)
{
	gchar* result = NULL;
	gchar* cache_dir_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* cache_dir = NULL;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp12_;
	gchar* _tmp13_;
	GError* _inner_error0_ = NULL;
#line 14 "../src/utils.vala"
	_tmp0_ = g_get_user_cache_dir ();
#line 14 "../src/utils.vala"
	_tmp1_ = g_build_filename (_tmp0_, "peek", NULL);
#line 14 "../src/utils.vala"
	cache_dir_path = _tmp1_;
#line 17 "../src/utils.vala"
	_tmp2_ = cache_dir_path;
#line 17 "../src/utils.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 17 "../src/utils.vala"
	cache_dir = _tmp3_;
#line 81 "utils.c"
	{
		GFile* _tmp4_;
#line 20 "../src/utils.vala"
		_tmp4_ = cache_dir;
#line 20 "../src/utils.vala"
		g_file_make_directory_with_parents (_tmp4_, NULL, &_inner_error0_);
#line 20 "../src/utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 90 "utils.c"
			goto __catch8_g_error;
		}
	}
	goto __finally8;
	__catch8_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
#line 19 "../src/utils.vala"
		e = _inner_error0_;
#line 19 "../src/utils.vala"
		_inner_error0_ = NULL;
#line 22 "../src/utils.vala"
		_tmp5_ = e;
#line 22 "../src/utils.vala"
		if (g_error_matches (_tmp5_, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
#line 107 "utils.c"
			const gchar* _tmp6_;
#line 23 "../src/utils.vala"
			_tmp6_ = cache_dir_path;
#line 23 "../src/utils.vala"
			g_debug ("utils.vala:23: Cache directory does already exist %s\n", _tmp6_);
#line 113 "utils.c"
		} else {
			FILE* _tmp7_;
			GError* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 25 "../src/utils.vala"
			_tmp7_ = stderr;
#line 25 "../src/utils.vala"
			_tmp8_ = e;
#line 25 "../src/utils.vala"
			_tmp9_ = _tmp8_->message;
#line 25 "../src/utils.vala"
			fprintf (_tmp7_, "Error: %s\n", _tmp9_);
#line 26 "../src/utils.vala"
			_tmp10_ = g_get_tmp_dir ();
#line 26 "../src/utils.vala"
			_tmp11_ = g_strdup (_tmp10_);
#line 26 "../src/utils.vala"
			result = _tmp11_;
#line 26 "../src/utils.vala"
			_g_error_free0 (e);
#line 26 "../src/utils.vala"
			_g_object_unref0 (cache_dir);
#line 26 "../src/utils.vala"
			_g_free0 (cache_dir_path);
#line 26 "../src/utils.vala"
			return result;
#line 142 "utils.c"
		}
#line 19 "../src/utils.vala"
		_g_error_free0 (e);
#line 146 "utils.c"
	}
	__finally8:
#line 19 "../src/utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 19 "../src/utils.vala"
		_g_object_unref0 (cache_dir);
#line 19 "../src/utils.vala"
		_g_free0 (cache_dir_path);
#line 19 "../src/utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 19 "../src/utils.vala"
		g_clear_error (&_inner_error0_);
#line 19 "../src/utils.vala"
		return NULL;
#line 161 "utils.c"
	}
#line 30 "../src/utils.vala"
	_tmp12_ = cache_dir;
#line 30 "../src/utils.vala"
	_tmp13_ = g_file_get_path (_tmp12_);
#line 30 "../src/utils.vala"
	result = _tmp13_;
#line 30 "../src/utils.vala"
	_g_object_unref0 (cache_dir);
#line 30 "../src/utils.vala"
	_g_free0 (cache_dir_path);
#line 30 "../src/utils.vala"
	return result;
#line 175 "utils.c"
}


gchar*
peek_utils_create_temp_file (const gchar* extension,
                             GError** error)
{
	gchar* result = NULL;
	gchar* temp_dir = NULL;
	gchar* _tmp0_;
	gchar* file_name = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gint fd = 0;
#line 33 "../src/utils.vala"
	g_return_val_if_fail (extension != NULL, NULL);
#line 34 "../src/utils.vala"
	_tmp0_ = peek_utils_get_temp_dir ();
#line 34 "../src/utils.vala"
	temp_dir = _tmp0_;
#line 35 "../src/utils.vala"
	_tmp1_ = g_strconcat ("peekXXXXXX.", extension, NULL);
#line 35 "../src/utils.vala"
	_tmp2_ = _tmp1_;
#line 35 "../src/utils.vala"
	_tmp3_ = g_build_filename (temp_dir, _tmp2_, NULL);
#line 35 "../src/utils.vala"
	_tmp4_ = _tmp3_;
#line 35 "../src/utils.vala"
	_g_free0 (_tmp2_);
#line 35 "../src/utils.vala"
	file_name = _tmp4_;
#line 36 "../src/utils.vala"
	fd = g_mkstemp (file_name);
#line 37 "../src/utils.vala"
	close (fd);
#line 38 "../src/utils.vala"
	g_debug ("utils.vala:38: Temp file: %s\n", file_name);
#line 39 "../src/utils.vala"
	result = file_name;
#line 39 "../src/utils.vala"
	_g_free0 (temp_dir);
#line 39 "../src/utils.vala"
	return result;
#line 222 "utils.c"
}


gboolean
peek_utils_is_exit_status_success (gint status)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
	{
		gboolean _tmp0_ = FALSE;
#line 44 "../src/utils.vala"
		_tmp0_ = g_spawn_check_exit_status (status, &_inner_error0_);
#line 44 "../src/utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 237 "utils.c"
			goto __catch9_g_error;
		}
#line 44 "../src/utils.vala"
		if (_tmp0_) {
#line 45 "../src/utils.vala"
			result = TRUE;
#line 45 "../src/utils.vala"
			return result;
#line 246 "utils.c"
		}
	}
	goto __finally9;
	__catch9_g_error:
	{
		GError* e = NULL;
		FILE* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 43 "../src/utils.vala"
		e = _inner_error0_;
#line 43 "../src/utils.vala"
		_inner_error0_ = NULL;
#line 49 "../src/utils.vala"
		_tmp1_ = stderr;
#line 49 "../src/utils.vala"
		_tmp2_ = e;
#line 49 "../src/utils.vala"
		_tmp3_ = _tmp2_->message;
#line 49 "../src/utils.vala"
		fprintf (_tmp1_, "Error: %s\n", _tmp3_);
#line 43 "../src/utils.vala"
		_g_error_free0 (e);
#line 270 "utils.c"
	}
	__finally9:
#line 43 "../src/utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 275 "utils.c"
		gboolean _tmp4_ = FALSE;
#line 43 "../src/utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 43 "../src/utils.vala"
		g_clear_error (&_inner_error0_);
#line 43 "../src/utils.vala"
		return _tmp4_;
#line 283 "utils.c"
	}
#line 52 "../src/utils.vala"
	result = FALSE;
#line 52 "../src/utils.vala"
	return result;
#line 289 "utils.c"
}


gboolean
peek_utils_check_for_executable (const gchar* executable)
{
	gboolean result = FALSE;
	gchar** args = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gint args_length1;
	gint _args_size_;
	gint status = 0;
	gchar* output = NULL;
	gchar* errorout = NULL;
	GError* _inner_error0_ = NULL;
#line 55 "../src/utils.vala"
	g_return_val_if_fail (executable != NULL, FALSE);
#line 56 "../src/utils.vala"
	_tmp0_ = g_strdup ("which");
#line 56 "../src/utils.vala"
	_tmp1_ = g_strdup (executable);
#line 56 "../src/utils.vala"
	_tmp2_ = g_new0 (gchar*, 2 + 1);
#line 56 "../src/utils.vala"
	_tmp2_[0] = _tmp0_;
#line 56 "../src/utils.vala"
	_tmp2_[1] = _tmp1_;
#line 56 "../src/utils.vala"
	args = _tmp2_;
#line 56 "../src/utils.vala"
	args_length1 = 2;
#line 56 "../src/utils.vala"
	_args_size_ = args_length1;
#line 325 "utils.c"
	{
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gint _tmp5_ = 0;
#line 65 "../src/utils.vala"
		g_spawn_sync (NULL, args, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp3_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 65 "../src/utils.vala"
		_g_free0 (output);
#line 65 "../src/utils.vala"
		output = _tmp3_;
#line 65 "../src/utils.vala"
		_g_free0 (errorout);
#line 65 "../src/utils.vala"
		errorout = _tmp4_;
#line 65 "../src/utils.vala"
		status = _tmp5_;
#line 65 "../src/utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 344 "utils.c"
			gboolean _tmp6_ = FALSE;
#line 65 "../src/utils.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 348 "utils.c"
				goto __catch10_g_spawn_error;
			}
#line 65 "../src/utils.vala"
			_g_free0 (errorout);
#line 65 "../src/utils.vala"
			_g_free0 (output);
#line 65 "../src/utils.vala"
			args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 65 "../src/utils.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 65 "../src/utils.vala"
			g_clear_error (&_inner_error0_);
#line 65 "../src/utils.vala"
			return _tmp6_;
#line 363 "utils.c"
		}
#line 68 "../src/utils.vala"
		g_debug ("utils.vala:68: Looking for executable %s (%i): %s%s", executable, status, output, errorout);
#line 70 "../src/utils.vala"
		result = peek_utils_is_exit_status_success (status);
#line 70 "../src/utils.vala"
		_g_free0 (errorout);
#line 70 "../src/utils.vala"
		_g_free0 (output);
#line 70 "../src/utils.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 70 "../src/utils.vala"
		return result;
#line 377 "utils.c"
	}
	goto __finally10;
	__catch10_g_spawn_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 64 "../src/utils.vala"
		e = _inner_error0_;
#line 64 "../src/utils.vala"
		_inner_error0_ = NULL;
#line 72 "../src/utils.vala"
		_tmp7_ = e;
#line 72 "../src/utils.vala"
		_tmp8_ = _tmp7_->message;
#line 72 "../src/utils.vala"
		g_debug ("utils.vala:72: Error: %s", _tmp8_);
#line 64 "../src/utils.vala"
		_g_error_free0 (e);
#line 397 "utils.c"
	}
	__finally10:
#line 64 "../src/utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 402 "utils.c"
		gboolean _tmp9_ = FALSE;
#line 64 "../src/utils.vala"
		_g_free0 (errorout);
#line 64 "../src/utils.vala"
		_g_free0 (output);
#line 64 "../src/utils.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 64 "../src/utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 64 "../src/utils.vala"
		g_clear_error (&_inner_error0_);
#line 64 "../src/utils.vala"
		return _tmp9_;
#line 416 "utils.c"
	}
#line 75 "../src/utils.vala"
	result = FALSE;
#line 75 "../src/utils.vala"
	_g_free0 (errorout);
#line 75 "../src/utils.vala"
	_g_free0 (output);
#line 75 "../src/utils.vala"
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 75 "../src/utils.vala"
	return result;
#line 428 "utils.c"
}


gchar*
peek_utils_get_file_extension_for_format (PeekOutputFormat output_format)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 79 "../src/utils.vala"
	_tmp0_ = peek_output_format_to_string (output_format);
#line 79 "../src/utils.vala"
	result = _tmp0_;
#line 79 "../src/utils.vala"
	return result;
#line 443 "utils.c"
}


static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
	gunichar _tmp0_;
#line 1199 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1200 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1201 "glib-2.0.vapi"
	_tmp0_ = _vala_c;
#line 1201 "glib-2.0.vapi"
	if (_tmp0_ != ((gunichar) 0)) {
#line 463 "utils.c"
		gchar* _tmp1_;
#line 1202 "glib-2.0.vapi"
		_tmp1_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1202 "glib-2.0.vapi"
		*index = (gint) (_tmp1_ - ((gchar*) self));
#line 1203 "glib-2.0.vapi"
		result = TRUE;
#line 1203 "glib-2.0.vapi"
		if (c) {
#line 1203 "glib-2.0.vapi"
			*c = _vala_c;
#line 475 "utils.c"
		}
#line 1203 "glib-2.0.vapi"
		return result;
#line 479 "utils.c"
	} else {
#line 1205 "glib-2.0.vapi"
		result = FALSE;
#line 1205 "glib-2.0.vapi"
		if (c) {
#line 1205 "glib-2.0.vapi"
			*c = _vala_c;
#line 487 "utils.c"
		}
#line 1205 "glib-2.0.vapi"
		return result;
#line 491 "utils.c"
	}
#line 1199 "glib-2.0.vapi"
	if (c) {
#line 1199 "glib-2.0.vapi"
		*c = _vala_c;
#line 497 "utils.c"
	}
}


gboolean
peek_utils_string_is_empty (const gchar* str)
{
	gboolean result = FALSE;
	gunichar c = 0U;
#line 83 "../src/utils.vala"
	if (str == NULL) {
#line 83 "../src/utils.vala"
		result = TRUE;
#line 83 "../src/utils.vala"
		return result;
#line 513 "utils.c"
	}
	{
		gint i = 0;
#line 86 "../src/utils.vala"
		i = 0;
#line 519 "utils.c"
		{
			gboolean _tmp0_ = FALSE;
#line 86 "../src/utils.vala"
			_tmp0_ = TRUE;
#line 86 "../src/utils.vala"
			while (TRUE) {
#line 526 "utils.c"
				gunichar _tmp1_ = 0U;
				gboolean _tmp2_;
				gboolean _tmp3_ = FALSE;
				gunichar _tmp4_;
#line 86 "../src/utils.vala"
				if (!_tmp0_) {
#line 533 "utils.c"
				}
#line 86 "../src/utils.vala"
				_tmp0_ = FALSE;
#line 86 "../src/utils.vala"
				_tmp2_ = string_get_next_char (str, &i, &_tmp1_);
#line 86 "../src/utils.vala"
				c = _tmp1_;
#line 86 "../src/utils.vala"
				if (!_tmp2_) {
#line 86 "../src/utils.vala"
					break;
#line 545 "utils.c"
				}
#line 87 "../src/utils.vala"
				_tmp4_ = c;
#line 87 "../src/utils.vala"
				if (!g_unichar_isspace (_tmp4_)) {
#line 551 "utils.c"
					gunichar _tmp5_;
#line 87 "../src/utils.vala"
					_tmp5_ = c;
#line 87 "../src/utils.vala"
					_tmp3_ = !g_unichar_iscntrl (_tmp5_);
#line 557 "utils.c"
				} else {
#line 87 "../src/utils.vala"
					_tmp3_ = FALSE;
#line 561 "utils.c"
				}
#line 87 "../src/utils.vala"
				if (_tmp3_) {
#line 87 "../src/utils.vala"
					result = FALSE;
#line 87 "../src/utils.vala"
					return result;
#line 569 "utils.c"
				}
			}
		}
	}
#line 90 "../src/utils.vala"
	result = TRUE;
#line 90 "../src/utils.vala"
	return result;
#line 578 "utils.c"
}


gint
peek_utils_make_even (gint i)
{
	gint result = 0;
#line 94 "../src/utils.vala"
	result = (i / 2) * 2;
#line 94 "../src/utils.vala"
	return result;
#line 590 "utils.c"
}


/**
    * Returns available system memory in kiB.
    * Returns -1 if memory could not be read
    */
static gchar*
g_file_stream_read_line (FILE* self)
{
	gchar* result = NULL;
	gint c = 0;
	GString* ret = NULL;
	GString* _tmp6_;
#line 3642 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 3644 "glib-2.0.vapi"
	ret = NULL;
#line 3645 "glib-2.0.vapi"
	while (TRUE) {
#line 611 "utils.c"
		gint _tmp0_;
		GString* _tmp1_;
		gint _tmp3_;
		GString* _tmp4_;
		gint _tmp5_;
#line 3645 "glib-2.0.vapi"
		c = fgetc (self);
#line 3645 "glib-2.0.vapi"
		_tmp0_ = c;
#line 3645 "glib-2.0.vapi"
		if (!(_tmp0_ != EOF)) {
#line 3645 "glib-2.0.vapi"
			break;
#line 625 "utils.c"
		}
#line 3646 "glib-2.0.vapi"
		_tmp1_ = ret;
#line 3646 "glib-2.0.vapi"
		if (_tmp1_ == NULL) {
#line 631 "utils.c"
			GString* _tmp2_;
#line 3647 "glib-2.0.vapi"
			_tmp2_ = g_string_new ("");
#line 3647 "glib-2.0.vapi"
			_g_string_free0 (ret);
#line 3647 "glib-2.0.vapi"
			ret = _tmp2_;
#line 639 "utils.c"
		}
#line 3649 "glib-2.0.vapi"
		_tmp3_ = c;
#line 3649 "glib-2.0.vapi"
		if (_tmp3_ == ((gint) '\n')) {
#line 3650 "glib-2.0.vapi"
			break;
#line 647 "utils.c"
		}
#line 3652 "glib-2.0.vapi"
		_tmp4_ = ret;
#line 3652 "glib-2.0.vapi"
		_tmp5_ = c;
#line 3652 "glib-2.0.vapi"
		g_string_append_c ((GString*) _tmp4_, (gchar) _tmp5_);
#line 655 "utils.c"
	}
#line 3654 "glib-2.0.vapi"
	_tmp6_ = ret;
#line 3654 "glib-2.0.vapi"
	if (_tmp6_ == NULL) {
#line 3655 "glib-2.0.vapi"
		result = NULL;
#line 3655 "glib-2.0.vapi"
		_g_string_free0 (ret);
#line 3655 "glib-2.0.vapi"
		return result;
#line 667 "utils.c"
	} else {
		GString* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 3657 "glib-2.0.vapi"
		_tmp7_ = ret;
#line 3657 "glib-2.0.vapi"
		_tmp8_ = ((GString*) _tmp7_)->str;
#line 3657 "glib-2.0.vapi"
		_tmp9_ = g_strdup (_tmp8_);
#line 3657 "glib-2.0.vapi"
		result = _tmp9_;
#line 3657 "glib-2.0.vapi"
		_g_string_free0 (ret);
#line 3657 "glib-2.0.vapi"
		return result;
#line 684 "utils.c"
	}
#line 3642 "glib-2.0.vapi"
	_g_string_free0 (ret);
#line 688 "utils.c"
}


gint
peek_utils_get_available_system_memory (void)
{
	gint result = 0;
	FILE* stream = NULL;
	FILE* _tmp0_;
	FILE* _tmp1_;
	gchar* line = NULL;
#line 102 "../src/utils.vala"
	_tmp0_ = g_fopen ("/proc/meminfo", "r");
#line 102 "../src/utils.vala"
	stream = _tmp0_;
#line 103 "../src/utils.vala"
	_tmp1_ = stream;
#line 103 "../src/utils.vala"
	_vala_assert (_tmp1_ != NULL, "stream != null");
#line 106 "../src/utils.vala"
	while (TRUE) {
#line 710 "utils.c"
		FILE* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
#line 106 "../src/utils.vala"
		_tmp2_ = stream;
#line 106 "../src/utils.vala"
		_tmp3_ = g_file_stream_read_line (_tmp2_);
#line 106 "../src/utils.vala"
		_g_free0 (line);
#line 106 "../src/utils.vala"
		line = _tmp3_;
#line 106 "../src/utils.vala"
		_tmp4_ = line;
#line 106 "../src/utils.vala"
		if (!(_tmp4_ != NULL)) {
#line 106 "../src/utils.vala"
			break;
#line 729 "utils.c"
		}
#line 107 "../src/utils.vala"
		_tmp5_ = line;
#line 107 "../src/utils.vala"
		if (g_str_has_prefix (_tmp5_, "MemAvailable")) {
#line 735 "utils.c"
			gint memory = 0;
			const gchar* _tmp6_;
#line 108 "../src/utils.vala"
			memory = 0;
#line 109 "../src/utils.vala"
			_tmp6_ = line;
#line 109 "../src/utils.vala"
			sscanf (_tmp6_, "MemAvailable: %d kB", &memory);
#line 110 "../src/utils.vala"
			result = memory;
#line 110 "../src/utils.vala"
			_g_free0 (line);
#line 110 "../src/utils.vala"
			_fclose0 (stream);
#line 110 "../src/utils.vala"
			return result;
#line 752 "utils.c"
		}
	}
#line 114 "../src/utils.vala"
	result = -1;
#line 114 "../src/utils.vala"
	_g_free0 (line);
#line 114 "../src/utils.vala"
	_fclose0 (stream);
#line 114 "../src/utils.vala"
	return result;
#line 763 "utils.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 128 "../src/utils.vala"
	return self ? g_object_ref (self) : NULL;
#line 772 "utils.c"
}


static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  int str_array_length1)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
#line 1148 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1149 "glib-2.0.vapi"
		separator = "";
#line 787 "utils.c"
	}
#line 1151 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 791 "utils.c"
		gboolean _tmp1_ = FALSE;
#line 1151 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1151 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 797 "utils.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1151 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 802 "utils.c"
				const gchar* _tmp3_;
#line 1151 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1151 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 808 "utils.c"
			} else {
#line 1151 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 812 "utils.c"
			}
#line 1151 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 816 "utils.c"
		}
#line 1151 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 820 "utils.c"
	} else {
#line 1151 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 824 "utils.c"
	}
#line 1151 "glib-2.0.vapi"
	if (_tmp0_) {
#line 828 "utils.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp20_;
		gint _tmp22_;
		gsize _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		const gchar* res = NULL;
		gsize _tmp27_;
		void* _tmp28_;
		void* ptr = NULL;
		const gchar* _tmp29_;
		const gchar* _tmp30_;
		void* _tmp31_;
		const gchar* _tmp44_;
#line 1153 "glib-2.0.vapi"
		len = (gsize) 1;
#line 847 "utils.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1154 "glib-2.0.vapi"
			i = 0;
#line 1154 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1154 "glib-2.0.vapi"
			while (TRUE) {
#line 856 "utils.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp12_ = 0;
				gint _tmp13_;
				const gchar* _tmp14_;
				gsize _tmp19_;
#line 1154 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 865 "utils.c"
					gint _tmp5_;
#line 1154 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1154 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 871 "utils.c"
				}
#line 1154 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1154 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 877 "utils.c"
					gint _tmp8_;
#line 1154 "glib-2.0.vapi"
					_tmp8_ = i;
#line 1154 "glib-2.0.vapi"
					_tmp7_ = _tmp8_ < str_array_length1;
#line 883 "utils.c"
				} else {
#line 1154 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 887 "utils.c"
				}
#line 1154 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1154 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 893 "utils.c"
				} else {
					gboolean _tmp9_ = FALSE;
#line 1154 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 898 "utils.c"
						gint _tmp10_;
						const gchar* _tmp11_;
#line 1154 "glib-2.0.vapi"
						_tmp10_ = i;
#line 1154 "glib-2.0.vapi"
						_tmp11_ = str_array[_tmp10_];
#line 1154 "glib-2.0.vapi"
						_tmp9_ = _tmp11_ != NULL;
#line 907 "utils.c"
					} else {
#line 1154 "glib-2.0.vapi"
						_tmp9_ = FALSE;
#line 911 "utils.c"
					}
#line 1154 "glib-2.0.vapi"
					_tmp6_ = _tmp9_;
#line 915 "utils.c"
				}
#line 1154 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1154 "glib-2.0.vapi"
					break;
#line 921 "utils.c"
				}
#line 1155 "glib-2.0.vapi"
				_tmp13_ = i;
#line 1155 "glib-2.0.vapi"
				_tmp14_ = str_array[_tmp13_];
#line 1155 "glib-2.0.vapi"
				if (_tmp14_ != NULL) {
#line 929 "utils.c"
					gint _tmp15_;
					const gchar* _tmp16_;
					gint _tmp17_;
					gint _tmp18_;
#line 1155 "glib-2.0.vapi"
					_tmp15_ = i;
#line 1155 "glib-2.0.vapi"
					_tmp16_ = str_array[_tmp15_];
#line 1155 "glib-2.0.vapi"
					_tmp17_ = strlen ((const gchar*) _tmp16_);
#line 1155 "glib-2.0.vapi"
					_tmp18_ = _tmp17_;
#line 1155 "glib-2.0.vapi"
					_tmp12_ = _tmp18_;
#line 944 "utils.c"
				} else {
#line 1155 "glib-2.0.vapi"
					_tmp12_ = 0;
#line 948 "utils.c"
				}
#line 1155 "glib-2.0.vapi"
				_tmp19_ = len;
#line 1155 "glib-2.0.vapi"
				len = _tmp19_ + _tmp12_;
#line 954 "utils.c"
			}
		}
#line 1157 "glib-2.0.vapi"
		_tmp20_ = i;
#line 1157 "glib-2.0.vapi"
		if (_tmp20_ == 0) {
#line 961 "utils.c"
			gchar* _tmp21_;
#line 1158 "glib-2.0.vapi"
			_tmp21_ = g_strdup ("");
#line 1158 "glib-2.0.vapi"
			result = _tmp21_;
#line 1158 "glib-2.0.vapi"
			return result;
#line 969 "utils.c"
		}
#line 1160 "glib-2.0.vapi"
		_tmp22_ = i;
#line 1160 "glib-2.0.vapi"
		str_array_length1 = _tmp22_;
#line 1161 "glib-2.0.vapi"
		_tmp23_ = len;
#line 1161 "glib-2.0.vapi"
		_tmp24_ = strlen ((const gchar*) separator);
#line 1161 "glib-2.0.vapi"
		_tmp25_ = _tmp24_;
#line 1161 "glib-2.0.vapi"
		_tmp26_ = i;
#line 1161 "glib-2.0.vapi"
		len = _tmp23_ + (_tmp25_ * (_tmp26_ - 1));
#line 1163 "glib-2.0.vapi"
		_tmp27_ = len;
#line 1163 "glib-2.0.vapi"
		_tmp28_ = g_malloc (_tmp27_);
#line 1163 "glib-2.0.vapi"
		res = _tmp28_;
#line 1164 "glib-2.0.vapi"
		_tmp29_ = res;
#line 1164 "glib-2.0.vapi"
		_tmp30_ = str_array[0];
#line 1164 "glib-2.0.vapi"
		_tmp31_ = g_stpcpy ((void*) _tmp29_, (const gchar*) _tmp30_);
#line 1164 "glib-2.0.vapi"
		ptr = _tmp31_;
#line 999 "utils.c"
		{
			gboolean _tmp32_ = FALSE;
#line 1165 "glib-2.0.vapi"
			i = 1;
#line 1165 "glib-2.0.vapi"
			_tmp32_ = TRUE;
#line 1165 "glib-2.0.vapi"
			while (TRUE) {
#line 1008 "utils.c"
				gint _tmp34_;
				void* _tmp35_;
				void* _tmp36_;
				const gchar* _tmp37_ = NULL;
				gint _tmp38_;
				const gchar* _tmp39_;
				void* _tmp42_;
				void* _tmp43_;
#line 1165 "glib-2.0.vapi"
				if (!_tmp32_) {
#line 1019 "utils.c"
					gint _tmp33_;
#line 1165 "glib-2.0.vapi"
					_tmp33_ = i;
#line 1165 "glib-2.0.vapi"
					i = _tmp33_ + 1;
#line 1025 "utils.c"
				}
#line 1165 "glib-2.0.vapi"
				_tmp32_ = FALSE;
#line 1165 "glib-2.0.vapi"
				_tmp34_ = i;
#line 1165 "glib-2.0.vapi"
				if (!(_tmp34_ < str_array_length1)) {
#line 1165 "glib-2.0.vapi"
					break;
#line 1035 "utils.c"
				}
#line 1166 "glib-2.0.vapi"
				_tmp35_ = ptr;
#line 1166 "glib-2.0.vapi"
				_tmp36_ = g_stpcpy (_tmp35_, (const gchar*) separator);
#line 1166 "glib-2.0.vapi"
				ptr = _tmp36_;
#line 1167 "glib-2.0.vapi"
				_tmp38_ = i;
#line 1167 "glib-2.0.vapi"
				_tmp39_ = str_array[_tmp38_];
#line 1167 "glib-2.0.vapi"
				if (_tmp39_ != NULL) {
#line 1049 "utils.c"
					gint _tmp40_;
					const gchar* _tmp41_;
#line 1167 "glib-2.0.vapi"
					_tmp40_ = i;
#line 1167 "glib-2.0.vapi"
					_tmp41_ = str_array[_tmp40_];
#line 1167 "glib-2.0.vapi"
					_tmp37_ = (const gchar*) _tmp41_;
#line 1058 "utils.c"
				} else {
#line 1167 "glib-2.0.vapi"
					_tmp37_ = "";
#line 1062 "utils.c"
				}
#line 1167 "glib-2.0.vapi"
				_tmp42_ = ptr;
#line 1167 "glib-2.0.vapi"
				_tmp43_ = g_stpcpy (_tmp42_, _tmp37_);
#line 1167 "glib-2.0.vapi"
				ptr = _tmp43_;
#line 1070 "utils.c"
			}
		}
#line 1170 "glib-2.0.vapi"
		_tmp44_ = res;
#line 1170 "glib-2.0.vapi"
		res = NULL;
#line 1170 "glib-2.0.vapi"
		result = (gchar*) _tmp44_;
#line 1170 "glib-2.0.vapi"
		return result;
#line 1081 "utils.c"
	} else {
		gchar* _tmp45_;
#line 1172 "glib-2.0.vapi"
		_tmp45_ = g_strdup ("");
#line 1172 "glib-2.0.vapi"
		result = _tmp45_;
#line 1172 "glib-2.0.vapi"
		return result;
#line 1090 "utils.c"
	}
}


gchar*
peek_utils_get_command_failed_message (gchar** argv,
                                       int argv_length1,
                                       GSubprocess* subprocess)
{
	gchar* result = NULL;
	gint status = 0;
	gint term_sig = 0;
	gchar* output = NULL;
	gchar* message = NULL;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
#line 118 "../src/utils.vala"
	status = -1;
#line 119 "../src/utils.vala"
	term_sig = 0;
#line 120 "../src/utils.vala"
	output = NULL;
#line 122 "../src/utils.vala"
	if (subprocess != NULL) {
#line 1120 "utils.c"
		GInputStream* stdout_pipe = NULL;
		GInputStream* _tmp0_;
		GInputStream* _tmp1_;
		GInputStream* _tmp2_;
#line 123 "../src/utils.vala"
		status = g_subprocess_get_status (subprocess);
#line 124 "../src/utils.vala"
		if (g_subprocess_get_if_signaled (subprocess)) {
#line 125 "../src/utils.vala"
			term_sig = g_subprocess_get_term_sig (subprocess);
#line 1131 "utils.c"
		}
#line 128 "../src/utils.vala"
		_tmp0_ = g_subprocess_get_stdout_pipe (subprocess);
#line 128 "../src/utils.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 128 "../src/utils.vala"
		stdout_pipe = _tmp1_;
#line 129 "../src/utils.vala"
		_tmp2_ = stdout_pipe;
#line 129 "../src/utils.vala"
		if (_tmp2_ != NULL) {
#line 1143 "utils.c"
			GInputStream* _tmp3_;
			gchar* _tmp4_;
#line 130 "../src/utils.vala"
			_tmp3_ = stdout_pipe;
#line 130 "../src/utils.vala"
			_tmp4_ = peek_utils_read_instream_as_utf8 (_tmp3_);
#line 130 "../src/utils.vala"
			_g_free0 (output);
#line 130 "../src/utils.vala"
			output = _tmp4_;
#line 1154 "utils.c"
		}
#line 122 "../src/utils.vala"
		_g_object_unref0 (stdout_pipe);
#line 1158 "utils.c"
	}
#line 134 "../src/utils.vala"
	_tmp5_ = _vala_g_strjoinv (" ", argv, argv_length1);
#line 134 "../src/utils.vala"
	_tmp6_ = _tmp5_;
#line 134 "../src/utils.vala"
	_tmp7_ = status;
#line 134 "../src/utils.vala"
	_tmp8_ = term_sig;
#line 134 "../src/utils.vala"
	_tmp9_ = g_strdup_printf ("Command \"%s\" failed with status %i (received signal %i).", _tmp6_, _tmp7_, _tmp8_);
#line 134 "../src/utils.vala"
	_tmp10_ = _tmp9_;
#line 134 "../src/utils.vala"
	_g_free0 (_tmp6_);
#line 134 "../src/utils.vala"
	message = _tmp10_;
#line 137 "../src/utils.vala"
	_tmp11_ = output;
#line 137 "../src/utils.vala"
	if (_tmp11_ != NULL) {
#line 1180 "utils.c"
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 138 "../src/utils.vala"
		_tmp12_ = message;
#line 138 "../src/utils.vala"
		_tmp13_ = output;
#line 138 "../src/utils.vala"
		_tmp14_ = g_strdup_printf ("\n\nOutput:\n%s", _tmp13_);
#line 138 "../src/utils.vala"
		_tmp15_ = _tmp14_;
#line 138 "../src/utils.vala"
		_tmp16_ = g_strconcat (_tmp12_, _tmp15_, NULL);
#line 138 "../src/utils.vala"
		_g_free0 (message);
#line 138 "../src/utils.vala"
		message = _tmp16_;
#line 138 "../src/utils.vala"
		_g_free0 (_tmp15_);
#line 1202 "utils.c"
	}
#line 141 "../src/utils.vala"
	result = message;
#line 141 "../src/utils.vala"
	_g_free0 (output);
#line 141 "../src/utils.vala"
	return result;
#line 1210 "utils.c"
}


static gchar*
peek_utils_read_instream_as_utf8 (GInputStream* stream)
{
	gchar* result = NULL;
	GString* output = NULL;
	GString* _tmp0_;
	GDataInputStream* dis = NULL;
	GDataInputStream* _tmp1_;
	gchar* line = NULL;
	GString* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	GError* _inner_error0_ = NULL;
#line 144 "../src/utils.vala"
	g_return_val_if_fail (stream != NULL, NULL);
#line 145 "../src/utils.vala"
	_tmp0_ = g_string_new ("");
#line 145 "../src/utils.vala"
	output = _tmp0_;
#line 146 "../src/utils.vala"
	_tmp1_ = g_data_input_stream_new (stream);
#line 146 "../src/utils.vala"
	dis = _tmp1_;
#line 1237 "utils.c"
	{
#line 150 "../src/utils.vala"
		while (TRUE) {
#line 1241 "utils.c"
			gchar* _tmp2_ = NULL;
			GDataInputStream* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			const gchar* _tmp6_;
			GString* _tmp7_;
			const gchar* _tmp8_;
#line 150 "../src/utils.vala"
			_tmp3_ = dis;
#line 150 "../src/utils.vala"
			_tmp4_ = g_data_input_stream_read_line_utf8 (_tmp3_, NULL, NULL, &_inner_error0_);
#line 150 "../src/utils.vala"
			_tmp2_ = _tmp4_;
#line 150 "../src/utils.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 150 "../src/utils.vala"
				if (_inner_error0_->domain == G_IO_ERROR) {
#line 1259 "utils.c"
					goto __catch11_g_io_error;
				}
#line 150 "../src/utils.vala"
				_g_free0 (line);
#line 150 "../src/utils.vala"
				_g_object_unref0 (dis);
#line 150 "../src/utils.vala"
				_g_string_free0 (output);
#line 150 "../src/utils.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 150 "../src/utils.vala"
				g_clear_error (&_inner_error0_);
#line 150 "../src/utils.vala"
				return NULL;
#line 1274 "utils.c"
			}
#line 150 "../src/utils.vala"
			_tmp5_ = _tmp2_;
#line 150 "../src/utils.vala"
			_tmp2_ = NULL;
#line 150 "../src/utils.vala"
			_g_free0 (line);
#line 150 "../src/utils.vala"
			line = _tmp5_;
#line 150 "../src/utils.vala"
			_tmp6_ = line;
#line 150 "../src/utils.vala"
			if (!(_tmp6_ != NULL)) {
#line 150 "../src/utils.vala"
				_g_free0 (_tmp2_);
#line 150 "../src/utils.vala"
				break;
#line 1292 "utils.c"
			}
#line 151 "../src/utils.vala"
			_tmp7_ = output;
#line 151 "../src/utils.vala"
			_tmp8_ = line;
#line 151 "../src/utils.vala"
			g_string_append (_tmp7_, _tmp8_);
#line 150 "../src/utils.vala"
			_g_free0 (_tmp2_);
#line 1302 "utils.c"
		}
	}
	goto __finally11;
	__catch11_g_io_error:
	{
		GError* e = NULL;
		FILE* _tmp9_;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 149 "../src/utils.vala"
		e = _inner_error0_;
#line 149 "../src/utils.vala"
		_inner_error0_ = NULL;
#line 154 "../src/utils.vala"
		_tmp9_ = stderr;
#line 154 "../src/utils.vala"
		_tmp10_ = e;
#line 154 "../src/utils.vala"
		_tmp11_ = _tmp10_->message;
#line 154 "../src/utils.vala"
		fprintf (_tmp9_, "Error: %s\n", _tmp11_);
#line 155 "../src/utils.vala"
		result = NULL;
#line 155 "../src/utils.vala"
		_g_error_free0 (e);
#line 155 "../src/utils.vala"
		_g_free0 (line);
#line 155 "../src/utils.vala"
		_g_object_unref0 (dis);
#line 155 "../src/utils.vala"
		_g_string_free0 (output);
#line 155 "../src/utils.vala"
		return result;
#line 1336 "utils.c"
	}
	__finally11:
#line 149 "../src/utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 149 "../src/utils.vala"
		_g_free0 (line);
#line 149 "../src/utils.vala"
		_g_object_unref0 (dis);
#line 149 "../src/utils.vala"
		_g_string_free0 (output);
#line 149 "../src/utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 149 "../src/utils.vala"
		g_clear_error (&_inner_error0_);
#line 149 "../src/utils.vala"
		return NULL;
#line 1353 "utils.c"
	}
#line 158 "../src/utils.vala"
	_tmp12_ = output;
#line 158 "../src/utils.vala"
	_tmp13_ = _tmp12_->str;
#line 158 "../src/utils.vala"
	_tmp14_ = g_strdup (_tmp13_);
#line 158 "../src/utils.vala"
	result = _tmp14_;
#line 158 "../src/utils.vala"
	_g_free0 (line);
#line 158 "../src/utils.vala"
	_g_object_unref0 (dis);
#line 158 "../src/utils.vala"
	_g_string_free0 (output);
#line 158 "../src/utils.vala"
	return result;
#line 1371 "utils.c"
}


gchar*
peek_utils_format_time (gint64 seconds)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 164 "../src/utils.vala"
	_tmp0_ = g_strdup_printf (PEEK_UTILS_TIME_FORMAT, seconds / 60, seconds % 60);
#line 164 "../src/utils.vala"
	result = _tmp0_;
#line 164 "../src/utils.vala"
	return result;
#line 1386 "utils.c"
}


PeekUtils*
peek_utils_construct (GType object_type)
{
	PeekUtils* self = NULL;
#line 12 "../src/utils.vala"
	self = (PeekUtils*) g_type_create_instance (object_type);
#line 12 "../src/utils.vala"
	return self;
#line 1398 "utils.c"
}


PeekUtils*
peek_utils_new (void)
{
#line 12 "../src/utils.vala"
	return peek_utils_construct (PEEK_TYPE_UTILS);
#line 1407 "utils.c"
}


static void
peek_value_utils_init (GValue* value)
{
#line 12 "../src/utils.vala"
	value->data[0].v_pointer = NULL;
#line 1416 "utils.c"
}


static void
peek_value_utils_free_value (GValue* value)
{
#line 12 "../src/utils.vala"
	if (value->data[0].v_pointer) {
#line 12 "../src/utils.vala"
		peek_utils_unref (value->data[0].v_pointer);
#line 1427 "utils.c"
	}
}


static void
peek_value_utils_copy_value (const GValue* src_value,
                             GValue* dest_value)
{
#line 12 "../src/utils.vala"
	if (src_value->data[0].v_pointer) {
#line 12 "../src/utils.vala"
		dest_value->data[0].v_pointer = peek_utils_ref (src_value->data[0].v_pointer);
#line 1440 "utils.c"
	} else {
#line 12 "../src/utils.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1444 "utils.c"
	}
}


static gpointer
peek_value_utils_peek_pointer (const GValue* value)
{
#line 12 "../src/utils.vala"
	return value->data[0].v_pointer;
#line 1454 "utils.c"
}


static gchar*
peek_value_utils_collect_value (GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
#line 12 "../src/utils.vala"
	if (collect_values[0].v_pointer) {
#line 1466 "utils.c"
		PeekUtils * object;
		object = collect_values[0].v_pointer;
#line 12 "../src/utils.vala"
		if (object->parent_instance.g_class == NULL) {
#line 12 "../src/utils.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1473 "utils.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 12 "../src/utils.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1477 "utils.c"
		}
#line 12 "../src/utils.vala"
		value->data[0].v_pointer = peek_utils_ref (object);
#line 1481 "utils.c"
	} else {
#line 12 "../src/utils.vala"
		value->data[0].v_pointer = NULL;
#line 1485 "utils.c"
	}
#line 12 "../src/utils.vala"
	return NULL;
#line 1489 "utils.c"
}


static gchar*
peek_value_utils_lcopy_value (const GValue* value,
                              guint n_collect_values,
                              GTypeCValue* collect_values,
                              guint collect_flags)
{
	PeekUtils ** object_p;
	object_p = collect_values[0].v_pointer;
#line 12 "../src/utils.vala"
	if (!object_p) {
#line 12 "../src/utils.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1505 "utils.c"
	}
#line 12 "../src/utils.vala"
	if (!value->data[0].v_pointer) {
#line 12 "../src/utils.vala"
		*object_p = NULL;
#line 1511 "utils.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 12 "../src/utils.vala"
		*object_p = value->data[0].v_pointer;
#line 1515 "utils.c"
	} else {
#line 12 "../src/utils.vala"
		*object_p = peek_utils_ref (value->data[0].v_pointer);
#line 1519 "utils.c"
	}
#line 12 "../src/utils.vala"
	return NULL;
#line 1523 "utils.c"
}


GParamSpec*
peek_param_spec_utils (const gchar* name,
                       const gchar* nick,
                       const gchar* blurb,
                       GType object_type,
                       GParamFlags flags)
{
	PeekParamSpecUtils* spec;
#line 12 "../src/utils.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PEEK_TYPE_UTILS), NULL);
#line 12 "../src/utils.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 12 "../src/utils.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 12 "../src/utils.vala"
	return G_PARAM_SPEC (spec);
#line 1543 "utils.c"
}


gpointer
peek_value_get_utils (const GValue* value)
{
#line 12 "../src/utils.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PEEK_TYPE_UTILS), NULL);
#line 12 "../src/utils.vala"
	return value->data[0].v_pointer;
#line 1554 "utils.c"
}


void
peek_value_set_utils (GValue* value,
                      gpointer v_object)
{
	PeekUtils * old;
#line 12 "../src/utils.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PEEK_TYPE_UTILS));
#line 12 "../src/utils.vala"
	old = value->data[0].v_pointer;
#line 12 "../src/utils.vala"
	if (v_object) {
#line 12 "../src/utils.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PEEK_TYPE_UTILS));
#line 12 "../src/utils.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 12 "../src/utils.vala"
		value->data[0].v_pointer = v_object;
#line 12 "../src/utils.vala"
		peek_utils_ref (value->data[0].v_pointer);
#line 1577 "utils.c"
	} else {
#line 12 "../src/utils.vala"
		value->data[0].v_pointer = NULL;
#line 1581 "utils.c"
	}
#line 12 "../src/utils.vala"
	if (old) {
#line 12 "../src/utils.vala"
		peek_utils_unref (old);
#line 1587 "utils.c"
	}
}


void
peek_value_take_utils (GValue* value,
                       gpointer v_object)
{
	PeekUtils * old;
#line 12 "../src/utils.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PEEK_TYPE_UTILS));
#line 12 "../src/utils.vala"
	old = value->data[0].v_pointer;
#line 12 "../src/utils.vala"
	if (v_object) {
#line 12 "../src/utils.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PEEK_TYPE_UTILS));
#line 12 "../src/utils.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 12 "../src/utils.vala"
		value->data[0].v_pointer = v_object;
#line 1609 "utils.c"
	} else {
#line 12 "../src/utils.vala"
		value->data[0].v_pointer = NULL;
#line 1613 "utils.c"
	}
#line 12 "../src/utils.vala"
	if (old) {
#line 12 "../src/utils.vala"
		peek_utils_unref (old);
#line 1619 "utils.c"
	}
}


static void
peek_utils_class_init (PeekUtilsClass * klass)
{
#line 12 "../src/utils.vala"
	peek_utils_parent_class = g_type_class_peek_parent (klass);
#line 12 "../src/utils.vala"
	((PeekUtilsClass *) klass)->finalize = peek_utils_finalize;
#line 1631 "utils.c"
}


static void
peek_utils_instance_init (PeekUtils * self)
{
#line 12 "../src/utils.vala"
	self->ref_count = 1;
#line 1640 "utils.c"
}


static void
peek_utils_finalize (PeekUtils * obj)
{
	PeekUtils * self;
#line 12 "../src/utils.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PEEK_TYPE_UTILS, PeekUtils);
#line 12 "../src/utils.vala"
	g_signal_handlers_destroy (self);
#line 1652 "utils.c"
}


GType
peek_utils_get_type (void)
{
	static volatile gsize peek_utils_type_id__volatile = 0;
	if (g_once_init_enter (&peek_utils_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { peek_value_utils_init, peek_value_utils_free_value, peek_value_utils_copy_value, peek_value_utils_peek_pointer, "p", peek_value_utils_collect_value, "p", peek_value_utils_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PeekUtilsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) peek_utils_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PeekUtils), 0, (GInstanceInitFunc) peek_utils_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType peek_utils_type_id;
		peek_utils_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PeekUtils", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&peek_utils_type_id__volatile, peek_utils_type_id);
	}
	return peek_utils_type_id__volatile;
}


gpointer
peek_utils_ref (gpointer instance)
{
	PeekUtils * self;
	self = instance;
#line 12 "../src/utils.vala"
	g_atomic_int_inc (&self->ref_count);
#line 12 "../src/utils.vala"
	return instance;
#line 1681 "utils.c"
}


void
peek_utils_unref (gpointer instance)
{
	PeekUtils * self;
	self = instance;
#line 12 "../src/utils.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 12 "../src/utils.vala"
		PEEK_UTILS_GET_CLASS (self)->finalize (self);
#line 12 "../src/utils.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1696 "utils.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



