/* application-window.c generated by valac 0.42.7, the Vala compiler
 * generated from application-window.vala, do not modify */

/*
Peek Copyright (c) 2015-2018 by Philipp Wolfer <ph.wolfer@gmail.com>

This file is part of Peek.

This software is licensed under the GNU General Public License
(version 3 or later). See the LICENSE file in this distribution.

This file contains GPL 3 code taken from corebird, a Gtk+ linux Twitter client.
Copyright (C) 2013 Timm Bäder, https://github.com/baedert/corebird/
*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "../../application.h"
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <glib/gi18n-lib.h>
#include <cairo.h>
#include <pango/pango.h>
#include <glib/gstdio.h>


#define PEEK_UI_TYPE_APPLICATION_WINDOW (peek_ui_application_window_get_type ())
#define PEEK_UI_APPLICATION_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PEEK_UI_TYPE_APPLICATION_WINDOW, PeekUiApplicationWindow))
#define PEEK_UI_APPLICATION_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PEEK_UI_TYPE_APPLICATION_WINDOW, PeekUiApplicationWindowClass))
#define PEEK_UI_IS_APPLICATION_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PEEK_UI_TYPE_APPLICATION_WINDOW))
#define PEEK_UI_IS_APPLICATION_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PEEK_UI_TYPE_APPLICATION_WINDOW))
#define PEEK_UI_APPLICATION_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PEEK_UI_TYPE_APPLICATION_WINDOW, PeekUiApplicationWindowClass))

typedef struct _PeekUiApplicationWindow PeekUiApplicationWindow;
typedef struct _PeekUiApplicationWindowClass PeekUiApplicationWindowClass;
typedef struct _PeekUiApplicationWindowPrivate PeekUiApplicationWindowPrivate;
enum  {
	PEEK_UI_APPLICATION_WINDOW_0_PROPERTY,
	PEEK_UI_APPLICATION_WINDOW_RECORDER_PROPERTY,
	PEEK_UI_APPLICATION_WINDOW_OPEN_FILE_MANAGER_PROPERTY,
	PEEK_UI_APPLICATION_WINDOW_SHOW_NOTIFICATION_PROPERTY,
	PEEK_UI_APPLICATION_WINDOW_SIZE_INDICATOR_DELAY_PROPERTY,
	PEEK_UI_APPLICATION_WINDOW_RECORDING_START_DELAY_PROPERTY,
	PEEK_UI_APPLICATION_WINDOW_DEFAULT_FILE_NAME_FORMAT_PROPERTY,
	PEEK_UI_APPLICATION_WINDOW_SAVE_FOLDER_PROPERTY,
	PEEK_UI_APPLICATION_WINDOW_NUM_PROPERTIES
};
static GParamSpec* peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _cairo_region_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_region_destroy (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _gtk_icon_info_free0(var) ((var == NULL) ? NULL : (var = (gtk_icon_info_free (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))
enum  {
	PEEK_UI_APPLICATION_WINDOW_RECORDING_FINISHED_SIGNAL,
	PEEK_UI_APPLICATION_WINDOW_NUM_SIGNALS
};
static guint peek_ui_application_window_signals[PEEK_UI_APPLICATION_WINDOW_NUM_SIGNALS] = {0};

struct _PeekUiApplicationWindow {
	GtkApplicationWindow parent_instance;
	PeekUiApplicationWindowPrivate * priv;
};

struct _PeekUiApplicationWindowClass {
	GtkApplicationWindowClass parent_class;
};

struct _PeekUiApplicationWindowPrivate {
	PeekRecordingScreenRecorder* _recorder;
	gboolean _open_file_manager;
	gboolean _show_notification;
	gint _size_indicator_delay;
	gint _recording_start_delay;
	gchar* _default_file_name_format;
	gchar* _save_folder;
	GtkHeaderBar* headerbar;
	GtkWidget* recording_view;
	GtkButton* record_button;
	GtkButton* stop_button;
	GtkPopover* pop_format;
	GtkMenuButton* pop_format_menu;
	GtkLabel* size_indicator;
	GtkLabel* delay_indicator;
	GtkLabel* shortcut_label;
	GtkPopover* pop_menu;
	guint start_recording_event_source;
	guint size_indicator_timeout;
	guint delay_indicator_timeout;
	guint time_indicator_timeout;
	gboolean is_recording;
	gboolean is_postprocessing;
	GFile* in_file;
	GFile* out_file;
	PeekRecordingRecordingArea active_recording_area;
	gchar* stop_button_label;
	GSettings* settings;
};

struct _Block4Data {
	int _ref_count_;
	PeekUiApplicationWindow* self;
	gint delay;
};

struct _Block5Data {
	int _ref_count_;
	Block4Data * _data4_;
	gulong hide_handler;
};


static gint PeekUiApplicationWindow_private_offset;
static gpointer peek_ui_application_window_parent_class = NULL;

GType peek_ui_application_window_get_type (void) G_GNUC_CONST;
#define PEEK_UI_APPLICATION_WINDOW_SMALL_WINDOW_SIZE 380
PeekUiApplicationWindow* peek_ui_application_window_new (PeekApplication* application,
                                                         PeekRecordingScreenRecorder* recorder);
PeekUiApplicationWindow* peek_ui_application_window_construct (GType object_type,
                                                               PeekApplication* application,
                                                               PeekRecordingScreenRecorder* recorder);
void peek_ui_application_window_set_recorder (PeekUiApplicationWindow* self,
                                              PeekRecordingScreenRecorder* value);
PeekRecordingScreenRecorder* peek_ui_application_window_get_recorder (PeekUiApplicationWindow* self);
static void __lambda4_ (PeekUiApplicationWindow* self);
static void peek_ui_application_window_enter_recording_state (PeekUiApplicationWindow* self);
static void ___lambda4__peek_recording_screen_recorder_recording_started (PeekRecordingScreenRecorder* _sender,
                                                                   gpointer self);
static void __lambda5_ (PeekUiApplicationWindow* self);
static void peek_ui_application_window_show_file_chooser (PeekUiApplicationWindow* self);
static void ___lambda5__peek_recording_screen_recorder_recording_postprocess_started (PeekRecordingScreenRecorder* _sender,
                                                                               gpointer self);
static void __lambda9_ (PeekUiApplicationWindow* self,
                 GFile* file);
static void peek_ui_application_window_try_save_file (PeekUiApplicationWindow* self);
static void ___lambda9__peek_recording_screen_recorder_recording_finished (PeekRecordingScreenRecorder* _sender,
                                                                    GFile* file,
                                                                    gpointer self);
static void __lambda10_ (PeekUiApplicationWindow* self,
                  GError* reason);
GtkDialog* peek_ui_error_dialog_present_single_instance (GtkWindow* main_window,
                                                         const gchar* summary,
                                                         GError* _error_);
static void peek_ui_application_window_leave_recording_state (PeekUiApplicationWindow* self);
static void ___lambda10__peek_recording_screen_recorder_recording_aborted (PeekRecordingScreenRecorder* _sender,
                                                                    GError* reason,
                                                                    gpointer self);
static void peek_ui_application_window_toggle_recording (PeekUiApplicationWindow* self);
static void _peek_ui_application_window_toggle_recording_peek_application_toggle_recording (PeekApplication* _sender,
                                                                                     gpointer self);
static void peek_ui_application_window_prepare_start_recording (PeekUiApplicationWindow* self);
static void _peek_ui_application_window_prepare_start_recording_peek_application_start_recording (PeekApplication* _sender,
                                                                                           gpointer self);
static void peek_ui_application_window_prepare_stop_recording (PeekUiApplicationWindow* self);
static void _peek_ui_application_window_prepare_stop_recording_peek_application_stop_recording (PeekApplication* _sender,
                                                                                         gpointer self);
static void __lambda15_ (PeekUiApplicationWindow* self,
                  GParamSpec* pspec);
static void peek_ui_application_window_update_format_label (PeekUiApplicationWindow* self);
static void ___lambda15__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void peek_ui_application_window_load_geometry (PeekUiApplicationWindow* self);
void peek_ui_application_window_on_window_screen_changed (PeekUiApplicationWindow* self,
                                                          GdkScreen* previous_screen);
static void __lambda16_ (PeekUiApplicationWindow* self);
static void peek_ui_application_window_show_size_indicator (PeekUiApplicationWindow* self);
static void ___lambda16__gtk_widget_show (GtkWidget* _sender,
                                   gpointer self);
static void peek_ui_application_window_set_close_button_position (PeekUiApplicationWindow* self);
void peek_ui_application_window_hide_headerbar (PeekUiApplicationWindow* self);
static gboolean peek_ui_application_window_real_configure_event (GtkWidget* base,
                                                          GdkEventConfigure* event);
static void peek_ui_application_window_get_recording_area (PeekUiApplicationWindow* self,
                                                    PeekRecordingRecordingArea* result);
static gboolean peek_ui_application_window_real_delete_event (GtkWidget* base,
                                                       GdkEventAny* event);
static void ___lambda18_ (PeekUiApplicationWindow* self,
                   PeekUiApplicationWindow* file);
static void ____lambda18__peek_ui_application_window_recording_finished (PeekUiApplicationWindow* _sender,
                                                                  gpointer self);
static GNotification* peek_ui_application_window_build_standard_notification (const gchar* message);
static void peek_ui_application_window_save_geometry (PeekUiApplicationWindow* self);
static gchar* peek_ui_application_window_get_format_name (PeekUiApplicationWindow* self,
                                                   PeekOutputFormat format);
static void peek_ui_application_window_select_format (PeekUiApplicationWindow* self,
                                               PeekOutputFormat format);
static void peek_ui_application_window_update_time (PeekUiApplicationWindow* self);
static gboolean __lambda14_ (PeekUiApplicationWindow* self);
static gboolean ___lambda14__gsource_func (gpointer self);
static void _peek_ui_application_window_on_window_screen_changed_gtk_widget_screen_changed (GtkWidget* _sender,
                                                                                     GdkScreen* previous_screen,
                                                                                     gpointer self);
static gboolean peek_ui_application_window_on_window_draw (PeekUiApplicationWindow* self,
                                                    GtkWidget* widget,
                                                    cairo_t* ctx);
static void peek_ui_application_window_update_input_shape (PeekUiApplicationWindow* self);
static gboolean _peek_ui_application_window_on_window_draw_gtk_widget_draw (GtkWidget* _sender,
                                                                     cairo_t* cr,
                                                                     gpointer self);
static gboolean peek_ui_application_window_on_recording_view_draw (PeekUiApplicationWindow* self,
                                                            GtkWidget* widget,
                                                            cairo_t* ctx);
static gboolean _peek_ui_application_window_on_recording_view_draw_gtk_widget_draw (GtkWidget* _sender,
                                                                             cairo_t* cr,
                                                                             gpointer self);
static void peek_ui_application_window_on_recording_view_size_allocate (PeekUiApplicationWindow* self,
                                                                 GtkAllocation* allocation);
static void _peek_ui_application_window_on_recording_view_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender,
                                                                                           GtkAllocation* allocation,
                                                                                           gpointer self);
gint peek_ui_application_window_get_size_indicator_delay (PeekUiApplicationWindow* self);
static gboolean _____lambda17_ (PeekUiApplicationWindow* self);
static gboolean ______lambda17__gsource_func (gpointer self);
static void peek_ui_application_window_on_gif_button_clicked (PeekUiApplicationWindow* self,
                                                       GtkButton* source);
static void _peek_ui_application_window_on_gif_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                           gpointer self);
static void peek_ui_application_window_on_apng_button_clicked (PeekUiApplicationWindow* self,
                                                        GtkButton* source);
static void _peek_ui_application_window_on_apng_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                            gpointer self);
static void peek_ui_application_window_on_webm_button_clicked (PeekUiApplicationWindow* self,
                                                        GtkButton* source);
static void _peek_ui_application_window_on_webm_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                            gpointer self);
static void peek_ui_application_window_on_mp4_button_clicked (PeekUiApplicationWindow* self,
                                                       GtkButton* source);
static void _peek_ui_application_window_on_mp4_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                           gpointer self);
static void peek_ui_application_window_on_record_button_clicked (PeekUiApplicationWindow* self,
                                                          GtkButton* source);
static void _peek_ui_application_window_on_record_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                              gpointer self);
static void peek_ui_application_window_on_stop_button_clicked (PeekUiApplicationWindow* self,
                                                        GtkButton* source);
static void _peek_ui_application_window_on_stop_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                            gpointer self);
static void peek_ui_application_window_on_new_window_button_clicked (PeekUiApplicationWindow* self,
                                                              GtkButton* source);
static void _peek_ui_application_window_on_new_window_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                  gpointer self);
static void peek_ui_application_window_on_preferences_button_clicked (PeekUiApplicationWindow* self,
                                                               GtkButton* source);
GtkWindow* peek_ui_preferences_dialog_present_single_instance (GtkWindow* main_window);
static void _peek_ui_application_window_on_preferences_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                   gpointer self);
static void peek_ui_application_window_on_about_button_clicked (PeekUiApplicationWindow* self,
                                                         GtkButton* source);
GtkDialog* peek_ui_about_dialog_present_single_instance (GtkWindow* main_window);
static void _peek_ui_application_window_on_about_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                             gpointer self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
gint peek_ui_application_window_get_recording_start_delay (PeekUiApplicationWindow* self);
static gboolean ___lambda11_ (Block4Data* _data4_);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void ___lambda12_ (Block5Data* _data5_);
static void peek_ui_application_window_start_recording (PeekUiApplicationWindow* self);
static void ____lambda12__gtk_widget_hide (GtkWidget* _sender,
                                    gpointer self);
static gboolean ____lambda11__gsource_func (gpointer self);
static void peek_ui_application_window_show_spinner (PeekUiApplicationWindow* self);
static gint peek_ui_application_window_get_window_width (PeekUiApplicationWindow* self);
static void peek_ui_application_window_hide_spinner (PeekUiApplicationWindow* self);
static gboolean __lambda13_ (PeekUiApplicationWindow* self);
static gboolean ___lambda13__gsource_func (gpointer self);
static void peek_ui_application_window_freeze_window_size (PeekUiApplicationWindow* self);
static void peek_ui_application_window_unfreeze_window_size (PeekUiApplicationWindow* self);
static void ___lambda8_ (PeekUiApplicationWindow* self,
                  GObject* obj,
                  GAsyncResult* res);
static void ____lambda8__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
const gchar* peek_ui_application_window_get_default_file_name_format (PeekUiApplicationWindow* self);
static gchar* peek_ui_application_window_load_preferred_save_folder (PeekUiApplicationWindow* self);
static void peek_ui_application_window_save_file (PeekUiApplicationWindow* self);
static void __lambda6_ (PeekUiApplicationWindow* self,
                 GObject* obj,
                 GAsyncResult* res);
static void peek_ui_application_window_handle_saved_file (PeekUiApplicationWindow* self,
                                                   GFile* file);
static void ___lambda6__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self);
static void peek_ui_application_window_save_preferred_save_folder (PeekUiApplicationWindow* self,
                                                            GFile* out_file);
gboolean peek_ui_application_window_get_open_file_manager (PeekUiApplicationWindow* self);
static void peek_ui_application_window_show_file_saved_notification (PeekUiApplicationWindow* self,
                                                              GFile* file);
gboolean peek_ui_application_window_get_show_notification (PeekUiApplicationWindow* self);
#define PEEK_APP_ID "com.uploadedlobster.peek"
const gchar* peek_ui_application_window_get_save_folder (PeekUiApplicationWindow* self);
void peek_ui_application_window_set_save_folder (PeekUiApplicationWindow* self,
                                                 const gchar* value);
static void peek_ui_application_window_move_close_button_left (PeekUiApplicationWindow* self);
void peek_ui_application_window_set_open_file_manager (PeekUiApplicationWindow* self,
                                                       gboolean value);
void peek_ui_application_window_set_show_notification (PeekUiApplicationWindow* self,
                                                       gboolean value);
void peek_ui_application_window_set_size_indicator_delay (PeekUiApplicationWindow* self,
                                                          gint value);
void peek_ui_application_window_set_recording_start_delay (PeekUiApplicationWindow* self,
                                                           gint value);
void peek_ui_application_window_set_default_file_name_format (PeekUiApplicationWindow* self,
                                                              const gchar* value);
static void peek_ui_application_window_finalize (GObject * obj);
static void _vala_peek_ui_application_window_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_peek_ui_application_window_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static inline gpointer
peek_ui_application_window_get_instance_private (PeekUiApplicationWindow* self)
{
	return G_STRUCT_MEMBER_P (self, PeekUiApplicationWindow_private_offset);
}


static void
__lambda4_ (PeekUiApplicationWindow* self)
{
#line 89 "../src/ui/application-window.vala"
	peek_ui_application_window_enter_recording_state (self);
#line 353 "application-window.c"
}


static void
___lambda4__peek_recording_screen_recorder_recording_started (PeekRecordingScreenRecorder* _sender,
                                                              gpointer self)
{
#line 88 "../src/ui/application-window.vala"
	__lambda4_ ((PeekUiApplicationWindow*) self);
#line 363 "application-window.c"
}


static void
__lambda5_ (PeekUiApplicationWindow* self)
{
#line 93 "../src/ui/application-window.vala"
	self->priv->is_postprocessing = TRUE;
#line 94 "../src/ui/application-window.vala"
	peek_ui_application_window_show_file_chooser (self);
#line 374 "application-window.c"
}


static void
___lambda5__peek_recording_screen_recorder_recording_postprocess_started (PeekRecordingScreenRecorder* _sender,
                                                                          gpointer self)
{
#line 92 "../src/ui/application-window.vala"
	__lambda5_ ((PeekUiApplicationWindow*) self);
#line 384 "application-window.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 98 "../src/ui/application-window.vala"
	return self ? g_object_ref (self) : NULL;
#line 393 "application-window.c"
}


static void
__lambda9_ (PeekUiApplicationWindow* self,
            GFile* file)
{
	GFile* _tmp0_;
#line 97 "../src/ui/application-window.vala"
	g_return_if_fail (file != NULL);
#line 98 "../src/ui/application-window.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 98 "../src/ui/application-window.vala"
	_g_object_unref0 (self->priv->in_file);
#line 98 "../src/ui/application-window.vala"
	self->priv->in_file = _tmp0_;
#line 99 "../src/ui/application-window.vala"
	peek_ui_application_window_try_save_file (self);
#line 412 "application-window.c"
}


static void
___lambda9__peek_recording_screen_recorder_recording_finished (PeekRecordingScreenRecorder* _sender,
                                                               GFile* file,
                                                               gpointer self)
{
#line 97 "../src/ui/application-window.vala"
	__lambda9_ ((PeekUiApplicationWindow*) self, file);
#line 423 "application-window.c"
}


static void
__lambda10_ (PeekUiApplicationWindow* self,
             GError* reason)
{
#line 103 "../src/ui/application-window.vala"
	if (reason != NULL) {
#line 433 "application-window.c"
		FILE* _tmp0_;
		const gchar* _tmp1_;
		GtkDialog* _tmp2_;
		GtkDialog* _tmp3_;
#line 104 "../src/ui/application-window.vala"
		_tmp0_ = stderr;
#line 104 "../src/ui/application-window.vala"
		_tmp1_ = reason->message;
#line 104 "../src/ui/application-window.vala"
		fprintf (_tmp0_, "Recording canceled: %s\n", _tmp1_);
#line 105 "../src/ui/application-window.vala"
		_tmp2_ = peek_ui_error_dialog_present_single_instance ((GtkWindow*) self, _ ("An unexpected error occurred during recording. Recording was aborted."), reason);
#line 105 "../src/ui/application-window.vala"
		_tmp3_ = _tmp2_;
#line 105 "../src/ui/application-window.vala"
		_g_object_unref0 (_tmp3_);
#line 450 "application-window.c"
	} else {
		FILE* _tmp4_;
#line 110 "../src/ui/application-window.vala"
		_tmp4_ = stderr;
#line 110 "../src/ui/application-window.vala"
		fprintf (_tmp4_, "Recording canceled\n");
#line 457 "application-window.c"
	}
#line 113 "../src/ui/application-window.vala"
	_g_object_unref0 (self->priv->in_file);
#line 113 "../src/ui/application-window.vala"
	self->priv->in_file = NULL;
#line 114 "../src/ui/application-window.vala"
	peek_ui_application_window_leave_recording_state (self);
#line 465 "application-window.c"
}


static void
___lambda10__peek_recording_screen_recorder_recording_aborted (PeekRecordingScreenRecorder* _sender,
                                                               GError* reason,
                                                               gpointer self)
{
#line 102 "../src/ui/application-window.vala"
	__lambda10_ ((PeekUiApplicationWindow*) self, reason);
#line 476 "application-window.c"
}


static void
_peek_ui_application_window_toggle_recording_peek_application_toggle_recording (PeekApplication* _sender,
                                                                                gpointer self)
{
#line 117 "../src/ui/application-window.vala"
	peek_ui_application_window_toggle_recording ((PeekUiApplicationWindow*) self);
#line 486 "application-window.c"
}


static void
_peek_ui_application_window_prepare_start_recording_peek_application_start_recording (PeekApplication* _sender,
                                                                                      gpointer self)
{
#line 119 "../src/ui/application-window.vala"
	peek_ui_application_window_prepare_start_recording ((PeekUiApplicationWindow*) self);
#line 496 "application-window.c"
}


static void
_peek_ui_application_window_prepare_stop_recording_peek_application_stop_recording (PeekApplication* _sender,
                                                                                    gpointer self)
{
#line 121 "../src/ui/application-window.vala"
	peek_ui_application_window_prepare_stop_recording ((PeekUiApplicationWindow*) self);
#line 506 "application-window.c"
}


static void
__lambda15_ (PeekUiApplicationWindow* self,
             GParamSpec* pspec)
{
#line 124 "../src/ui/application-window.vala"
	g_return_if_fail (pspec != NULL);
#line 125 "../src/ui/application-window.vala"
	peek_ui_application_window_update_format_label (self);
#line 518 "application-window.c"
}


static void
___lambda15__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 124 "../src/ui/application-window.vala"
	__lambda15_ ((PeekUiApplicationWindow*) self, pspec);
#line 529 "application-window.c"
}


static void
__lambda16_ (PeekUiApplicationWindow* self)
{
#line 189 "../src/ui/application-window.vala"
	peek_ui_application_window_show_size_indicator (self);
#line 538 "application-window.c"
}


static void
___lambda16__gtk_widget_show (GtkWidget* _sender,
                              gpointer self)
{
#line 188 "../src/ui/application-window.vala"
	__lambda16_ ((PeekUiApplicationWindow*) self);
#line 548 "application-window.c"
}


PeekUiApplicationWindow*
peek_ui_application_window_construct (GType object_type,
                                      PeekApplication* application,
                                      PeekRecordingScreenRecorder* recorder)
{
	PeekUiApplicationWindow * self = NULL;
	PeekRecordingScreenRecorder* _tmp0_;
	PeekRecordingScreenRecorder* _tmp1_;
	PeekRecordingScreenRecorder* _tmp2_;
	PeekRecordingScreenRecorder* _tmp3_;
	PeekRecordingScreenRecorder* _tmp4_;
	PeekRecordingRecordingConfig* _tmp5_;
	PeekRecordingRecordingConfig* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	GSettings* _tmp9_;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	GSettings* _tmp12_;
	GtkSettings* _tmp13_;
	GSettings* _tmp14_;
	PeekRecordingScreenRecorder* _tmp15_;
	PeekRecordingRecordingConfig* _tmp16_;
	PeekRecordingRecordingConfig* _tmp17_;
	GSettings* _tmp18_;
	PeekRecordingScreenRecorder* _tmp19_;
	PeekRecordingRecordingConfig* _tmp20_;
	PeekRecordingRecordingConfig* _tmp21_;
	GSettings* _tmp22_;
	PeekRecordingScreenRecorder* _tmp23_;
	PeekRecordingRecordingConfig* _tmp24_;
	PeekRecordingRecordingConfig* _tmp25_;
	GSettings* _tmp26_;
	PeekRecordingScreenRecorder* _tmp27_;
	PeekRecordingRecordingConfig* _tmp28_;
	PeekRecordingRecordingConfig* _tmp29_;
	GSettings* _tmp30_;
	PeekRecordingScreenRecorder* _tmp31_;
	PeekRecordingRecordingConfig* _tmp32_;
	PeekRecordingRecordingConfig* _tmp33_;
	GSettings* _tmp34_;
	PeekRecordingScreenRecorder* _tmp35_;
	PeekRecordingRecordingConfig* _tmp36_;
	PeekRecordingRecordingConfig* _tmp37_;
	GSettings* _tmp38_;
	GSettings* _tmp39_;
	GtkButton* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	gchar* _tmp43_;
#line 82 "../src/ui/application-window.vala"
	g_return_val_if_fail (application != NULL, NULL);
#line 82 "../src/ui/application-window.vala"
	g_return_val_if_fail (recorder != NULL, NULL);
#line 84 "../src/ui/application-window.vala"
	self = (PeekUiApplicationWindow*) g_object_new (object_type, "application", application, NULL);
#line 87 "../src/ui/application-window.vala"
	peek_ui_application_window_set_recorder (self, recorder);
#line 88 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->_recorder;
#line 88 "../src/ui/application-window.vala"
	g_signal_connect_object (_tmp0_, "recording-started", (GCallback) ___lambda4__peek_recording_screen_recorder_recording_started, self, 0);
#line 92 "../src/ui/application-window.vala"
	_tmp1_ = self->priv->_recorder;
#line 92 "../src/ui/application-window.vala"
	g_signal_connect_object (_tmp1_, "recording-postprocess-started", (GCallback) ___lambda5__peek_recording_screen_recorder_recording_postprocess_started, self, 0);
#line 97 "../src/ui/application-window.vala"
	_tmp2_ = self->priv->_recorder;
#line 97 "../src/ui/application-window.vala"
	g_signal_connect_object (_tmp2_, "recording-finished", (GCallback) ___lambda9__peek_recording_screen_recorder_recording_finished, self, 0);
#line 102 "../src/ui/application-window.vala"
	_tmp3_ = self->priv->_recorder;
#line 102 "../src/ui/application-window.vala"
	g_signal_connect_object (_tmp3_, "recording-aborted", (GCallback) ___lambda10__peek_recording_screen_recorder_recording_aborted, self, 0);
#line 117 "../src/ui/application-window.vala"
	g_signal_connect_object (application, "toggle-recording", (GCallback) _peek_ui_application_window_toggle_recording_peek_application_toggle_recording, self, 0);
#line 119 "../src/ui/application-window.vala"
	g_signal_connect_object (application, "start-recording", (GCallback) _peek_ui_application_window_prepare_start_recording_peek_application_start_recording, self, 0);
#line 121 "../src/ui/application-window.vala"
	g_signal_connect_object (application, "stop-recording", (GCallback) _peek_ui_application_window_prepare_stop_recording_peek_application_stop_recording, self, 0);
#line 124 "../src/ui/application-window.vala"
	_tmp4_ = self->priv->_recorder;
#line 124 "../src/ui/application-window.vala"
	_tmp5_ = peek_recording_screen_recorder_get_config (_tmp4_);
#line 124 "../src/ui/application-window.vala"
	_tmp6_ = _tmp5_;
#line 124 "../src/ui/application-window.vala"
	g_signal_connect_object ((GObject*) _tmp6_, "notify::output-format", (GCallback) ___lambda15__g_object_notify, self, 0);
#line 129 "../src/ui/application-window.vala"
	_tmp7_ = peek_application_get_app_settings ();
#line 129 "../src/ui/application-window.vala"
	_g_object_unref0 (self->priv->settings);
#line 129 "../src/ui/application-window.vala"
	self->priv->settings = _tmp7_;
#line 131 "../src/ui/application-window.vala"
	_tmp8_ = self->priv->settings;
#line 131 "../src/ui/application-window.vala"
	g_settings_bind (_tmp8_, "interface-open-file-manager", (GObject*) self, "open_file_manager", G_SETTINGS_BIND_DEFAULT);
#line 135 "../src/ui/application-window.vala"
	_tmp9_ = self->priv->settings;
#line 135 "../src/ui/application-window.vala"
	g_settings_bind (_tmp9_, "interface-show-notification", (GObject*) self, "show_notification", G_SETTINGS_BIND_DEFAULT);
#line 139 "../src/ui/application-window.vala"
	_tmp10_ = self->priv->settings;
#line 139 "../src/ui/application-window.vala"
	g_settings_bind (_tmp10_, "interface-size-indicator-delay", (GObject*) self, "size_indicator_delay", G_SETTINGS_BIND_DEFAULT);
#line 143 "../src/ui/application-window.vala"
	_tmp11_ = self->priv->settings;
#line 143 "../src/ui/application-window.vala"
	g_settings_bind (_tmp11_, "interface-default-file-name-format", (GObject*) self, "default_file_name_format", G_SETTINGS_BIND_DEFAULT);
#line 147 "../src/ui/application-window.vala"
	_tmp12_ = self->priv->settings;
#line 147 "../src/ui/application-window.vala"
	_tmp13_ = gtk_widget_get_settings ((GtkWidget*) self);
#line 147 "../src/ui/application-window.vala"
	g_settings_bind (_tmp12_, "interface-prefer-dark-theme", (GObject*) _tmp13_, "gtk_application_prefer_dark_theme", G_SETTINGS_BIND_DEFAULT);
#line 151 "../src/ui/application-window.vala"
	_tmp14_ = self->priv->settings;
#line 151 "../src/ui/application-window.vala"
	_tmp15_ = self->priv->_recorder;
#line 151 "../src/ui/application-window.vala"
	_tmp16_ = peek_recording_screen_recorder_get_config (_tmp15_);
#line 151 "../src/ui/application-window.vala"
	_tmp17_ = _tmp16_;
#line 151 "../src/ui/application-window.vala"
	g_settings_bind (_tmp14_, "recording-output-format", (GObject*) _tmp17_, "output_format", G_SETTINGS_BIND_DEFAULT);
#line 155 "../src/ui/application-window.vala"
	_tmp18_ = self->priv->settings;
#line 155 "../src/ui/application-window.vala"
	_tmp19_ = self->priv->_recorder;
#line 155 "../src/ui/application-window.vala"
	_tmp20_ = peek_recording_screen_recorder_get_config (_tmp19_);
#line 155 "../src/ui/application-window.vala"
	_tmp21_ = _tmp20_;
#line 155 "../src/ui/application-window.vala"
	g_settings_bind (_tmp18_, "recording-gifski-enabled", (GObject*) _tmp21_, "gifski_enabled", G_SETTINGS_BIND_DEFAULT);
#line 159 "../src/ui/application-window.vala"
	_tmp22_ = self->priv->settings;
#line 159 "../src/ui/application-window.vala"
	_tmp23_ = self->priv->_recorder;
#line 159 "../src/ui/application-window.vala"
	_tmp24_ = peek_recording_screen_recorder_get_config (_tmp23_);
#line 159 "../src/ui/application-window.vala"
	_tmp25_ = _tmp24_;
#line 159 "../src/ui/application-window.vala"
	g_settings_bind (_tmp22_, "recording-gifski-quality", (GObject*) _tmp25_, "gifski_quality", G_SETTINGS_BIND_DEFAULT);
#line 163 "../src/ui/application-window.vala"
	_tmp26_ = self->priv->settings;
#line 163 "../src/ui/application-window.vala"
	_tmp27_ = self->priv->_recorder;
#line 163 "../src/ui/application-window.vala"
	_tmp28_ = peek_recording_screen_recorder_get_config (_tmp27_);
#line 163 "../src/ui/application-window.vala"
	_tmp29_ = _tmp28_;
#line 163 "../src/ui/application-window.vala"
	g_settings_bind (_tmp26_, "recording-framerate", (GObject*) _tmp29_, "framerate", G_SETTINGS_BIND_DEFAULT);
#line 167 "../src/ui/application-window.vala"
	_tmp30_ = self->priv->settings;
#line 167 "../src/ui/application-window.vala"
	_tmp31_ = self->priv->_recorder;
#line 167 "../src/ui/application-window.vala"
	_tmp32_ = peek_recording_screen_recorder_get_config (_tmp31_);
#line 167 "../src/ui/application-window.vala"
	_tmp33_ = _tmp32_;
#line 167 "../src/ui/application-window.vala"
	g_settings_bind (_tmp30_, "recording-downsample", (GObject*) _tmp33_, "downsample", G_SETTINGS_BIND_DEFAULT);
#line 171 "../src/ui/application-window.vala"
	_tmp34_ = self->priv->settings;
#line 171 "../src/ui/application-window.vala"
	_tmp35_ = self->priv->_recorder;
#line 171 "../src/ui/application-window.vala"
	_tmp36_ = peek_recording_screen_recorder_get_config (_tmp35_);
#line 171 "../src/ui/application-window.vala"
	_tmp37_ = _tmp36_;
#line 171 "../src/ui/application-window.vala"
	g_settings_bind (_tmp34_, "recording-capture-mouse", (GObject*) _tmp37_, "capture_mouse", G_SETTINGS_BIND_DEFAULT);
#line 175 "../src/ui/application-window.vala"
	_tmp38_ = self->priv->settings;
#line 175 "../src/ui/application-window.vala"
	g_settings_bind (_tmp38_, "recording-start-delay", (GObject*) self, "recording_start_delay", G_SETTINGS_BIND_DEFAULT);
#line 179 "../src/ui/application-window.vala"
	_tmp39_ = self->priv->settings;
#line 179 "../src/ui/application-window.vala"
	g_settings_bind (_tmp39_, "persist-save-folder", (GObject*) self, "save_folder", G_SETTINGS_BIND_DEFAULT);
#line 184 "../src/ui/application-window.vala"
	gtk_window_set_keep_above ((GtkWindow*) self, TRUE);
#line 185 "../src/ui/application-window.vala"
	peek_ui_application_window_load_geometry (self);
#line 186 "../src/ui/application-window.vala"
	peek_ui_application_window_on_window_screen_changed (self, NULL);
#line 188 "../src/ui/application-window.vala"
	g_signal_connect_object ((GtkWidget*) self, "show", (GCallback) ___lambda16__gtk_widget_show, self, 0);
#line 192 "../src/ui/application-window.vala"
	_tmp40_ = self->priv->stop_button;
#line 192 "../src/ui/application-window.vala"
	_tmp41_ = gtk_button_get_label (_tmp40_);
#line 192 "../src/ui/application-window.vala"
	_tmp42_ = _tmp41_;
#line 192 "../src/ui/application-window.vala"
	_tmp43_ = g_strdup (_tmp42_);
#line 192 "../src/ui/application-window.vala"
	_g_free0 (self->priv->stop_button_label);
#line 192 "../src/ui/application-window.vala"
	self->priv->stop_button_label = _tmp43_;
#line 196 "../src/ui/application-window.vala"
	peek_ui_application_window_set_close_button_position (self);
#line 82 "../src/ui/application-window.vala"
	return self;
#line 760 "application-window.c"
}


PeekUiApplicationWindow*
peek_ui_application_window_new (PeekApplication* application,
                                PeekRecordingScreenRecorder* recorder)
{
#line 82 "../src/ui/application-window.vala"
	return peek_ui_application_window_construct (PEEK_UI_TYPE_APPLICATION_WINDOW, application, recorder);
#line 770 "application-window.c"
}


void
peek_ui_application_window_hide_headerbar (PeekUiApplicationWindow* self)
{
	GtkStyleContext* _tmp0_;
	GtkHeaderBar* _tmp1_;
#line 200 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 201 "../src/ui/application-window.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 201 "../src/ui/application-window.vala"
	gtk_style_context_add_class (_tmp0_, "headerbar-hidden");
#line 202 "../src/ui/application-window.vala"
	_tmp1_ = self->priv->headerbar;
#line 202 "../src/ui/application-window.vala"
	gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 789 "application-window.c"
}


static gboolean
peek_ui_application_window_real_configure_event (GtkWidget* base,
                                                 GdkEventConfigure* event)
{
	PeekUiApplicationWindow * self;
	gboolean result = FALSE;
	PeekRecordingScreenRecorder* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 205 "../src/ui/application-window.vala"
	self = (PeekUiApplicationWindow*) base;
#line 205 "../src/ui/application-window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 206 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->_recorder;
#line 206 "../src/ui/application-window.vala"
	_tmp1_ = peek_recording_screen_recorder_get_is_recording (_tmp0_);
#line 206 "../src/ui/application-window.vala"
	_tmp2_ = _tmp1_;
#line 206 "../src/ui/application-window.vala"
	if (_tmp2_) {
#line 814 "application-window.c"
		PeekRecordingRecordingArea new_recording_area = {0};
		PeekRecordingRecordingArea _tmp3_ = {0};
		PeekRecordingRecordingArea _tmp4_;
#line 207 "../src/ui/application-window.vala"
		peek_ui_application_window_get_recording_area (self, &_tmp3_);
#line 207 "../src/ui/application-window.vala"
		new_recording_area = _tmp3_;
#line 208 "../src/ui/application-window.vala"
		_tmp4_ = self->priv->active_recording_area;
#line 208 "../src/ui/application-window.vala"
		if (!peek_recording_recording_area_equals (&new_recording_area, &_tmp4_)) {
#line 826 "application-window.c"
			PeekRecordingScreenRecorder* _tmp5_;
#line 209 "../src/ui/application-window.vala"
			_tmp5_ = self->priv->_recorder;
#line 209 "../src/ui/application-window.vala"
			peek_recording_screen_recorder_cancel (_tmp5_);
#line 832 "application-window.c"
		}
#line 206 "../src/ui/application-window.vala"
		peek_recording_recording_area_destroy (&new_recording_area);
#line 836 "application-window.c"
	}
#line 213 "../src/ui/application-window.vala"
	result = GTK_WIDGET_CLASS (peek_ui_application_window_parent_class)->configure_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_window_get_type (), GtkApplicationWindow), event);
#line 213 "../src/ui/application-window.vala"
	return result;
#line 842 "application-window.c"
}


static gchar*
bool_to_string (gboolean self)
{
	gchar* result = NULL;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 852 "application-window.c"
		gchar* _tmp0_;
#line 38 "glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		result = _tmp0_;
#line 38 "glib-2.0.vapi"
		return result;
#line 860 "application-window.c"
	} else {
		gchar* _tmp1_;
#line 40 "glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		result = _tmp1_;
#line 40 "glib-2.0.vapi"
		return result;
#line 869 "application-window.c"
	}
}


static void
___lambda18_ (PeekUiApplicationWindow* self,
              PeekUiApplicationWindow* file)
{
	GtkApplication* _tmp0_;
	GtkApplication* _tmp1_;
#line 225 "../src/ui/application-window.vala"
	g_return_if_fail (file != NULL);
#line 226 "../src/ui/application-window.vala"
	_tmp0_ = gtk_window_get_application ((GtkWindow*) self);
#line 226 "../src/ui/application-window.vala"
	_tmp1_ = _tmp0_;
#line 226 "../src/ui/application-window.vala"
	g_application_withdraw_notification ((GApplication*) _tmp1_, "background-rendering");
#line 227 "../src/ui/application-window.vala"
	gtk_window_close ((GtkWindow*) self);
#line 890 "application-window.c"
}


static void
____lambda18__peek_ui_application_window_recording_finished (PeekUiApplicationWindow* _sender,
                                                             gpointer self)
{
#line 225 "../src/ui/application-window.vala"
	___lambda18_ ((PeekUiApplicationWindow*) self, _sender);
#line 900 "application-window.c"
}


static gboolean
peek_ui_application_window_real_delete_event (GtkWidget* base,
                                              GdkEventAny* event)
{
	PeekUiApplicationWindow * self;
	gboolean result = FALSE;
	PeekRecordingScreenRecorder* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_ = FALSE;
	PeekRecordingScreenRecorder* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	guint _tmp22_;
	guint _tmp24_;
	guint _tmp26_;
	guint _tmp28_;
#line 216 "../src/ui/application-window.vala"
	self = (PeekUiApplicationWindow*) base;
#line 216 "../src/ui/application-window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 217 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->_recorder;
#line 217 "../src/ui/application-window.vala"
	_tmp1_ = peek_recording_screen_recorder_get_is_recording (_tmp0_);
#line 217 "../src/ui/application-window.vala"
	_tmp2_ = _tmp1_;
#line 217 "../src/ui/application-window.vala"
	_tmp3_ = bool_to_string (_tmp2_);
#line 217 "../src/ui/application-window.vala"
	_tmp4_ = _tmp3_;
#line 217 "../src/ui/application-window.vala"
	_tmp5_ = self->priv->is_postprocessing;
#line 217 "../src/ui/application-window.vala"
	_tmp6_ = bool_to_string (_tmp5_);
#line 217 "../src/ui/application-window.vala"
	_tmp7_ = _tmp6_;
#line 217 "../src/ui/application-window.vala"
	g_debug ("application-window.vala:217: delete_event: recorder.is_recording=%s, w" \
"indow.is_postprocessing=%s", _tmp4_, _tmp7_);
#line 217 "../src/ui/application-window.vala"
	_g_free0 (_tmp7_);
#line 217 "../src/ui/application-window.vala"
	_g_free0 (_tmp4_);
#line 222 "../src/ui/application-window.vala"
	_tmp9_ = self->priv->_recorder;
#line 222 "../src/ui/application-window.vala"
	_tmp10_ = peek_recording_screen_recorder_get_is_recording (_tmp9_);
#line 222 "../src/ui/application-window.vala"
	_tmp11_ = _tmp10_;
#line 222 "../src/ui/application-window.vala"
	if (_tmp11_) {
#line 222 "../src/ui/application-window.vala"
		_tmp8_ = TRUE;
#line 962 "application-window.c"
	} else {
		gboolean _tmp12_;
#line 222 "../src/ui/application-window.vala"
		_tmp12_ = self->priv->is_postprocessing;
#line 222 "../src/ui/application-window.vala"
		_tmp8_ = _tmp12_;
#line 969 "application-window.c"
	}
#line 222 "../src/ui/application-window.vala"
	if (_tmp8_) {
#line 973 "application-window.c"
		PeekRecordingScreenRecorder* _tmp13_;
		gboolean _tmp14_;
		gboolean _tmp15_;
#line 225 "../src/ui/application-window.vala"
		g_signal_connect_object (self, "recording-finished", (GCallback) ____lambda18__peek_ui_application_window_recording_finished, self, 0);
#line 230 "../src/ui/application-window.vala"
		_tmp13_ = self->priv->_recorder;
#line 230 "../src/ui/application-window.vala"
		_tmp14_ = peek_recording_screen_recorder_get_is_recording (_tmp13_);
#line 230 "../src/ui/application-window.vala"
		_tmp15_ = _tmp14_;
#line 230 "../src/ui/application-window.vala"
		if (_tmp15_) {
#line 987 "application-window.c"
			PeekRecordingScreenRecorder* _tmp16_;
#line 231 "../src/ui/application-window.vala"
			_tmp16_ = self->priv->_recorder;
#line 231 "../src/ui/application-window.vala"
			peek_recording_screen_recorder_cancel (_tmp16_);
#line 993 "application-window.c"
		} else {
			GNotification* notification = NULL;
			GNotification* _tmp17_;
			GNotification* _tmp18_;
			GtkApplication* _tmp19_;
			GtkApplication* _tmp20_;
			GNotification* _tmp21_;
#line 233 "../src/ui/application-window.vala"
			_tmp17_ = peek_ui_application_window_build_standard_notification (_ ("Rendering animation…"));
#line 233 "../src/ui/application-window.vala"
			notification = _tmp17_;
#line 234 "../src/ui/application-window.vala"
			_tmp18_ = notification;
#line 234 "../src/ui/application-window.vala"
			g_notification_set_body (_tmp18_, _ ("Peek will close when rendering is finished."));
#line 235 "../src/ui/application-window.vala"
			_tmp19_ = gtk_window_get_application ((GtkWindow*) self);
#line 235 "../src/ui/application-window.vala"
			_tmp20_ = _tmp19_;
#line 235 "../src/ui/application-window.vala"
			_tmp21_ = notification;
#line 235 "../src/ui/application-window.vala"
			g_application_send_notification ((GApplication*) _tmp20_, "background-rendering", _tmp21_);
#line 230 "../src/ui/application-window.vala"
			_g_object_unref0 (notification);
#line 1019 "application-window.c"
		}
#line 238 "../src/ui/application-window.vala"
		gtk_widget_hide ((GtkWidget*) self);
#line 239 "../src/ui/application-window.vala"
		result = TRUE;
#line 239 "../src/ui/application-window.vala"
		return result;
#line 1027 "application-window.c"
	}
#line 242 "../src/ui/application-window.vala"
	_tmp22_ = self->priv->start_recording_event_source;
#line 242 "../src/ui/application-window.vala"
	if (_tmp22_ != ((guint) 0)) {
#line 1033 "application-window.c"
		guint _tmp23_;
#line 243 "../src/ui/application-window.vala"
		_tmp23_ = self->priv->start_recording_event_source;
#line 243 "../src/ui/application-window.vala"
		g_source_remove (_tmp23_);
#line 244 "../src/ui/application-window.vala"
		self->priv->start_recording_event_source = (guint) 0;
#line 1041 "application-window.c"
	}
#line 247 "../src/ui/application-window.vala"
	_tmp24_ = self->priv->size_indicator_timeout;
#line 247 "../src/ui/application-window.vala"
	if (_tmp24_ != ((guint) 0)) {
#line 1047 "application-window.c"
		guint _tmp25_;
#line 248 "../src/ui/application-window.vala"
		_tmp25_ = self->priv->size_indicator_timeout;
#line 248 "../src/ui/application-window.vala"
		g_source_remove (_tmp25_);
#line 249 "../src/ui/application-window.vala"
		self->priv->size_indicator_timeout = (guint) 0;
#line 1055 "application-window.c"
	}
#line 252 "../src/ui/application-window.vala"
	_tmp26_ = self->priv->delay_indicator_timeout;
#line 252 "../src/ui/application-window.vala"
	if (_tmp26_ != ((guint) 0)) {
#line 1061 "application-window.c"
		guint _tmp27_;
#line 253 "../src/ui/application-window.vala"
		_tmp27_ = self->priv->delay_indicator_timeout;
#line 253 "../src/ui/application-window.vala"
		g_source_remove (_tmp27_);
#line 254 "../src/ui/application-window.vala"
		self->priv->delay_indicator_timeout = (guint) 0;
#line 1069 "application-window.c"
	}
#line 257 "../src/ui/application-window.vala"
	_tmp28_ = self->priv->time_indicator_timeout;
#line 257 "../src/ui/application-window.vala"
	if (_tmp28_ != ((guint) 0)) {
#line 1075 "application-window.c"
		guint _tmp29_;
#line 258 "../src/ui/application-window.vala"
		_tmp29_ = self->priv->time_indicator_timeout;
#line 258 "../src/ui/application-window.vala"
		g_source_remove (_tmp29_);
#line 259 "../src/ui/application-window.vala"
		self->priv->time_indicator_timeout = (guint) 0;
#line 1083 "application-window.c"
	}
#line 262 "../src/ui/application-window.vala"
	peek_ui_application_window_save_geometry (self);
#line 264 "../src/ui/application-window.vala"
	result = FALSE;
#line 264 "../src/ui/application-window.vala"
	return result;
#line 1091 "application-window.c"
}


static gchar*
peek_ui_application_window_get_format_name (PeekUiApplicationWindow* self,
                                            PeekOutputFormat format)
{
	gchar* result = NULL;
#line 268 "../src/ui/application-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 269 "../src/ui/application-window.vala"
	switch (format) {
#line 269 "../src/ui/application-window.vala"
		case PEEK_OUTPUT_FORMAT_APNG:
#line 1106 "application-window.c"
		{
			gchar* _tmp0_;
#line 270 "../src/ui/application-window.vala"
			_tmp0_ = g_strdup (_ ("APNG"));
#line 270 "../src/ui/application-window.vala"
			result = _tmp0_;
#line 270 "../src/ui/application-window.vala"
			return result;
#line 1115 "application-window.c"
		}
#line 269 "../src/ui/application-window.vala"
		case PEEK_OUTPUT_FORMAT_GIF:
#line 1119 "application-window.c"
		{
			gchar* _tmp1_;
#line 271 "../src/ui/application-window.vala"
			_tmp1_ = g_strdup (_ ("GIF"));
#line 271 "../src/ui/application-window.vala"
			result = _tmp1_;
#line 271 "../src/ui/application-window.vala"
			return result;
#line 1128 "application-window.c"
		}
#line 269 "../src/ui/application-window.vala"
		case PEEK_OUTPUT_FORMAT_MP4:
#line 1132 "application-window.c"
		{
			gchar* _tmp2_;
#line 272 "../src/ui/application-window.vala"
			_tmp2_ = g_strdup (_ ("MP4"));
#line 272 "../src/ui/application-window.vala"
			result = _tmp2_;
#line 272 "../src/ui/application-window.vala"
			return result;
#line 1141 "application-window.c"
		}
#line 269 "../src/ui/application-window.vala"
		case PEEK_OUTPUT_FORMAT_WEBM:
#line 1145 "application-window.c"
		{
			gchar* _tmp3_;
#line 273 "../src/ui/application-window.vala"
			_tmp3_ = g_strdup (_ ("WebM"));
#line 273 "../src/ui/application-window.vala"
			result = _tmp3_;
#line 273 "../src/ui/application-window.vala"
			return result;
#line 1154 "application-window.c"
		}
		default:
		{
			gchar* _tmp4_;
#line 274 "../src/ui/application-window.vala"
			_tmp4_ = g_strdup ("");
#line 274 "../src/ui/application-window.vala"
			result = _tmp4_;
#line 274 "../src/ui/application-window.vala"
			return result;
#line 1165 "application-window.c"
		}
	}
}


static void
peek_ui_application_window_select_format (PeekUiApplicationWindow* self,
                                          PeekOutputFormat format)
{
	PeekRecordingScreenRecorder* _tmp0_;
	PeekRecordingRecordingConfig* _tmp1_;
	PeekRecordingRecordingConfig* _tmp2_;
#line 278 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 279 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->_recorder;
#line 279 "../src/ui/application-window.vala"
	_tmp1_ = peek_recording_screen_recorder_get_config (_tmp0_);
#line 279 "../src/ui/application-window.vala"
	_tmp2_ = _tmp1_;
#line 279 "../src/ui/application-window.vala"
	peek_recording_recording_config_set_output_format (_tmp2_, format);
#line 280 "../src/ui/application-window.vala"
	peek_ui_application_window_update_format_label (self);
#line 1190 "application-window.c"
}


static void
peek_ui_application_window_update_format_label (PeekUiApplicationWindow* self)
{
	gchar* format_name = NULL;
	PeekRecordingScreenRecorder* _tmp0_;
	PeekRecordingRecordingConfig* _tmp1_;
	PeekRecordingRecordingConfig* _tmp2_;
	PeekOutputFormat _tmp3_;
	PeekOutputFormat _tmp4_;
	gchar* _tmp5_;
	GtkButton* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GtkPopover* _tmp9_;
#line 283 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 284 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->_recorder;
#line 284 "../src/ui/application-window.vala"
	_tmp1_ = peek_recording_screen_recorder_get_config (_tmp0_);
#line 284 "../src/ui/application-window.vala"
	_tmp2_ = _tmp1_;
#line 284 "../src/ui/application-window.vala"
	_tmp3_ = peek_recording_recording_config_get_output_format (_tmp2_);
#line 284 "../src/ui/application-window.vala"
	_tmp4_ = _tmp3_;
#line 284 "../src/ui/application-window.vala"
	_tmp5_ = peek_ui_application_window_get_format_name (self, _tmp4_);
#line 284 "../src/ui/application-window.vala"
	format_name = _tmp5_;
#line 285 "../src/ui/application-window.vala"
	_tmp6_ = self->priv->record_button;
#line 285 "../src/ui/application-window.vala"
	_tmp7_ = g_strdup_printf (_ ("Record as %s"), format_name);
#line 285 "../src/ui/application-window.vala"
	_tmp8_ = _tmp7_;
#line 285 "../src/ui/application-window.vala"
	gtk_button_set_label (_tmp6_, _tmp8_);
#line 285 "../src/ui/application-window.vala"
	_g_free0 (_tmp8_);
#line 286 "../src/ui/application-window.vala"
	_tmp9_ = self->priv->pop_format;
#line 286 "../src/ui/application-window.vala"
	gtk_widget_hide ((GtkWidget*) _tmp9_);
#line 283 "../src/ui/application-window.vala"
	_g_free0 (format_name);
#line 1240 "application-window.c"
}


static gboolean
__lambda14_ (PeekUiApplicationWindow* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	GtkHeaderBar* _tmp10_;
#line 292 "../src/ui/application-window.vala"
	_tmp1_ = self->priv->is_recording;
#line 292 "../src/ui/application-window.vala"
	if (_tmp1_) {
#line 1255 "application-window.c"
		gboolean _tmp2_;
#line 292 "../src/ui/application-window.vala"
		_tmp2_ = self->priv->is_postprocessing;
#line 292 "../src/ui/application-window.vala"
		_tmp0_ = !_tmp2_;
#line 1261 "application-window.c"
	} else {
#line 292 "../src/ui/application-window.vala"
		_tmp0_ = FALSE;
#line 1265 "application-window.c"
	}
#line 292 "../src/ui/application-window.vala"
	if (_tmp0_) {
#line 1269 "application-window.c"
		gint64 seconds = 0LL;
		PeekRecordingScreenRecorder* _tmp3_;
		gint64 _tmp4_;
		gint64 _tmp5_;
		GtkHeaderBar* _tmp6_;
		gint64 _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 293 "../src/ui/application-window.vala"
		_tmp3_ = self->priv->_recorder;
#line 293 "../src/ui/application-window.vala"
		_tmp4_ = peek_recording_screen_recorder_get_elapsed_seconds (_tmp3_);
#line 293 "../src/ui/application-window.vala"
		_tmp5_ = _tmp4_;
#line 293 "../src/ui/application-window.vala"
		seconds = _tmp5_;
#line 294 "../src/ui/application-window.vala"
		_tmp6_ = self->priv->headerbar;
#line 294 "../src/ui/application-window.vala"
		_tmp7_ = seconds;
#line 294 "../src/ui/application-window.vala"
		_tmp8_ = peek_utils_format_time (_tmp7_);
#line 294 "../src/ui/application-window.vala"
		_tmp9_ = _tmp8_;
#line 294 "../src/ui/application-window.vala"
		gtk_header_bar_set_title (_tmp6_, _tmp9_);
#line 294 "../src/ui/application-window.vala"
		_g_free0 (_tmp9_);
#line 295 "../src/ui/application-window.vala"
		result = TRUE;
#line 295 "../src/ui/application-window.vala"
		return result;
#line 1302 "application-window.c"
	}
#line 298 "../src/ui/application-window.vala"
	self->priv->time_indicator_timeout = (guint) 0;
#line 299 "../src/ui/application-window.vala"
	_tmp10_ = self->priv->headerbar;
#line 299 "../src/ui/application-window.vala"
	gtk_header_bar_set_title (_tmp10_, "");
#line 300 "../src/ui/application-window.vala"
	result = FALSE;
#line 300 "../src/ui/application-window.vala"
	return result;
#line 1314 "application-window.c"
}


static gboolean
___lambda14__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda14_ ((PeekUiApplicationWindow*) self);
#line 291 "../src/ui/application-window.vala"
	return result;
#line 1325 "application-window.c"
}


static void
peek_ui_application_window_update_time (PeekUiApplicationWindow* self)
{
	GtkHeaderBar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 289 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 290 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->headerbar;
#line 290 "../src/ui/application-window.vala"
	_tmp1_ = peek_utils_format_time ((gint64) 0);
#line 290 "../src/ui/application-window.vala"
	_tmp2_ = _tmp1_;
#line 290 "../src/ui/application-window.vala"
	gtk_header_bar_set_title (_tmp0_, _tmp2_);
#line 290 "../src/ui/application-window.vala"
	_g_free0 (_tmp2_);
#line 291 "../src/ui/application-window.vala"
	self->priv->time_indicator_timeout = g_timeout_add_full (G_PRIORITY_LOW, (guint) 500, ___lambda14__gsource_func, g_object_ref (self), g_object_unref);
#line 1349 "application-window.c"
}


void
peek_ui_application_window_on_window_screen_changed (PeekUiApplicationWindow* self,
                                                     GdkScreen* previous_screen)
{
	GdkScreen* screen = NULL;
	GdkScreen* _tmp0_;
	GdkScreen* _tmp1_;
	GdkVisual* visual = NULL;
	GdkScreen* _tmp2_;
	GdkVisual* _tmp3_;
	GdkVisual* _tmp4_;
	GdkVisual* _tmp5_;
	GdkVisual* _tmp10_;
#line 305 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 306 "../src/ui/application-window.vala"
	_tmp0_ = gtk_window_get_screen ((GtkWindow*) self);
#line 306 "../src/ui/application-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 306 "../src/ui/application-window.vala"
	screen = _tmp1_;
#line 307 "../src/ui/application-window.vala"
	_tmp2_ = screen;
#line 307 "../src/ui/application-window.vala"
	_tmp3_ = gdk_screen_get_rgba_visual (_tmp2_);
#line 307 "../src/ui/application-window.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 307 "../src/ui/application-window.vala"
	visual = _tmp4_;
#line 309 "../src/ui/application-window.vala"
	_tmp5_ = visual;
#line 309 "../src/ui/application-window.vala"
	if (_tmp5_ == NULL) {
#line 1386 "application-window.c"
		FILE* _tmp6_;
		GdkScreen* _tmp7_;
		GdkVisual* _tmp8_;
		GdkVisual* _tmp9_;
#line 310 "../src/ui/application-window.vala"
		_tmp6_ = stderr;
#line 310 "../src/ui/application-window.vala"
		fprintf (_tmp6_, "Screen does not support alpha channels!");
#line 311 "../src/ui/application-window.vala"
		_tmp7_ = screen;
#line 311 "../src/ui/application-window.vala"
		_tmp8_ = gdk_screen_get_system_visual (_tmp7_);
#line 311 "../src/ui/application-window.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 311 "../src/ui/application-window.vala"
		_g_object_unref0 (visual);
#line 311 "../src/ui/application-window.vala"
		visual = _tmp9_;
#line 1405 "application-window.c"
	}
#line 314 "../src/ui/application-window.vala"
	_tmp10_ = visual;
#line 314 "../src/ui/application-window.vala"
	gtk_widget_set_visual ((GtkWidget*) self, _tmp10_);
#line 305 "../src/ui/application-window.vala"
	_g_object_unref0 (visual);
#line 305 "../src/ui/application-window.vala"
	_g_object_unref0 (screen);
#line 1415 "application-window.c"
}


static void
_peek_ui_application_window_on_window_screen_changed_gtk_widget_screen_changed (GtkWidget* _sender,
                                                                                GdkScreen* previous_screen,
                                                                                gpointer self)
{
#line 20 "../src/ui/application-window.vala"
	peek_ui_application_window_on_window_screen_changed ((PeekUiApplicationWindow*) self, previous_screen);
#line 1426 "application-window.c"
}


static gboolean
peek_ui_application_window_on_window_draw (PeekUiApplicationWindow* self,
                                           GtkWidget* widget,
                                           cairo_t* ctx)
{
	gboolean result = FALSE;
#line 318 "../src/ui/application-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 318 "../src/ui/application-window.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 318 "../src/ui/application-window.vala"
	g_return_val_if_fail (ctx != NULL, FALSE);
#line 319 "../src/ui/application-window.vala"
	peek_ui_application_window_update_input_shape (self);
#line 321 "../src/ui/application-window.vala"
	result = FALSE;
#line 321 "../src/ui/application-window.vala"
	return result;
#line 1448 "application-window.c"
}


static gboolean
_peek_ui_application_window_on_window_draw_gtk_widget_draw (GtkWidget* _sender,
                                                            cairo_t* cr,
                                                            gpointer self)
{
	gboolean result;
	result = peek_ui_application_window_on_window_draw ((PeekUiApplicationWindow*) self, _sender, cr);
#line 20 "../src/ui/application-window.vala"
	return result;
#line 1461 "application-window.c"
}


static gboolean
peek_ui_application_window_on_recording_view_draw (PeekUiApplicationWindow* self,
                                                   GtkWidget* widget,
                                                   cairo_t* ctx)
{
	gboolean result = FALSE;
#line 325 "../src/ui/application-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 325 "../src/ui/application-window.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 325 "../src/ui/application-window.vala"
	g_return_val_if_fail (ctx != NULL, FALSE);
#line 327 "../src/ui/application-window.vala"
	cairo_set_operator (ctx, CAIRO_OPERATOR_CLEAR);
#line 328 "../src/ui/application-window.vala"
	cairo_paint (ctx);
#line 330 "../src/ui/application-window.vala"
	result = FALSE;
#line 330 "../src/ui/application-window.vala"
	return result;
#line 1485 "application-window.c"
}


static gboolean
_peek_ui_application_window_on_recording_view_draw_gtk_widget_draw (GtkWidget* _sender,
                                                                    cairo_t* cr,
                                                                    gpointer self)
{
	gboolean result;
	result = peek_ui_application_window_on_recording_view_draw ((PeekUiApplicationWindow*) self, _sender, cr);
#line 20 "../src/ui/application-window.vala"
	return result;
#line 1498 "application-window.c"
}


static void
peek_ui_application_window_on_recording_view_size_allocate (PeekUiApplicationWindow* self,
                                                            GtkAllocation* allocation)
{
#line 334 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 334 "../src/ui/application-window.vala"
	g_return_if_fail (allocation != NULL);
#line 336 "../src/ui/application-window.vala"
	peek_ui_application_window_show_size_indicator (self);
#line 1512 "application-window.c"
}


static void
_peek_ui_application_window_on_recording_view_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender,
                                                                                      GtkAllocation* allocation,
                                                                                      gpointer self)
{
#line 20 "../src/ui/application-window.vala"
	peek_ui_application_window_on_recording_view_size_allocate ((PeekUiApplicationWindow*) self, allocation);
#line 1523 "application-window.c"
}


static gboolean
_____lambda17_ (PeekUiApplicationWindow* self)
{
	gboolean result = FALSE;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
#line 383 "../src/ui/application-window.vala"
	self->priv->size_indicator_timeout = (guint) 0;
#line 384 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->size_indicator;
#line 384 "../src/ui/application-window.vala"
	gtk_widget_set_opacity ((GtkWidget*) _tmp0_, 0.0);
#line 385 "../src/ui/application-window.vala"
	_tmp1_ = self->priv->shortcut_label;
#line 385 "../src/ui/application-window.vala"
	gtk_widget_set_opacity ((GtkWidget*) _tmp1_, 0.0);
#line 386 "../src/ui/application-window.vala"
	peek_ui_application_window_update_input_shape (self);
#line 387 "../src/ui/application-window.vala"
	result = FALSE;
#line 387 "../src/ui/application-window.vala"
	return result;
#line 1549 "application-window.c"
}


static gboolean
______lambda17__gsource_func (gpointer self)
{
	gboolean result;
	result = _____lambda17_ ((PeekUiApplicationWindow*) self);
#line 382 "../src/ui/application-window.vala"
	return result;
#line 1560 "application-window.c"
}


static void
peek_ui_application_window_show_size_indicator (PeekUiApplicationWindow* self)
{
#line 339 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 340 "../src/ui/application-window.vala"
	if (gtk_widget_get_realized ((GtkWidget*) self)) {
#line 1571 "application-window.c"
		PeekRecordingRecordingArea area = {0};
		PeekRecordingRecordingArea _tmp0_ = {0};
		PangoAttrList* attrs = NULL;
		PangoAttrList* _tmp1_;
		PeekRecordingRecordingArea _tmp2_;
		gint _tmp3_;
		GtkLabel* _tmp12_;
		PangoAttrList* _tmp13_;
		gboolean _tmp14_;
#line 341 "../src/ui/application-window.vala"
		peek_ui_application_window_update_input_shape (self);
#line 342 "../src/ui/application-window.vala"
		peek_ui_application_window_get_recording_area (self, &_tmp0_);
#line 342 "../src/ui/application-window.vala"
		area = _tmp0_;
#line 345 "../src/ui/application-window.vala"
		_tmp1_ = pango_attr_list_new ();
#line 345 "../src/ui/application-window.vala"
		attrs = _tmp1_;
#line 347 "../src/ui/application-window.vala"
		_tmp2_ = area;
#line 347 "../src/ui/application-window.vala"
		_tmp3_ = _tmp2_.width;
#line 347 "../src/ui/application-window.vala"
		if (_tmp3_ < PEEK_UI_APPLICATION_WINDOW_SMALL_WINDOW_SIZE) {
#line 1597 "application-window.c"
			GtkButton* _tmp4_;
			GtkButton* _tmp5_;
			PangoAttrList* _tmp6_;
			PangoAttribute* _tmp7_;
#line 348 "../src/ui/application-window.vala"
			_tmp4_ = self->priv->record_button;
#line 348 "../src/ui/application-window.vala"
			peek_gtk_helper_hide_button_label (_tmp4_);
#line 349 "../src/ui/application-window.vala"
			_tmp5_ = self->priv->stop_button;
#line 349 "../src/ui/application-window.vala"
			peek_gtk_helper_hide_button_label (_tmp5_);
#line 350 "../src/ui/application-window.vala"
			_tmp6_ = attrs;
#line 350 "../src/ui/application-window.vala"
			_tmp7_ = pango_attr_scale_new (PANGO_SCALE_SMALL);
#line 350 "../src/ui/application-window.vala"
			pango_attr_list_insert (_tmp6_, _tmp7_);
#line 1616 "application-window.c"
		} else {
			GtkButton* _tmp8_;
			GtkButton* _tmp9_;
			PangoAttrList* _tmp10_;
			PangoAttribute* _tmp11_;
#line 352 "../src/ui/application-window.vala"
			_tmp8_ = self->priv->record_button;
#line 352 "../src/ui/application-window.vala"
			peek_gtk_helper_show_button_label (_tmp8_);
#line 353 "../src/ui/application-window.vala"
			_tmp9_ = self->priv->stop_button;
#line 353 "../src/ui/application-window.vala"
			peek_gtk_helper_show_button_label (_tmp9_);
#line 354 "../src/ui/application-window.vala"
			_tmp10_ = attrs;
#line 354 "../src/ui/application-window.vala"
			_tmp11_ = pango_attr_scale_new (PANGO_SCALE_LARGE);
#line 354 "../src/ui/application-window.vala"
			pango_attr_list_insert (_tmp10_, _tmp11_);
#line 1636 "application-window.c"
		}
#line 357 "../src/ui/application-window.vala"
		_tmp12_ = self->priv->shortcut_label;
#line 357 "../src/ui/application-window.vala"
		_tmp13_ = attrs;
#line 357 "../src/ui/application-window.vala"
		gtk_label_set_attributes (_tmp12_, _tmp13_);
#line 359 "../src/ui/application-window.vala"
		_tmp14_ = self->priv->is_recording;
#line 359 "../src/ui/application-window.vala"
		if (!_tmp14_) {
#line 1648 "application-window.c"
			GSettings* shortcut = NULL;
			GSettings* _tmp15_;
			gchar* keys = NULL;
			GSettings* _tmp16_;
			gchar* _tmp17_;
			guint accelerator_key = 0U;
			GdkModifierType accelerator_mods = 0U;
			const gchar* _tmp18_;
			guint _tmp19_ = 0U;
			GdkModifierType _tmp20_ = 0U;
			gchar* shortcut_hint = NULL;
			guint _tmp21_;
			GdkModifierType _tmp22_;
			gchar* _tmp23_;
			GtkLabel* _tmp24_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			GtkLabel* _tmp28_;
			GString* size_label = NULL;
			GString* _tmp29_;
			GString* _tmp30_;
			PeekRecordingRecordingArea _tmp31_;
			gint _tmp32_;
			PeekRecordingRecordingArea _tmp33_;
			gint _tmp34_;
			GtkLabel* _tmp35_;
			GString* _tmp36_;
			const gchar* _tmp37_;
			GtkLabel* _tmp38_;
			guint _tmp39_;
			PeekRecordingScreenRecorder* _tmp41_;
			gboolean _tmp42_;
			gboolean _tmp43_;
#line 361 "../src/ui/application-window.vala"
			_tmp15_ = peek_application_get_app_settings ();
#line 361 "../src/ui/application-window.vala"
			shortcut = _tmp15_;
#line 362 "../src/ui/application-window.vala"
			_tmp16_ = shortcut;
#line 362 "../src/ui/application-window.vala"
			_tmp17_ = g_settings_get_string (_tmp16_, "keybinding-toggle-recording");
#line 362 "../src/ui/application-window.vala"
			keys = _tmp17_;
#line 365 "../src/ui/application-window.vala"
			_tmp18_ = keys;
#line 365 "../src/ui/application-window.vala"
			gtk_accelerator_parse (_tmp18_, &_tmp19_, &_tmp20_);
#line 365 "../src/ui/application-window.vala"
			accelerator_key = _tmp19_;
#line 365 "../src/ui/application-window.vala"
			accelerator_mods = _tmp20_;
#line 366 "../src/ui/application-window.vala"
			_tmp21_ = accelerator_key;
#line 366 "../src/ui/application-window.vala"
			_tmp22_ = accelerator_mods;
#line 366 "../src/ui/application-window.vala"
			_tmp23_ = gtk_accelerator_get_label (_tmp21_, _tmp22_);
#line 366 "../src/ui/application-window.vala"
			shortcut_hint = _tmp23_;
#line 367 "../src/ui/application-window.vala"
			_tmp24_ = self->priv->shortcut_label;
#line 367 "../src/ui/application-window.vala"
			_tmp25_ = shortcut_hint;
#line 367 "../src/ui/application-window.vala"
			_tmp26_ = g_strdup_printf (_ ("Start / Stop: %s"), _tmp25_);
#line 367 "../src/ui/application-window.vala"
			_tmp27_ = _tmp26_;
#line 367 "../src/ui/application-window.vala"
			gtk_label_set_text (_tmp24_, _tmp27_);
#line 367 "../src/ui/application-window.vala"
			_g_free0 (_tmp27_);
#line 368 "../src/ui/application-window.vala"
			_tmp28_ = self->priv->shortcut_label;
#line 368 "../src/ui/application-window.vala"
			gtk_widget_show ((GtkWidget*) _tmp28_);
#line 370 "../src/ui/application-window.vala"
			_tmp29_ = g_string_new ("");
#line 370 "../src/ui/application-window.vala"
			size_label = _tmp29_;
#line 371 "../src/ui/application-window.vala"
			_tmp30_ = size_label;
#line 371 "../src/ui/application-window.vala"
			_tmp31_ = area;
#line 371 "../src/ui/application-window.vala"
			_tmp32_ = _tmp31_.width;
#line 371 "../src/ui/application-window.vala"
			_tmp33_ = area;
#line 371 "../src/ui/application-window.vala"
			_tmp34_ = _tmp33_.height;
#line 371 "../src/ui/application-window.vala"
			g_string_printf (_tmp30_, "%i x %i", _tmp32_, _tmp34_);
#line 372 "../src/ui/application-window.vala"
			_tmp35_ = self->priv->size_indicator;
#line 372 "../src/ui/application-window.vala"
			_tmp36_ = size_label;
#line 372 "../src/ui/application-window.vala"
			_tmp37_ = _tmp36_->str;
#line 372 "../src/ui/application-window.vala"
			gtk_label_set_text (_tmp35_, _tmp37_);
#line 373 "../src/ui/application-window.vala"
			_tmp38_ = self->priv->size_indicator;
#line 373 "../src/ui/application-window.vala"
			gtk_widget_show ((GtkWidget*) _tmp38_);
#line 375 "../src/ui/application-window.vala"
			_tmp39_ = self->priv->size_indicator_timeout;
#line 375 "../src/ui/application-window.vala"
			if (_tmp39_ != ((guint) 0)) {
#line 1757 "application-window.c"
				guint _tmp40_;
#line 376 "../src/ui/application-window.vala"
				_tmp40_ = self->priv->size_indicator_timeout;
#line 376 "../src/ui/application-window.vala"
				g_source_remove (_tmp40_);
#line 1763 "application-window.c"
			}
#line 379 "../src/ui/application-window.vala"
			_tmp41_ = self->priv->_recorder;
#line 379 "../src/ui/application-window.vala"
			_tmp42_ = peek_recording_screen_recorder_get_is_recording (_tmp41_);
#line 379 "../src/ui/application-window.vala"
			_tmp43_ = _tmp42_;
#line 379 "../src/ui/application-window.vala"
			if (!_tmp43_) {
#line 1773 "application-window.c"
				GtkLabel* _tmp44_;
				GtkLabel* _tmp45_;
				gint _tmp46_;
#line 380 "../src/ui/application-window.vala"
				_tmp44_ = self->priv->shortcut_label;
#line 380 "../src/ui/application-window.vala"
				gtk_widget_set_opacity ((GtkWidget*) _tmp44_, 1.0);
#line 381 "../src/ui/application-window.vala"
				_tmp45_ = self->priv->size_indicator;
#line 381 "../src/ui/application-window.vala"
				gtk_widget_set_opacity ((GtkWidget*) _tmp45_, 1.0);
#line 382 "../src/ui/application-window.vala"
				_tmp46_ = self->priv->_size_indicator_delay;
#line 382 "../src/ui/application-window.vala"
				self->priv->size_indicator_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) _tmp46_, ______lambda17__gsource_func, g_object_ref (self), g_object_unref);
#line 1789 "application-window.c"
			}
#line 359 "../src/ui/application-window.vala"
			_g_string_free0 (size_label);
#line 359 "../src/ui/application-window.vala"
			_g_free0 (shortcut_hint);
#line 359 "../src/ui/application-window.vala"
			_g_free0 (keys);
#line 359 "../src/ui/application-window.vala"
			_g_object_unref0 (shortcut);
#line 1799 "application-window.c"
		}
#line 340 "../src/ui/application-window.vala"
		_pango_attr_list_unref0 (attrs);
#line 340 "../src/ui/application-window.vala"
		peek_recording_recording_area_destroy (&area);
#line 1805 "application-window.c"
	}
}


static void
peek_ui_application_window_on_gif_button_clicked (PeekUiApplicationWindow* self,
                                                  GtkButton* source)
{
#line 395 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 395 "../src/ui/application-window.vala"
	g_return_if_fail (source != NULL);
#line 396 "../src/ui/application-window.vala"
	peek_ui_application_window_select_format (self, PEEK_OUTPUT_FORMAT_GIF);
#line 1820 "application-window.c"
}


static void
_peek_ui_application_window_on_gif_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                      gpointer self)
{
#line 20 "../src/ui/application-window.vala"
	peek_ui_application_window_on_gif_button_clicked ((PeekUiApplicationWindow*) self, _sender);
#line 1830 "application-window.c"
}


static void
peek_ui_application_window_on_apng_button_clicked (PeekUiApplicationWindow* self,
                                                   GtkButton* source)
{
#line 400 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 400 "../src/ui/application-window.vala"
	g_return_if_fail (source != NULL);
#line 401 "../src/ui/application-window.vala"
	peek_ui_application_window_select_format (self, PEEK_OUTPUT_FORMAT_APNG);
#line 1844 "application-window.c"
}


static void
_peek_ui_application_window_on_apng_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self)
{
#line 20 "../src/ui/application-window.vala"
	peek_ui_application_window_on_apng_button_clicked ((PeekUiApplicationWindow*) self, _sender);
#line 1854 "application-window.c"
}


static void
peek_ui_application_window_on_webm_button_clicked (PeekUiApplicationWindow* self,
                                                   GtkButton* source)
{
#line 405 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 405 "../src/ui/application-window.vala"
	g_return_if_fail (source != NULL);
#line 406 "../src/ui/application-window.vala"
	peek_ui_application_window_select_format (self, PEEK_OUTPUT_FORMAT_WEBM);
#line 1868 "application-window.c"
}


static void
_peek_ui_application_window_on_webm_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self)
{
#line 20 "../src/ui/application-window.vala"
	peek_ui_application_window_on_webm_button_clicked ((PeekUiApplicationWindow*) self, _sender);
#line 1878 "application-window.c"
}


static void
peek_ui_application_window_on_mp4_button_clicked (PeekUiApplicationWindow* self,
                                                  GtkButton* source)
{
#line 410 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 410 "../src/ui/application-window.vala"
	g_return_if_fail (source != NULL);
#line 411 "../src/ui/application-window.vala"
	peek_ui_application_window_select_format (self, PEEK_OUTPUT_FORMAT_MP4);
#line 1892 "application-window.c"
}


static void
_peek_ui_application_window_on_mp4_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                      gpointer self)
{
#line 20 "../src/ui/application-window.vala"
	peek_ui_application_window_on_mp4_button_clicked ((PeekUiApplicationWindow*) self, _sender);
#line 1902 "application-window.c"
}


static void
peek_ui_application_window_on_record_button_clicked (PeekUiApplicationWindow* self,
                                                     GtkButton* source)
{
#line 415 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 415 "../src/ui/application-window.vala"
	g_return_if_fail (source != NULL);
#line 416 "../src/ui/application-window.vala"
	peek_ui_application_window_prepare_start_recording (self);
#line 1916 "application-window.c"
}


static void
_peek_ui_application_window_on_record_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                         gpointer self)
{
#line 20 "../src/ui/application-window.vala"
	peek_ui_application_window_on_record_button_clicked ((PeekUiApplicationWindow*) self, _sender);
#line 1926 "application-window.c"
}


static void
peek_ui_application_window_on_stop_button_clicked (PeekUiApplicationWindow* self,
                                                   GtkButton* source)
{
#line 420 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 420 "../src/ui/application-window.vala"
	g_return_if_fail (source != NULL);
#line 421 "../src/ui/application-window.vala"
	peek_ui_application_window_prepare_stop_recording (self);
#line 1940 "application-window.c"
}


static void
_peek_ui_application_window_on_stop_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self)
{
#line 20 "../src/ui/application-window.vala"
	peek_ui_application_window_on_stop_button_clicked ((PeekUiApplicationWindow*) self, _sender);
#line 1950 "application-window.c"
}


static void
peek_ui_application_window_on_new_window_button_clicked (PeekUiApplicationWindow* self,
                                                         GtkButton* source)
{
	GtkPopover* _tmp0_;
	GtkApplication* _tmp1_;
	GtkApplication* _tmp2_;
#line 425 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 425 "../src/ui/application-window.vala"
	g_return_if_fail (source != NULL);
#line 426 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->pop_menu;
#line 426 "../src/ui/application-window.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 427 "../src/ui/application-window.vala"
	_tmp1_ = gtk_window_get_application ((GtkWindow*) self);
#line 427 "../src/ui/application-window.vala"
	_tmp2_ = _tmp1_;
#line 427 "../src/ui/application-window.vala"
	g_action_group_activate_action ((GActionGroup*) _tmp2_, "new-window", NULL);
#line 1975 "application-window.c"
}


static void
_peek_ui_application_window_on_new_window_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                             gpointer self)
{
#line 20 "../src/ui/application-window.vala"
	peek_ui_application_window_on_new_window_button_clicked ((PeekUiApplicationWindow*) self, _sender);
#line 1985 "application-window.c"
}


static void
peek_ui_application_window_on_preferences_button_clicked (PeekUiApplicationWindow* self,
                                                          GtkButton* source)
{
	GtkPopover* _tmp0_;
	GtkWindow* _tmp1_;
	GtkWindow* _tmp2_;
#line 431 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 431 "../src/ui/application-window.vala"
	g_return_if_fail (source != NULL);
#line 432 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->pop_menu;
#line 432 "../src/ui/application-window.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 433 "../src/ui/application-window.vala"
	_tmp1_ = peek_ui_preferences_dialog_present_single_instance ((GtkWindow*) self);
#line 433 "../src/ui/application-window.vala"
	_tmp2_ = _tmp1_;
#line 433 "../src/ui/application-window.vala"
	_g_object_unref0 (_tmp2_);
#line 2010 "application-window.c"
}


static void
_peek_ui_application_window_on_preferences_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                              gpointer self)
{
#line 20 "../src/ui/application-window.vala"
	peek_ui_application_window_on_preferences_button_clicked ((PeekUiApplicationWindow*) self, _sender);
#line 2020 "application-window.c"
}


static void
peek_ui_application_window_on_about_button_clicked (PeekUiApplicationWindow* self,
                                                    GtkButton* source)
{
	GtkPopover* _tmp0_;
	GtkDialog* _tmp1_;
	GtkDialog* _tmp2_;
#line 437 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 437 "../src/ui/application-window.vala"
	g_return_if_fail (source != NULL);
#line 438 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->pop_menu;
#line 438 "../src/ui/application-window.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 439 "../src/ui/application-window.vala"
	_tmp1_ = peek_ui_about_dialog_present_single_instance ((GtkWindow*) self);
#line 439 "../src/ui/application-window.vala"
	_tmp2_ = _tmp1_;
#line 439 "../src/ui/application-window.vala"
	_g_object_unref0 (_tmp2_);
#line 2045 "application-window.c"
}


static void
_peek_ui_application_window_on_about_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                        gpointer self)
{
#line 20 "../src/ui/application-window.vala"
	peek_ui_application_window_on_about_button_clicked ((PeekUiApplicationWindow*) self, _sender);
#line 2055 "application-window.c"
}


static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 442 "../src/ui/application-window.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 442 "../src/ui/application-window.vala"
	return _data4_;
#line 2066 "application-window.c"
}


static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 442 "../src/ui/application-window.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 2077 "application-window.c"
		PeekUiApplicationWindow* self;
#line 442 "../src/ui/application-window.vala"
		self = _data4_->self;
#line 442 "../src/ui/application-window.vala"
		_g_object_unref0 (self);
#line 442 "../src/ui/application-window.vala"
		g_slice_free (Block4Data, _data4_);
#line 2085 "application-window.c"
	}
}


static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 456 "../src/ui/application-window.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 456 "../src/ui/application-window.vala"
	return _data5_;
#line 2097 "application-window.c"
}


static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 456 "../src/ui/application-window.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 2108 "application-window.c"
		PeekUiApplicationWindow* self;
#line 456 "../src/ui/application-window.vala"
		self = _data5_->_data4_->self;
#line 456 "../src/ui/application-window.vala"
		block4_data_unref (_data5_->_data4_);
#line 456 "../src/ui/application-window.vala"
		_data5_->_data4_ = NULL;
#line 456 "../src/ui/application-window.vala"
		g_slice_free (Block5Data, _data5_);
#line 2118 "application-window.c"
	}
}


static void
___lambda12_ (Block5Data* _data5_)
{
	Block4Data* _data4_;
	PeekUiApplicationWindow* self;
	GtkLabel* _tmp0_;
	gulong _tmp1_;
	GtkButton* _tmp2_;
	const gchar* _tmp3_;
	GtkLabel* _tmp4_;
#line 459 "../src/ui/application-window.vala"
	_data4_ = _data5_->_data4_;
#line 459 "../src/ui/application-window.vala"
	self = _data4_->self;
#line 460 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->delay_indicator;
#line 460 "../src/ui/application-window.vala"
	_tmp1_ = _data5_->hide_handler;
#line 460 "../src/ui/application-window.vala"
	g_signal_handler_disconnect ((GObject*) _tmp0_, _tmp1_);
#line 461 "../src/ui/application-window.vala"
	_tmp2_ = self->priv->stop_button;
#line 461 "../src/ui/application-window.vala"
	_tmp3_ = self->priv->stop_button_label;
#line 461 "../src/ui/application-window.vala"
	gtk_button_set_label (_tmp2_, _tmp3_);
#line 462 "../src/ui/application-window.vala"
	_tmp4_ = self->priv->delay_indicator;
#line 462 "../src/ui/application-window.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp4_);
#line 463 "../src/ui/application-window.vala"
	peek_ui_application_window_start_recording (self);
#line 2155 "application-window.c"
}


static void
____lambda12__gtk_widget_hide (GtkWidget* _sender,
                               gpointer self)
{
#line 459 "../src/ui/application-window.vala"
	___lambda12_ (self);
#line 2165 "application-window.c"
}


static gboolean
___lambda11_ (Block4Data* _data4_)
{
	PeekUiApplicationWindow* self;
	gboolean result = FALSE;
	gint _tmp0_;
	gint _tmp1_;
#line 453 "../src/ui/application-window.vala"
	self = _data4_->self;
#line 454 "../src/ui/application-window.vala"
	_tmp0_ = _data4_->delay;
#line 454 "../src/ui/application-window.vala"
	_data4_->delay = _tmp0_ - 1;
#line 456 "../src/ui/application-window.vala"
	_tmp1_ = _data4_->delay;
#line 456 "../src/ui/application-window.vala"
	if (_tmp1_ == 0) {
#line 2186 "application-window.c"
		Block5Data* _data5_;
		GtkLabel* _tmp2_;
		gulong _tmp3_;
		GtkLabel* _tmp4_;
#line 456 "../src/ui/application-window.vala"
		_data5_ = g_slice_new0 (Block5Data);
#line 456 "../src/ui/application-window.vala"
		_data5_->_ref_count_ = 1;
#line 456 "../src/ui/application-window.vala"
		_data5_->_data4_ = block4_data_ref (_data4_);
#line 457 "../src/ui/application-window.vala"
		self->priv->delay_indicator_timeout = (guint) 0;
#line 458 "../src/ui/application-window.vala"
		_data5_->hide_handler = (gulong) 0;
#line 459 "../src/ui/application-window.vala"
		_tmp2_ = self->priv->delay_indicator;
#line 459 "../src/ui/application-window.vala"
		_tmp3_ = g_signal_connect_data ((GtkWidget*) _tmp2_, "hide", (GCallback) ____lambda12__gtk_widget_hide, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
#line 459 "../src/ui/application-window.vala"
		_data5_->hide_handler = _tmp3_;
#line 465 "../src/ui/application-window.vala"
		_tmp4_ = self->priv->delay_indicator;
#line 465 "../src/ui/application-window.vala"
		gtk_widget_hide ((GtkWidget*) _tmp4_);
#line 466 "../src/ui/application-window.vala"
		result = FALSE;
#line 466 "../src/ui/application-window.vala"
		block5_data_unref (_data5_);
#line 466 "../src/ui/application-window.vala"
		_data5_ = NULL;
#line 466 "../src/ui/application-window.vala"
		return result;
#line 2219 "application-window.c"
	} else {
		GtkLabel* _tmp5_;
		gint _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 468 "../src/ui/application-window.vala"
		_tmp5_ = self->priv->delay_indicator;
#line 468 "../src/ui/application-window.vala"
		_tmp6_ = _data4_->delay;
#line 468 "../src/ui/application-window.vala"
		_tmp7_ = g_strdup_printf ("%i", _tmp6_);
#line 468 "../src/ui/application-window.vala"
		_tmp8_ = _tmp7_;
#line 468 "../src/ui/application-window.vala"
		gtk_label_set_text (_tmp5_, _tmp8_);
#line 468 "../src/ui/application-window.vala"
		_g_free0 (_tmp8_);
#line 469 "../src/ui/application-window.vala"
		result = TRUE;
#line 469 "../src/ui/application-window.vala"
		return result;
#line 2241 "application-window.c"
	}
}


static gboolean
____lambda11__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda11_ (self);
#line 453 "../src/ui/application-window.vala"
	return result;
#line 2253 "application-window.c"
}


static void
peek_ui_application_window_prepare_start_recording (PeekUiApplicationWindow* self)
{
	Block4Data* _data4_;
	gboolean _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 442 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 442 "../src/ui/application-window.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 442 "../src/ui/application-window.vala"
	_data4_->_ref_count_ = 1;
#line 442 "../src/ui/application-window.vala"
	_data4_->self = g_object_ref (self);
#line 443 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->is_recording;
#line 443 "../src/ui/application-window.vala"
	if (_tmp0_) {
#line 443 "../src/ui/application-window.vala"
		block4_data_unref (_data4_);
#line 443 "../src/ui/application-window.vala"
		_data4_ = NULL;
#line 443 "../src/ui/application-window.vala"
		return;
#line 2282 "application-window.c"
	}
#line 445 "../src/ui/application-window.vala"
	peek_ui_application_window_enter_recording_state (self);
#line 446 "../src/ui/application-window.vala"
	_tmp1_ = self->priv->_recording_start_delay;
#line 446 "../src/ui/application-window.vala"
	_data4_->delay = _tmp1_;
#line 448 "../src/ui/application-window.vala"
	_tmp2_ = _data4_->delay;
#line 448 "../src/ui/application-window.vala"
	if (_tmp2_ > 0) {
#line 2294 "application-window.c"
		GtkLabel* _tmp3_;
		gint _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GtkLabel* _tmp7_;
		GtkLabel* _tmp8_;
		GtkLabel* _tmp9_;
#line 449 "../src/ui/application-window.vala"
		_tmp3_ = self->priv->delay_indicator;
#line 449 "../src/ui/application-window.vala"
		_tmp4_ = _data4_->delay;
#line 449 "../src/ui/application-window.vala"
		_tmp5_ = g_strdup_printf ("%i", _tmp4_);
#line 449 "../src/ui/application-window.vala"
		_tmp6_ = _tmp5_;
#line 449 "../src/ui/application-window.vala"
		gtk_label_set_text (_tmp3_, _tmp6_);
#line 449 "../src/ui/application-window.vala"
		_g_free0 (_tmp6_);
#line 450 "../src/ui/application-window.vala"
		_tmp7_ = self->priv->delay_indicator;
#line 450 "../src/ui/application-window.vala"
		gtk_widget_show ((GtkWidget*) _tmp7_);
#line 451 "../src/ui/application-window.vala"
		_tmp8_ = self->priv->size_indicator;
#line 451 "../src/ui/application-window.vala"
		gtk_widget_hide ((GtkWidget*) _tmp8_);
#line 452 "../src/ui/application-window.vala"
		_tmp9_ = self->priv->shortcut_label;
#line 452 "../src/ui/application-window.vala"
		gtk_widget_hide ((GtkWidget*) _tmp9_);
#line 453 "../src/ui/application-window.vala"
		self->priv->delay_indicator_timeout = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, ____lambda11__gsource_func, block4_data_ref (_data4_), block4_data_unref);
#line 2328 "application-window.c"
	} else {
#line 473 "../src/ui/application-window.vala"
		peek_ui_application_window_start_recording (self);
#line 2332 "application-window.c"
	}
#line 442 "../src/ui/application-window.vala"
	block4_data_unref (_data4_);
#line 442 "../src/ui/application-window.vala"
	_data4_ = NULL;
#line 2338 "application-window.c"
}


static void
peek_ui_application_window_prepare_stop_recording (PeekUiApplicationWindow* self)
{
	gboolean _tmp0_;
	guint _tmp1_;
#line 477 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 478 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->is_recording;
#line 478 "../src/ui/application-window.vala"
	if (!_tmp0_) {
#line 478 "../src/ui/application-window.vala"
		return;
#line 2355 "application-window.c"
	}
#line 480 "../src/ui/application-window.vala"
	_tmp1_ = self->priv->delay_indicator_timeout;
#line 480 "../src/ui/application-window.vala"
	if (_tmp1_ != ((guint) 0)) {
#line 2361 "application-window.c"
		guint _tmp2_;
#line 481 "../src/ui/application-window.vala"
		_tmp2_ = self->priv->delay_indicator_timeout;
#line 481 "../src/ui/application-window.vala"
		g_source_remove (_tmp2_);
#line 482 "../src/ui/application-window.vala"
		self->priv->delay_indicator_timeout = (guint) 0;
#line 483 "../src/ui/application-window.vala"
		peek_ui_application_window_leave_recording_state (self);
#line 2371 "application-window.c"
	} else {
		guint _tmp3_;
#line 484 "../src/ui/application-window.vala"
		_tmp3_ = self->priv->start_recording_event_source;
#line 484 "../src/ui/application-window.vala"
		if (_tmp3_ != ((guint) 0)) {
#line 2378 "application-window.c"
			guint _tmp4_;
#line 485 "../src/ui/application-window.vala"
			_tmp4_ = self->priv->start_recording_event_source;
#line 485 "../src/ui/application-window.vala"
			g_source_remove (_tmp4_);
#line 486 "../src/ui/application-window.vala"
			self->priv->start_recording_event_source = (guint) 0;
#line 487 "../src/ui/application-window.vala"
			peek_ui_application_window_leave_recording_state (self);
#line 2388 "application-window.c"
		} else {
			PeekRecordingScreenRecorder* _tmp5_;
			gboolean _tmp6_;
			gboolean _tmp7_;
#line 488 "../src/ui/application-window.vala"
			_tmp5_ = self->priv->_recorder;
#line 488 "../src/ui/application-window.vala"
			_tmp6_ = peek_recording_screen_recorder_get_is_recording (_tmp5_);
#line 488 "../src/ui/application-window.vala"
			_tmp7_ = _tmp6_;
#line 488 "../src/ui/application-window.vala"
			if (!_tmp7_) {
#line 489 "../src/ui/application-window.vala"
				return;
#line 2403 "application-window.c"
			} else {
				GtkButton* _tmp8_;
				PeekRecordingScreenRecorder* _tmp9_;
#line 491 "../src/ui/application-window.vala"
				_tmp8_ = self->priv->stop_button;
#line 491 "../src/ui/application-window.vala"
				gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, FALSE);
#line 492 "../src/ui/application-window.vala"
				peek_ui_application_window_show_spinner (self);
#line 493 "../src/ui/application-window.vala"
				_tmp9_ = self->priv->_recorder;
#line 493 "../src/ui/application-window.vala"
				peek_recording_screen_recorder_stop (_tmp9_);
#line 2417 "application-window.c"
			}
		}
	}
}


static void
peek_ui_application_window_show_spinner (PeekUiApplicationWindow* self)
{
	GtkBox* box = NULL;
	GtkBox* _tmp0_;
	GtkSpinner* spinner = NULL;
	GtkSpinner* _tmp1_;
	GtkSpinner* _tmp2_;
	GtkBox* _tmp3_;
	GtkSpinner* _tmp4_;
	GtkBox* _tmp8_;
	GtkHeaderBar* _tmp9_;
	GtkBox* _tmp10_;
#line 497 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 498 "../src/ui/application-window.vala"
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 498 "../src/ui/application-window.vala"
	g_object_ref_sink (_tmp0_);
#line 498 "../src/ui/application-window.vala"
	box = _tmp0_;
#line 500 "../src/ui/application-window.vala"
	_tmp1_ = (GtkSpinner*) gtk_spinner_new ();
#line 500 "../src/ui/application-window.vala"
	g_object_ref_sink (_tmp1_);
#line 500 "../src/ui/application-window.vala"
	spinner = _tmp1_;
#line 501 "../src/ui/application-window.vala"
	_tmp2_ = spinner;
#line 501 "../src/ui/application-window.vala"
	g_object_set (_tmp2_, "active", TRUE, NULL);
#line 502 "../src/ui/application-window.vala"
	_tmp3_ = box;
#line 502 "../src/ui/application-window.vala"
	_tmp4_ = spinner;
#line 502 "../src/ui/application-window.vala"
	gtk_box_pack_start (_tmp3_, (GtkWidget*) _tmp4_, FALSE, FALSE, (guint) 0);
#line 504 "../src/ui/application-window.vala"
	if (peek_ui_application_window_get_window_width (self) >= PEEK_UI_APPLICATION_WINDOW_SMALL_WINDOW_SIZE) {
#line 2463 "application-window.c"
		GtkLabel* label = NULL;
		GtkLabel* _tmp5_;
		GtkBox* _tmp6_;
		GtkLabel* _tmp7_;
#line 505 "../src/ui/application-window.vala"
		_tmp5_ = (GtkLabel*) gtk_label_new (_ ("Rendering…"));
#line 505 "../src/ui/application-window.vala"
		g_object_ref_sink (_tmp5_);
#line 505 "../src/ui/application-window.vala"
		label = _tmp5_;
#line 506 "../src/ui/application-window.vala"
		_tmp6_ = box;
#line 506 "../src/ui/application-window.vala"
		_tmp7_ = label;
#line 506 "../src/ui/application-window.vala"
		gtk_box_pack_start (_tmp6_, (GtkWidget*) _tmp7_, FALSE, FALSE, (guint) 0);
#line 504 "../src/ui/application-window.vala"
		_g_object_unref0 (label);
#line 2482 "application-window.c"
	}
#line 509 "../src/ui/application-window.vala"
	_tmp8_ = box;
#line 509 "../src/ui/application-window.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp8_);
#line 510 "../src/ui/application-window.vala"
	_tmp9_ = self->priv->headerbar;
#line 510 "../src/ui/application-window.vala"
	_tmp10_ = box;
#line 510 "../src/ui/application-window.vala"
	gtk_header_bar_set_custom_title (_tmp9_, (GtkWidget*) _tmp10_);
#line 497 "../src/ui/application-window.vala"
	_g_object_unref0 (spinner);
#line 497 "../src/ui/application-window.vala"
	_g_object_unref0 (box);
#line 2498 "application-window.c"
}


static void
peek_ui_application_window_hide_spinner (PeekUiApplicationWindow* self)
{
	GtkHeaderBar* _tmp0_;
#line 513 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 514 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->headerbar;
#line 514 "../src/ui/application-window.vala"
	gtk_header_bar_set_custom_title (_tmp0_, NULL);
#line 2512 "application-window.c"
}


static void
peek_ui_application_window_toggle_recording (PeekUiApplicationWindow* self)
{
	gboolean _tmp0_;
#line 517 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 518 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->is_recording;
#line 518 "../src/ui/application-window.vala"
	if (_tmp0_) {
#line 519 "../src/ui/application-window.vala"
		peek_ui_application_window_prepare_stop_recording (self);
#line 2528 "application-window.c"
	} else {
#line 521 "../src/ui/application-window.vala"
		peek_ui_application_window_prepare_start_recording (self);
#line 2532 "application-window.c"
	}
}


static gboolean
__lambda13_ (PeekUiApplicationWindow* self)
{
	gboolean result = FALSE;
	guint _tmp0_;
	PeekRecordingRecordingArea area = {0};
	PeekRecordingRecordingArea _tmp1_ = {0};
	PeekRecordingRecordingArea _tmp2_;
	gint _tmp3_;
	PeekRecordingRecordingArea _tmp4_;
	gint _tmp5_;
	PeekRecordingRecordingArea _tmp6_;
	gint _tmp7_;
	PeekRecordingRecordingArea _tmp8_;
	gint _tmp9_;
	PeekRecordingRecordingArea _tmp10_;
	PeekRecordingRecordingArea _tmp11_ = {0};
	gboolean _tmp21_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 529 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->start_recording_event_source;
#line 529 "../src/ui/application-window.vala"
	g_source_remove (_tmp0_);
#line 530 "../src/ui/application-window.vala"
	self->priv->start_recording_event_source = (guint) 0;
#line 531 "../src/ui/application-window.vala"
	peek_ui_application_window_update_time (self);
#line 532 "../src/ui/application-window.vala"
	peek_ui_application_window_get_recording_area (self, &_tmp1_);
#line 532 "../src/ui/application-window.vala"
	area = _tmp1_;
#line 533 "../src/ui/application-window.vala"
	_tmp2_ = area;
#line 533 "../src/ui/application-window.vala"
	_tmp3_ = _tmp2_.left;
#line 533 "../src/ui/application-window.vala"
	_tmp4_ = area;
#line 533 "../src/ui/application-window.vala"
	_tmp5_ = _tmp4_.top;
#line 533 "../src/ui/application-window.vala"
	_tmp6_ = area;
#line 533 "../src/ui/application-window.vala"
	_tmp7_ = _tmp6_.width;
#line 533 "../src/ui/application-window.vala"
	_tmp8_ = area;
#line 533 "../src/ui/application-window.vala"
	_tmp9_ = _tmp8_.height;
#line 533 "../src/ui/application-window.vala"
	g_debug ("application-window.vala:533: Recording area: %i, %i, %i, %i\n", _tmp3_, _tmp5_, _tmp7_, _tmp9_);
#line 535 "../src/ui/application-window.vala"
	_tmp10_ = area;
#line 535 "../src/ui/application-window.vala"
	peek_recording_recording_area_copy (&_tmp10_, &_tmp11_);
#line 535 "../src/ui/application-window.vala"
	peek_recording_recording_area_destroy (&self->priv->active_recording_area);
#line 535 "../src/ui/application-window.vala"
	self->priv->active_recording_area = _tmp11_;
#line 2594 "application-window.c"
	{
		PeekRecordingScreenRecorder* _tmp12_;
		PeekRecordingRecordingArea _tmp13_;
#line 538 "../src/ui/application-window.vala"
		_tmp12_ = self->priv->_recorder;
#line 538 "../src/ui/application-window.vala"
		_tmp13_ = area;
#line 538 "../src/ui/application-window.vala"
		peek_recording_screen_recorder_record (_tmp12_, &_tmp13_, &_inner_error0_);
#line 538 "../src/ui/application-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2606 "application-window.c"
			gboolean _tmp14_ = FALSE;
#line 538 "../src/ui/application-window.vala"
			if (_inner_error0_->domain == PEEK_RECORDING_ERROR) {
#line 2610 "application-window.c"
				goto __catch35_peek_recording_error;
			}
#line 538 "../src/ui/application-window.vala"
			peek_recording_recording_area_destroy (&area);
#line 538 "../src/ui/application-window.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 538 "../src/ui/application-window.vala"
			g_clear_error (&_inner_error0_);
#line 538 "../src/ui/application-window.vala"
			return _tmp14_;
#line 2621 "application-window.c"
		}
#line 539 "../src/ui/application-window.vala"
		result = TRUE;
#line 539 "../src/ui/application-window.vala"
		peek_recording_recording_area_destroy (&area);
#line 539 "../src/ui/application-window.vala"
		return result;
#line 2629 "application-window.c"
	}
	goto __finally35;
	__catch35_peek_recording_error:
	{
		GError* e = NULL;
		FILE* _tmp15_;
		GError* _tmp16_;
		const gchar* _tmp17_;
		GError* _tmp18_;
		GtkDialog* _tmp19_;
		GtkDialog* _tmp20_;
#line 537 "../src/ui/application-window.vala"
		e = _inner_error0_;
#line 537 "../src/ui/application-window.vala"
		_inner_error0_ = NULL;
#line 541 "../src/ui/application-window.vala"
		_tmp15_ = stderr;
#line 541 "../src/ui/application-window.vala"
		_tmp16_ = e;
#line 541 "../src/ui/application-window.vala"
		_tmp17_ = _tmp16_->message;
#line 541 "../src/ui/application-window.vala"
		fprintf (_tmp15_, "Failed to initialize recorder: %s\n", _tmp17_);
#line 542 "../src/ui/application-window.vala"
		peek_ui_application_window_leave_recording_state (self);
#line 543 "../src/ui/application-window.vala"
		_tmp18_ = e;
#line 543 "../src/ui/application-window.vala"
		_tmp19_ = peek_ui_error_dialog_present_single_instance ((GtkWindow*) self, _ ("Recording could not be started due to an unexpected error."), _tmp18_);
#line 543 "../src/ui/application-window.vala"
		_tmp20_ = _tmp19_;
#line 543 "../src/ui/application-window.vala"
		_g_object_unref0 (_tmp20_);
#line 547 "../src/ui/application-window.vala"
		result = FALSE;
#line 547 "../src/ui/application-window.vala"
		_g_error_free0 (e);
#line 547 "../src/ui/application-window.vala"
		peek_recording_recording_area_destroy (&area);
#line 547 "../src/ui/application-window.vala"
		return result;
#line 2671 "application-window.c"
	}
	__finally35:
#line 537 "../src/ui/application-window.vala"
	peek_recording_recording_area_destroy (&area);
#line 537 "../src/ui/application-window.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 537 "../src/ui/application-window.vala"
	g_clear_error (&_inner_error0_);
#line 537 "../src/ui/application-window.vala"
	return _tmp21_;
#line 2682 "application-window.c"
}


static gboolean
___lambda13__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda13_ ((PeekUiApplicationWindow*) self);
#line 528 "../src/ui/application-window.vala"
	return result;
#line 2693 "application-window.c"
}


static void
peek_ui_application_window_start_recording (PeekUiApplicationWindow* self)
{
#line 525 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 528 "../src/ui/application-window.vala"
	self->priv->start_recording_event_source = g_idle_add_full (G_PRIORITY_HIGH_IDLE, ___lambda13__gsource_func, g_object_ref (self), g_object_unref);
#line 2704 "application-window.c"
}


static void
peek_ui_application_window_enter_recording_state (PeekUiApplicationWindow* self)
{
	gboolean _tmp0_;
#line 552 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 553 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->is_recording;
#line 553 "../src/ui/application-window.vala"
	if (!_tmp0_) {
#line 2718 "application-window.c"
		GtkLabel* _tmp1_;
		GtkLabel* _tmp2_;
		GtkMenuButton* _tmp3_;
		GtkButton* _tmp4_;
		GtkButton* _tmp7_;
		GtkButton* _tmp8_;
#line 554 "../src/ui/application-window.vala"
		self->priv->is_recording = TRUE;
#line 555 "../src/ui/application-window.vala"
		_tmp1_ = self->priv->size_indicator;
#line 555 "../src/ui/application-window.vala"
		gtk_widget_set_opacity ((GtkWidget*) _tmp1_, 0.0);
#line 556 "../src/ui/application-window.vala"
		_tmp2_ = self->priv->shortcut_label;
#line 556 "../src/ui/application-window.vala"
		gtk_widget_set_opacity ((GtkWidget*) _tmp2_, 0.0);
#line 557 "../src/ui/application-window.vala"
		_tmp3_ = self->priv->pop_format_menu;
#line 557 "../src/ui/application-window.vala"
		gtk_widget_hide ((GtkWidget*) _tmp3_);
#line 558 "../src/ui/application-window.vala"
		_tmp4_ = self->priv->record_button;
#line 558 "../src/ui/application-window.vala"
		gtk_widget_hide ((GtkWidget*) _tmp4_);
#line 559 "../src/ui/application-window.vala"
		if (peek_ui_application_window_get_window_width (self) >= PEEK_UI_APPLICATION_WINDOW_SMALL_WINDOW_SIZE) {
#line 2745 "application-window.c"
			GtkButton* _tmp5_;
			const gchar* _tmp6_;
#line 560 "../src/ui/application-window.vala"
			_tmp5_ = self->priv->stop_button;
#line 560 "../src/ui/application-window.vala"
			_tmp6_ = self->priv->stop_button_label;
#line 560 "../src/ui/application-window.vala"
			gtk_button_set_label (_tmp5_, _tmp6_);
#line 2754 "application-window.c"
		}
#line 563 "../src/ui/application-window.vala"
		_tmp7_ = self->priv->stop_button;
#line 563 "../src/ui/application-window.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, TRUE);
#line 564 "../src/ui/application-window.vala"
		_tmp8_ = self->priv->stop_button;
#line 564 "../src/ui/application-window.vala"
		gtk_widget_show ((GtkWidget*) _tmp8_);
#line 565 "../src/ui/application-window.vala"
		peek_ui_application_window_freeze_window_size (self);
#line 566 "../src/ui/application-window.vala"
		gtk_window_set_keep_above ((GtkWindow*) self, TRUE);
#line 2768 "application-window.c"
	}
}


static void
___lambda8_ (PeekUiApplicationWindow* self,
             GObject* obj,
             GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 583 "../src/ui/application-window.vala"
	g_return_if_fail (res != NULL);
#line 2781 "application-window.c"
	{
		gboolean delete_success = FALSE;
		GFile* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 585 "../src/ui/application-window.vala"
		_tmp0_ = self->priv->in_file;
#line 585 "../src/ui/application-window.vala"
		delete_success = g_file_delete_finish (_tmp0_, res, &_inner_error0_);
#line 585 "../src/ui/application-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2793 "application-window.c"
			goto __catch36_g_error;
		}
#line 586 "../src/ui/application-window.vala"
		_tmp1_ = bool_to_string (delete_success);
#line 586 "../src/ui/application-window.vala"
		_tmp2_ = _tmp1_;
#line 586 "../src/ui/application-window.vala"
		g_debug ("application-window.vala:586: Temp file deleted: %s\n", _tmp2_);
#line 586 "../src/ui/application-window.vala"
		_g_free0 (_tmp2_);
#line 2804 "application-window.c"
	}
	goto __finally36;
	__catch36_g_error:
	{
		GError* e = NULL;
		FILE* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 584 "../src/ui/application-window.vala"
		e = _inner_error0_;
#line 584 "../src/ui/application-window.vala"
		_inner_error0_ = NULL;
#line 588 "../src/ui/application-window.vala"
		_tmp3_ = stderr;
#line 588 "../src/ui/application-window.vala"
		_tmp4_ = e;
#line 588 "../src/ui/application-window.vala"
		_tmp5_ = _tmp4_->message;
#line 588 "../src/ui/application-window.vala"
		fprintf (_tmp3_, "Temp file delete error: %s\n", _tmp5_);
#line 584 "../src/ui/application-window.vala"
		_g_error_free0 (e);
#line 2827 "application-window.c"
	}
	__finally36:
	{
		GError* _inner_error1_ = NULL;
#line 590 "../src/ui/application-window.vala"
		_g_object_unref0 (self->priv->in_file);
#line 590 "../src/ui/application-window.vala"
		self->priv->in_file = NULL;
#line 2836 "application-window.c"
	}
#line 584 "../src/ui/application-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 584 "../src/ui/application-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 584 "../src/ui/application-window.vala"
		g_clear_error (&_inner_error0_);
#line 584 "../src/ui/application-window.vala"
		return;
#line 2846 "application-window.c"
	}
#line 593 "../src/ui/application-window.vala"
	g_signal_emit (self, peek_ui_application_window_signals[PEEK_UI_APPLICATION_WINDOW_RECORDING_FINISHED_SIGNAL], 0);
#line 2850 "application-window.c"
}


static void
____lambda8__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 583 "../src/ui/application-window.vala"
	___lambda8_ ((PeekUiApplicationWindow*) self, source_object, res);
#line 583 "../src/ui/application-window.vala"
	g_object_unref (self);
#line 2863 "application-window.c"
}


static void
peek_ui_application_window_leave_recording_state (PeekUiApplicationWindow* self)
{
	GtkLabel* _tmp0_;
	GtkButton* _tmp1_;
	GtkMenuButton* _tmp2_;
	GtkButton* _tmp3_;
	GFile* _tmp4_;
#line 570 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 571 "../src/ui/application-window.vala"
	_g_object_unref0 (self->priv->out_file);
#line 571 "../src/ui/application-window.vala"
	self->priv->out_file = NULL;
#line 572 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->delay_indicator;
#line 572 "../src/ui/application-window.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 573 "../src/ui/application-window.vala"
	self->priv->is_recording = FALSE;
#line 574 "../src/ui/application-window.vala"
	self->priv->is_postprocessing = FALSE;
#line 575 "../src/ui/application-window.vala"
	_tmp1_ = self->priv->stop_button;
#line 575 "../src/ui/application-window.vala"
	gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 576 "../src/ui/application-window.vala"
	_tmp2_ = self->priv->pop_format_menu;
#line 576 "../src/ui/application-window.vala"
	gtk_widget_show ((GtkWidget*) _tmp2_);
#line 577 "../src/ui/application-window.vala"
	_tmp3_ = self->priv->record_button;
#line 577 "../src/ui/application-window.vala"
	gtk_widget_show ((GtkWidget*) _tmp3_);
#line 578 "../src/ui/application-window.vala"
	peek_ui_application_window_unfreeze_window_size (self);
#line 579 "../src/ui/application-window.vala"
	peek_ui_application_window_hide_spinner (self);
#line 581 "../src/ui/application-window.vala"
	_tmp4_ = self->priv->in_file;
#line 581 "../src/ui/application-window.vala"
	if (_tmp4_ != NULL) {
#line 2909 "application-window.c"
		GFile* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		GFile* _tmp8_;
#line 582 "../src/ui/application-window.vala"
		_tmp5_ = self->priv->in_file;
#line 582 "../src/ui/application-window.vala"
		_tmp6_ = g_file_get_uri (_tmp5_);
#line 582 "../src/ui/application-window.vala"
		_tmp7_ = _tmp6_;
#line 582 "../src/ui/application-window.vala"
		g_debug ("application-window.vala:582: Deleting temp file %s\n", _tmp7_);
#line 582 "../src/ui/application-window.vala"
		_g_free0 (_tmp7_);
#line 583 "../src/ui/application-window.vala"
		_tmp8_ = self->priv->in_file;
#line 583 "../src/ui/application-window.vala"
		g_file_delete_async (_tmp8_, G_PRIORITY_DEFAULT, NULL, ____lambda8__gasync_ready_callback, g_object_ref (self));
#line 2928 "application-window.c"
	} else {
#line 596 "../src/ui/application-window.vala"
		g_signal_emit (self, peek_ui_application_window_signals[PEEK_UI_APPLICATION_WINDOW_RECORDING_FINISHED_SIGNAL], 0);
#line 2932 "application-window.c"
	}
}


static void
peek_ui_application_window_update_input_shape (PeekUiApplicationWindow* self)
{
	cairo_region_t* window_region = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	cairo_region_t* _tmp2_;
	cairo_region_t* recording_view_region = NULL;
	GtkWidget* _tmp3_;
	cairo_region_t* _tmp4_;
	cairo_region_t* _tmp5_;
	cairo_region_t* _tmp6_;
	GtkPopover* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	GtkPopover* _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp16_;
	cairo_region_t* _tmp21_;
	GdkScreen* _tmp22_;
#line 600 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 602 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->recording_view;
#line 602 "../src/ui/application-window.vala"
	_tmp1_ = gtk_widget_get_toplevel (_tmp0_);
#line 602 "../src/ui/application-window.vala"
	_tmp2_ = peek_gtk_helper_create_region_from_widget (_tmp1_);
#line 602 "../src/ui/application-window.vala"
	window_region = _tmp2_;
#line 603 "../src/ui/application-window.vala"
	_tmp3_ = self->priv->recording_view;
#line 603 "../src/ui/application-window.vala"
	_tmp4_ = peek_gtk_helper_create_region_from_widget (_tmp3_);
#line 603 "../src/ui/application-window.vala"
	recording_view_region = _tmp4_;
#line 604 "../src/ui/application-window.vala"
	_tmp5_ = window_region;
#line 604 "../src/ui/application-window.vala"
	_tmp6_ = recording_view_region;
#line 604 "../src/ui/application-window.vala"
	cairo_region_subtract (_tmp5_, _tmp6_);
#line 607 "../src/ui/application-window.vala"
	_tmp7_ = self->priv->pop_format;
#line 607 "../src/ui/application-window.vala"
	_tmp8_ = gtk_widget_get_visible ((GtkWidget*) _tmp7_);
#line 607 "../src/ui/application-window.vala"
	_tmp9_ = _tmp8_;
#line 607 "../src/ui/application-window.vala"
	if (_tmp9_) {
#line 2987 "application-window.c"
		cairo_region_t* pop_format_region = NULL;
		GtkPopover* _tmp10_;
		cairo_region_t* _tmp11_;
		cairo_region_t* _tmp12_;
		cairo_region_t* _tmp13_;
#line 608 "../src/ui/application-window.vala"
		_tmp10_ = self->priv->pop_format;
#line 608 "../src/ui/application-window.vala"
		_tmp11_ = peek_gtk_helper_create_region_from_widget ((GtkWidget*) _tmp10_);
#line 608 "../src/ui/application-window.vala"
		pop_format_region = _tmp11_;
#line 609 "../src/ui/application-window.vala"
		_tmp12_ = window_region;
#line 609 "../src/ui/application-window.vala"
		_tmp13_ = pop_format_region;
#line 609 "../src/ui/application-window.vala"
		cairo_region_union (_tmp12_, _tmp13_);
#line 607 "../src/ui/application-window.vala"
		_cairo_region_destroy0 (pop_format_region);
#line 3007 "application-window.c"
	}
#line 613 "../src/ui/application-window.vala"
	_tmp14_ = self->priv->pop_menu;
#line 613 "../src/ui/application-window.vala"
	_tmp15_ = gtk_widget_get_visible ((GtkWidget*) _tmp14_);
#line 613 "../src/ui/application-window.vala"
	_tmp16_ = _tmp15_;
#line 613 "../src/ui/application-window.vala"
	if (_tmp16_) {
#line 3017 "application-window.c"
		cairo_region_t* pop_menu_region = NULL;
		GtkPopover* _tmp17_;
		cairo_region_t* _tmp18_;
		cairo_region_t* _tmp19_;
		cairo_region_t* _tmp20_;
#line 614 "../src/ui/application-window.vala"
		_tmp17_ = self->priv->pop_menu;
#line 614 "../src/ui/application-window.vala"
		_tmp18_ = peek_gtk_helper_create_region_from_widget ((GtkWidget*) _tmp17_);
#line 614 "../src/ui/application-window.vala"
		pop_menu_region = _tmp18_;
#line 615 "../src/ui/application-window.vala"
		_tmp19_ = window_region;
#line 615 "../src/ui/application-window.vala"
		_tmp20_ = pop_menu_region;
#line 615 "../src/ui/application-window.vala"
		cairo_region_union (_tmp19_, _tmp20_);
#line 613 "../src/ui/application-window.vala"
		_cairo_region_destroy0 (pop_menu_region);
#line 3037 "application-window.c"
	}
#line 618 "../src/ui/application-window.vala"
	_tmp21_ = window_region;
#line 618 "../src/ui/application-window.vala"
	gtk_widget_input_shape_combine_region ((GtkWidget*) self, _tmp21_);
#line 620 "../src/ui/application-window.vala"
	_tmp22_ = gtk_window_get_screen ((GtkWindow*) self);
#line 620 "../src/ui/application-window.vala"
	if (!gdk_screen_is_composited (_tmp22_)) {
#line 3047 "application-window.c"
		gboolean _tmp23_ = FALSE;
		guint _tmp24_;
#line 621 "../src/ui/application-window.vala"
		_tmp24_ = self->priv->delay_indicator_timeout;
#line 621 "../src/ui/application-window.vala"
		if (_tmp24_ == ((guint) 0)) {
#line 3054 "application-window.c"
			guint _tmp25_;
#line 622 "../src/ui/application-window.vala"
			_tmp25_ = self->priv->size_indicator_timeout;
#line 622 "../src/ui/application-window.vala"
			_tmp23_ = _tmp25_ == ((guint) 0);
#line 3060 "application-window.c"
		} else {
#line 621 "../src/ui/application-window.vala"
			_tmp23_ = FALSE;
#line 3064 "application-window.c"
		}
#line 621 "../src/ui/application-window.vala"
		if (_tmp23_) {
#line 3068 "application-window.c"
			cairo_region_t* _tmp26_;
#line 623 "../src/ui/application-window.vala"
			_tmp26_ = window_region;
#line 623 "../src/ui/application-window.vala"
			gtk_widget_shape_combine_region ((GtkWidget*) self, _tmp26_);
#line 3074 "application-window.c"
		} else {
#line 625 "../src/ui/application-window.vala"
			gtk_widget_shape_combine_region ((GtkWidget*) self, NULL);
#line 3078 "application-window.c"
		}
	}
#line 600 "../src/ui/application-window.vala"
	_cairo_region_destroy0 (recording_view_region);
#line 600 "../src/ui/application-window.vala"
	_cairo_region_destroy0 (window_region);
#line 3085 "application-window.c"
}


static void
peek_ui_application_window_freeze_window_size (PeekUiApplicationWindow* self)
{
	gint width = 0;
	gint height = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 630 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 632 "../src/ui/application-window.vala"
	if (peek_desktop_integration_is_xfce ()) {
#line 633 "../src/ui/application-window.vala"
		g_debug ("application-window.vala:633: Window size freezing disabled on Xfce");
#line 634 "../src/ui/application-window.vala"
		return;
#line 3106 "application-window.c"
	}
#line 637 "../src/ui/application-window.vala"
	width = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 638 "../src/ui/application-window.vala"
	height = gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 639 "../src/ui/application-window.vala"
	_tmp0_ = width;
#line 639 "../src/ui/application-window.vala"
	_tmp1_ = height;
#line 639 "../src/ui/application-window.vala"
	g_debug ("application-window.vala:639: freeze_window_size w: %d, h: %d", _tmp0_, _tmp1_);
#line 640 "../src/ui/application-window.vala"
	_tmp2_ = width;
#line 640 "../src/ui/application-window.vala"
	_tmp3_ = height;
#line 640 "../src/ui/application-window.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, _tmp2_, _tmp3_);
#line 641 "../src/ui/application-window.vala"
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
#line 3126 "application-window.c"
}


static void
peek_ui_application_window_unfreeze_window_size (PeekUiApplicationWindow* self)
{
	gint width = 0;
	gint height = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 644 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 646 "../src/ui/application-window.vala"
	if (peek_desktop_integration_is_xfce ()) {
#line 647 "../src/ui/application-window.vala"
		g_debug ("application-window.vala:647: Window size freezing disabled on Xfce");
#line 648 "../src/ui/application-window.vala"
		return;
#line 3147 "application-window.c"
	}
#line 651 "../src/ui/application-window.vala"
	width = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 652 "../src/ui/application-window.vala"
	height = gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 653 "../src/ui/application-window.vala"
	_tmp0_ = width;
#line 653 "../src/ui/application-window.vala"
	_tmp1_ = height;
#line 653 "../src/ui/application-window.vala"
	g_debug ("application-window.vala:653: unfreeze_window_size w: %d, h: %d", _tmp0_, _tmp1_);
#line 654 "../src/ui/application-window.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, 0, 0);
#line 655 "../src/ui/application-window.vala"
	_tmp2_ = width;
#line 655 "../src/ui/application-window.vala"
	_tmp3_ = height;
#line 655 "../src/ui/application-window.vala"
	gtk_window_set_default_size ((GtkWindow*) self, _tmp2_, _tmp3_);
#line 656 "../src/ui/application-window.vala"
	gtk_window_set_resizable ((GtkWindow*) self, TRUE);
#line 3169 "application-window.c"
}


static void
peek_ui_application_window_get_recording_area (PeekUiApplicationWindow* self,
                                               PeekRecordingRecordingArea* result)
{
	GtkWidget* _tmp0_;
	PeekRecordingRecordingArea _tmp1_ = {0};
#line 659 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 660 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->recording_view;
#line 660 "../src/ui/application-window.vala"
	peek_recording_recording_area_create_for_widget (_tmp0_, &_tmp1_);
#line 660 "../src/ui/application-window.vala"
	*result = _tmp1_;
#line 660 "../src/ui/application-window.vala"
	return;
#line 3189 "application-window.c"
}


static void
peek_ui_application_window_show_file_chooser (PeekUiApplicationWindow* self)
{
	GtkFileChooserDialog* chooser = NULL;
	GtkFileChooserDialog* _tmp0_;
	GtkWidget* ok_button = NULL;
	GtkFileChooserDialog* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkFileChooserDialog* _tmp6_;
	gchar* extension = NULL;
	PeekRecordingScreenRecorder* _tmp7_;
	PeekRecordingRecordingConfig* _tmp8_;
	PeekRecordingRecordingConfig* _tmp9_;
	PeekOutputFormat _tmp10_;
	PeekOutputFormat _tmp11_;
	gchar* _tmp12_;
	gchar* filename = NULL;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GtkFileFilter* filter = NULL;
	GtkFileFilter* _tmp19_;
	GtkFileFilter* _tmp20_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	GtkFileChooserDialog* _tmp24_;
	GtkFileFilter* _tmp25_;
	gchar* folder = NULL;
	gchar* _tmp26_;
	GtkFileChooserDialog* _tmp27_;
	const gchar* _tmp28_;
	GDateTime* now = NULL;
	GDateTime* _tmp29_;
	gchar* default_name = NULL;
	GDateTime* _tmp30_;
	const gchar* _tmp31_;
	gchar* _tmp32_;
	GtkFileChooserDialog* _tmp33_;
	const gchar* _tmp34_;
	GtkFileChooserDialog* _tmp35_;
	const gchar* _tmp36_;
	GtkFileChooserDialog* _tmp37_;
	GtkFileChooserDialog* _tmp44_;
#line 663 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 670 "../src/ui/application-window.vala"
	_tmp0_ = (GtkFileChooserDialog*) gtk_file_chooser_dialog_new (_ ("Save animation"), (GtkWindow*) self, GTK_FILE_CHOOSER_ACTION_SAVE, _ ("_Cancel"), GTK_RESPONSE_CANCEL, NULL);
#line 670 "../src/ui/application-window.vala"
	g_object_ref_sink (_tmp0_);
#line 670 "../src/ui/application-window.vala"
	chooser = _tmp0_;
#line 674 "../src/ui/application-window.vala"
	_tmp1_ = chooser;
#line 674 "../src/ui/application-window.vala"
	_tmp2_ = gtk_dialog_add_button ((GtkDialog*) _tmp1_, _ ("_Save"), (gint) GTK_RESPONSE_ACCEPT);
#line 674 "../src/ui/application-window.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 674 "../src/ui/application-window.vala"
	ok_button = _tmp3_;
#line 675 "../src/ui/application-window.vala"
	_tmp4_ = ok_button;
#line 675 "../src/ui/application-window.vala"
	_tmp5_ = gtk_widget_get_style_context (_tmp4_);
#line 675 "../src/ui/application-window.vala"
	gtk_style_context_add_class (_tmp5_, "suggested-action");
#line 678 "../src/ui/application-window.vala"
	_tmp6_ = chooser;
#line 678 "../src/ui/application-window.vala"
	gtk_file_chooser_set_do_overwrite_confirmation ((GtkFileChooser*) _tmp6_, TRUE);
#line 680 "../src/ui/application-window.vala"
	_tmp7_ = self->priv->_recorder;
#line 680 "../src/ui/application-window.vala"
	_tmp8_ = peek_recording_screen_recorder_get_config (_tmp7_);
#line 680 "../src/ui/application-window.vala"
	_tmp9_ = _tmp8_;
#line 680 "../src/ui/application-window.vala"
	_tmp10_ = peek_recording_recording_config_get_output_format (_tmp9_);
#line 680 "../src/ui/application-window.vala"
	_tmp11_ = _tmp10_;
#line 680 "../src/ui/application-window.vala"
	_tmp12_ = peek_utils_get_file_extension_for_format (_tmp11_);
#line 680 "../src/ui/application-window.vala"
	extension = _tmp12_;
#line 682 "../src/ui/application-window.vala"
	_tmp13_ = self->priv->_default_file_name_format;
#line 682 "../src/ui/application-window.vala"
	_tmp14_ = g_strconcat (_tmp13_, ".", NULL);
#line 682 "../src/ui/application-window.vala"
	_tmp15_ = _tmp14_;
#line 682 "../src/ui/application-window.vala"
	_tmp16_ = extension;
#line 682 "../src/ui/application-window.vala"
	_tmp17_ = g_strconcat (_tmp15_, _tmp16_, NULL);
#line 682 "../src/ui/application-window.vala"
	_tmp18_ = _tmp17_;
#line 682 "../src/ui/application-window.vala"
	_g_free0 (_tmp15_);
#line 682 "../src/ui/application-window.vala"
	filename = _tmp18_;
#line 684 "../src/ui/application-window.vala"
	_tmp19_ = gtk_file_filter_new ();
#line 684 "../src/ui/application-window.vala"
	g_object_ref_sink (_tmp19_);
#line 684 "../src/ui/application-window.vala"
	filter = _tmp19_;
#line 685 "../src/ui/application-window.vala"
	_tmp20_ = filter;
#line 685 "../src/ui/application-window.vala"
	_tmp21_ = extension;
#line 685 "../src/ui/application-window.vala"
	_tmp22_ = g_strconcat ("*.", _tmp21_, NULL);
#line 685 "../src/ui/application-window.vala"
	_tmp23_ = _tmp22_;
#line 685 "../src/ui/application-window.vala"
	gtk_file_filter_add_pattern (_tmp20_, _tmp23_);
#line 685 "../src/ui/application-window.vala"
	_g_free0 (_tmp23_);
#line 686 "../src/ui/application-window.vala"
	_tmp24_ = chooser;
#line 686 "../src/ui/application-window.vala"
	_tmp25_ = filter;
#line 686 "../src/ui/application-window.vala"
	gtk_file_chooser_set_filter ((GtkFileChooser*) _tmp24_, _tmp25_);
#line 688 "../src/ui/application-window.vala"
	_tmp26_ = peek_ui_application_window_load_preferred_save_folder (self);
#line 688 "../src/ui/application-window.vala"
	folder = _tmp26_;
#line 689 "../src/ui/application-window.vala"
	_tmp27_ = chooser;
#line 689 "../src/ui/application-window.vala"
	_tmp28_ = folder;
#line 689 "../src/ui/application-window.vala"
	gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp27_, _tmp28_);
#line 691 "../src/ui/application-window.vala"
	_tmp29_ = g_date_time_new_now_local ();
#line 691 "../src/ui/application-window.vala"
	now = _tmp29_;
#line 692 "../src/ui/application-window.vala"
	_tmp30_ = now;
#line 692 "../src/ui/application-window.vala"
	_tmp31_ = filename;
#line 692 "../src/ui/application-window.vala"
	_tmp32_ = g_date_time_format (_tmp30_, _tmp31_);
#line 692 "../src/ui/application-window.vala"
	default_name = _tmp32_;
#line 693 "../src/ui/application-window.vala"
	_tmp33_ = chooser;
#line 693 "../src/ui/application-window.vala"
	_tmp34_ = default_name;
#line 693 "../src/ui/application-window.vala"
	gtk_file_chooser_set_current_name ((GtkFileChooser*) _tmp33_, _tmp34_);
#line 695 "../src/ui/application-window.vala"
	_tmp35_ = chooser;
#line 695 "../src/ui/application-window.vala"
	_tmp36_ = g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) _tmp35_));
#line 695 "../src/ui/application-window.vala"
	g_debug ("application-window.vala:695: Showing file chooser (%s)", _tmp36_);
#line 696 "../src/ui/application-window.vala"
	_tmp37_ = chooser;
#line 696 "../src/ui/application-window.vala"
	if (gtk_dialog_run ((GtkDialog*) _tmp37_) == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 3361 "application-window.c"
		GtkFileChooserDialog* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		GtkFileChooserDialog* _tmp41_;
		GFile* _tmp42_;
#line 697 "../src/ui/application-window.vala"
		_tmp38_ = chooser;
#line 697 "../src/ui/application-window.vala"
		_tmp39_ = gtk_file_chooser_get_uri ((GtkFileChooser*) _tmp38_);
#line 697 "../src/ui/application-window.vala"
		_tmp40_ = _tmp39_;
#line 697 "../src/ui/application-window.vala"
		g_debug ("application-window.vala:697: Selected file %s", _tmp40_);
#line 697 "../src/ui/application-window.vala"
		_g_free0 (_tmp40_);
#line 698 "../src/ui/application-window.vala"
		_tmp41_ = chooser;
#line 698 "../src/ui/application-window.vala"
		_tmp42_ = gtk_file_chooser_get_file ((GtkFileChooser*) _tmp41_);
#line 698 "../src/ui/application-window.vala"
		_g_object_unref0 (self->priv->out_file);
#line 698 "../src/ui/application-window.vala"
		self->priv->out_file = _tmp42_;
#line 699 "../src/ui/application-window.vala"
		peek_ui_application_window_try_save_file (self);
#line 3387 "application-window.c"
	} else {
		PeekRecordingScreenRecorder* _tmp43_;
#line 701 "../src/ui/application-window.vala"
		_tmp43_ = self->priv->_recorder;
#line 701 "../src/ui/application-window.vala"
		peek_recording_screen_recorder_cancel (_tmp43_);
#line 702 "../src/ui/application-window.vala"
		peek_ui_application_window_leave_recording_state (self);
#line 3396 "application-window.c"
	}
#line 707 "../src/ui/application-window.vala"
	_tmp44_ = chooser;
#line 707 "../src/ui/application-window.vala"
	g_signal_emit_by_name ((GtkDialog*) _tmp44_, "close");
#line 663 "../src/ui/application-window.vala"
	_g_free0 (default_name);
#line 663 "../src/ui/application-window.vala"
	_g_date_time_unref0 (now);
#line 663 "../src/ui/application-window.vala"
	_g_free0 (folder);
#line 663 "../src/ui/application-window.vala"
	_g_object_unref0 (filter);
#line 663 "../src/ui/application-window.vala"
	_g_free0 (filename);
#line 663 "../src/ui/application-window.vala"
	_g_free0 (extension);
#line 663 "../src/ui/application-window.vala"
	_g_object_unref0 (ok_button);
#line 663 "../src/ui/application-window.vala"
	_g_object_unref0 (chooser);
#line 3418 "application-window.c"
}


static void
peek_ui_application_window_try_save_file (PeekUiApplicationWindow* self)
{
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_;
#line 711 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 712 "../src/ui/application-window.vala"
	_tmp1_ = self->priv->in_file;
#line 712 "../src/ui/application-window.vala"
	if (_tmp1_ == NULL) {
#line 712 "../src/ui/application-window.vala"
		_tmp0_ = TRUE;
#line 3435 "application-window.c"
	} else {
		GFile* _tmp2_;
#line 712 "../src/ui/application-window.vala"
		_tmp2_ = self->priv->out_file;
#line 712 "../src/ui/application-window.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 3442 "application-window.c"
	}
#line 712 "../src/ui/application-window.vala"
	if (_tmp0_) {
#line 713 "../src/ui/application-window.vala"
		return;
#line 3448 "application-window.c"
	}
#line 716 "../src/ui/application-window.vala"
	peek_ui_application_window_save_file (self);
#line 3452 "application-window.c"
}


static void
__lambda6_ (PeekUiApplicationWindow* self,
            GObject* obj,
            GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 721 "../src/ui/application-window.vala"
	g_return_if_fail (res != NULL);
#line 3464 "application-window.c"
	{
		gboolean copy_success = FALSE;
		GFile* _tmp0_;
		gboolean _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GFile* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gboolean _tmp7_;
#line 723 "../src/ui/application-window.vala"
		_tmp0_ = self->priv->in_file;
#line 723 "../src/ui/application-window.vala"
		copy_success = g_file_copy_finish (_tmp0_, res, &_inner_error0_);
#line 723 "../src/ui/application-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3481 "application-window.c"
			goto __catch37_g_error;
		}
#line 724 "../src/ui/application-window.vala"
		_tmp1_ = copy_success;
#line 724 "../src/ui/application-window.vala"
		_tmp2_ = bool_to_string (_tmp1_);
#line 724 "../src/ui/application-window.vala"
		_tmp3_ = _tmp2_;
#line 724 "../src/ui/application-window.vala"
		_tmp4_ = self->priv->out_file;
#line 724 "../src/ui/application-window.vala"
		_tmp5_ = g_file_get_uri (_tmp4_);
#line 724 "../src/ui/application-window.vala"
		_tmp6_ = _tmp5_;
#line 724 "../src/ui/application-window.vala"
		g_debug ("application-window.vala:724: File saved %s: %s", _tmp3_, _tmp6_);
#line 724 "../src/ui/application-window.vala"
		_g_free0 (_tmp6_);
#line 724 "../src/ui/application-window.vala"
		_g_free0 (_tmp3_);
#line 728 "../src/ui/application-window.vala"
		_tmp7_ = copy_success;
#line 728 "../src/ui/application-window.vala"
		if (_tmp7_) {
#line 3506 "application-window.c"
			GFile* _tmp8_;
#line 729 "../src/ui/application-window.vala"
			_tmp8_ = self->priv->out_file;
#line 729 "../src/ui/application-window.vala"
			peek_ui_application_window_handle_saved_file (self, _tmp8_);
#line 3512 "application-window.c"
		} else {
			gchar* message = NULL;
			GFile* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			FILE* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			GError* _tmp17_;
#line 731 "../src/ui/application-window.vala"
			_tmp9_ = self->priv->out_file;
#line 731 "../src/ui/application-window.vala"
			_tmp10_ = g_file_get_uri (_tmp9_);
#line 731 "../src/ui/application-window.vala"
			_tmp11_ = _tmp10_;
#line 731 "../src/ui/application-window.vala"
			_tmp12_ = g_strdup_printf ("Saving file %s failed.", _tmp11_);
#line 731 "../src/ui/application-window.vala"
			_tmp13_ = _tmp12_;
#line 731 "../src/ui/application-window.vala"
			_g_free0 (_tmp11_);
#line 731 "../src/ui/application-window.vala"
			message = _tmp13_;
#line 732 "../src/ui/application-window.vala"
			_tmp14_ = stderr;
#line 732 "../src/ui/application-window.vala"
			_tmp15_ = message;
#line 732 "../src/ui/application-window.vala"
			fprintf (_tmp14_, "%s\n", _tmp15_);
#line 733 "../src/ui/application-window.vala"
			_tmp16_ = message;
#line 733 "../src/ui/application-window.vala"
			_tmp17_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_FAILED, _tmp16_);
#line 733 "../src/ui/application-window.vala"
			_inner_error0_ = _tmp17_;
#line 733 "../src/ui/application-window.vala"
			_g_free0 (message);
#line 3552 "application-window.c"
			goto __catch37_g_error;
		}
	}
	goto __finally37;
	__catch37_g_error:
	{
		GError* e = NULL;
		FILE* _tmp18_;
		GError* _tmp19_;
		const gchar* _tmp20_;
		GError* _tmp21_;
		GtkDialog* _tmp22_;
		GtkDialog* _tmp23_;
#line 722 "../src/ui/application-window.vala"
		e = _inner_error0_;
#line 722 "../src/ui/application-window.vala"
		_inner_error0_ = NULL;
#line 736 "../src/ui/application-window.vala"
		_tmp18_ = stderr;
#line 736 "../src/ui/application-window.vala"
		_tmp19_ = e;
#line 736 "../src/ui/application-window.vala"
		_tmp20_ = _tmp19_->message;
#line 736 "../src/ui/application-window.vala"
		fprintf (_tmp18_, "File save error: %s\n", _tmp20_);
#line 737 "../src/ui/application-window.vala"
		_tmp21_ = e;
#line 737 "../src/ui/application-window.vala"
		_tmp22_ = peek_ui_error_dialog_present_single_instance ((GtkWindow*) self, _ ("The file could not be saved to the selected location."), _tmp21_);
#line 737 "../src/ui/application-window.vala"
		_tmp23_ = _tmp22_;
#line 737 "../src/ui/application-window.vala"
		_g_object_unref0 (_tmp23_);
#line 722 "../src/ui/application-window.vala"
		_g_error_free0 (e);
#line 3588 "application-window.c"
	}
	__finally37:
	{
		GError* _inner_error1_ = NULL;
#line 743 "../src/ui/application-window.vala"
		peek_ui_application_window_leave_recording_state (self);
#line 3595 "application-window.c"
	}
#line 722 "../src/ui/application-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 722 "../src/ui/application-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 722 "../src/ui/application-window.vala"
		g_clear_error (&_inner_error0_);
#line 722 "../src/ui/application-window.vala"
		return;
#line 3605 "application-window.c"
	}
}


static void
___lambda6__gasync_ready_callback (GObject* source_object,
                                   GAsyncResult* res,
                                   gpointer self)
{
#line 720 "../src/ui/application-window.vala"
	__lambda6_ ((PeekUiApplicationWindow*) self, source_object, res);
#line 720 "../src/ui/application-window.vala"
	g_object_unref (self);
#line 3619 "application-window.c"
}


static void
peek_ui_application_window_save_file (PeekUiApplicationWindow* self)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
#line 719 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 720 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->in_file;
#line 720 "../src/ui/application-window.vala"
	_tmp1_ = self->priv->out_file;
#line 720 "../src/ui/application-window.vala"
	g_file_copy_async (_tmp0_, _tmp1_, G_FILE_COPY_OVERWRITE, G_PRIORITY_DEFAULT, NULL, NULL, NULL, ___lambda6__gasync_ready_callback, g_object_ref (self));
#line 3636 "application-window.c"
}


static void
peek_ui_application_window_handle_saved_file (PeekUiApplicationWindow* self,
                                              GFile* file)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 748 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 748 "../src/ui/application-window.vala"
	g_return_if_fail (file != NULL);
#line 749 "../src/ui/application-window.vala"
	peek_ui_application_window_save_preferred_save_folder (self, file);
#line 752 "../src/ui/application-window.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) self);
#line 752 "../src/ui/application-window.vala"
	_tmp2_ = _tmp1_;
#line 752 "../src/ui/application-window.vala"
	if (_tmp2_) {
#line 3659 "application-window.c"
		gboolean _tmp3_;
#line 752 "../src/ui/application-window.vala"
		_tmp3_ = self->priv->_open_file_manager;
#line 752 "../src/ui/application-window.vala"
		_tmp0_ = _tmp3_;
#line 3665 "application-window.c"
	} else {
#line 752 "../src/ui/application-window.vala"
		_tmp0_ = FALSE;
#line 3669 "application-window.c"
	}
#line 752 "../src/ui/application-window.vala"
	if (_tmp0_) {
#line 753 "../src/ui/application-window.vala"
		peek_desktop_integration_launch_file_manager (file);
#line 3675 "application-window.c"
	} else {
#line 755 "../src/ui/application-window.vala"
		peek_ui_application_window_show_file_saved_notification (self, file);
#line 3679 "application-window.c"
	}
}


static void
peek_ui_application_window_show_file_saved_notification (PeekUiApplicationWindow* self,
                                                         GFile* file)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GString* message = NULL;
	GString* _tmp4_;
	GString* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GNotification* notification = NULL;
	GString* _tmp8_;
	const gchar* _tmp9_;
	GNotification* _tmp10_;
	GVariant* parameter = NULL;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GVariant* _tmp13_;
	GVariant* _tmp14_;
	GString* _tmp21_;
	const gchar* _tmp22_;
	GtkApplication* _tmp23_;
	GtkApplication* _tmp24_;
	GNotification* _tmp25_;
#line 762 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 762 "../src/ui/application-window.vala"
	g_return_if_fail (file != NULL);
#line 763 "../src/ui/application-window.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) self);
#line 763 "../src/ui/application-window.vala"
	_tmp2_ = _tmp1_;
#line 763 "../src/ui/application-window.vala"
	if (_tmp2_) {
#line 3720 "application-window.c"
		gboolean _tmp3_;
#line 763 "../src/ui/application-window.vala"
		_tmp3_ = self->priv->_show_notification;
#line 763 "../src/ui/application-window.vala"
		_tmp0_ = !_tmp3_;
#line 3726 "application-window.c"
	} else {
#line 763 "../src/ui/application-window.vala"
		_tmp0_ = FALSE;
#line 3730 "application-window.c"
	}
#line 763 "../src/ui/application-window.vala"
	if (_tmp0_) {
#line 763 "../src/ui/application-window.vala"
		return;
#line 3736 "application-window.c"
	}
#line 765 "../src/ui/application-window.vala"
	_tmp4_ = g_string_new ("");
#line 765 "../src/ui/application-window.vala"
	message = _tmp4_;
#line 766 "../src/ui/application-window.vala"
	_tmp5_ = message;
#line 766 "../src/ui/application-window.vala"
	_tmp6_ = g_file_get_basename (file);
#line 766 "../src/ui/application-window.vala"
	_tmp7_ = _tmp6_;
#line 766 "../src/ui/application-window.vala"
	g_string_printf (_tmp5_, _ ("Animation saved as “%s”"), _tmp7_);
#line 766 "../src/ui/application-window.vala"
	_g_free0 (_tmp7_);
#line 768 "../src/ui/application-window.vala"
	_tmp8_ = message;
#line 768 "../src/ui/application-window.vala"
	_tmp9_ = _tmp8_->str;
#line 768 "../src/ui/application-window.vala"
	_tmp10_ = peek_ui_application_window_build_standard_notification (_tmp9_);
#line 768 "../src/ui/application-window.vala"
	notification = _tmp10_;
#line 771 "../src/ui/application-window.vala"
	_tmp11_ = g_file_get_uri (file);
#line 771 "../src/ui/application-window.vala"
	_tmp12_ = _tmp11_;
#line 771 "../src/ui/application-window.vala"
	_tmp13_ = g_variant_new_string (_tmp12_);
#line 771 "../src/ui/application-window.vala"
	g_variant_ref_sink (_tmp13_);
#line 771 "../src/ui/application-window.vala"
	_tmp14_ = _tmp13_;
#line 771 "../src/ui/application-window.vala"
	_g_free0 (_tmp12_);
#line 771 "../src/ui/application-window.vala"
	parameter = _tmp14_;
#line 775 "../src/ui/application-window.vala"
	if (!peek_desktop_integration_is_unity ()) {
#line 3776 "application-window.c"
		GNotification* _tmp15_;
		GNotification* _tmp16_;
		GVariant* _tmp17_;
		gboolean _tmp18_ = FALSE;
#line 776 "../src/ui/application-window.vala"
		_tmp15_ = notification;
#line 776 "../src/ui/application-window.vala"
		g_notification_set_body (_tmp15_, _ ("Click here to show the saved file in your file manager."));
#line 777 "../src/ui/application-window.vala"
		_tmp16_ = notification;
#line 777 "../src/ui/application-window.vala"
		_tmp17_ = parameter;
#line 777 "../src/ui/application-window.vala"
		g_notification_add_button_with_target_value (_tmp16_, _ ("Show in file manager"), "app.show-file", _tmp17_);
#line 783 "../src/ui/application-window.vala"
		if (!peek_desktop_integration_is_plasma ()) {
#line 784 "../src/ui/application-window.vala"
			_tmp18_ = !peek_desktop_integration_is_xfce ();
#line 3795 "application-window.c"
		} else {
#line 783 "../src/ui/application-window.vala"
			_tmp18_ = FALSE;
#line 3799 "application-window.c"
		}
#line 783 "../src/ui/application-window.vala"
		if (_tmp18_) {
#line 3803 "application-window.c"
			GNotification* _tmp19_;
			GVariant* _tmp20_;
#line 785 "../src/ui/application-window.vala"
			_tmp19_ = notification;
#line 785 "../src/ui/application-window.vala"
			_tmp20_ = parameter;
#line 785 "../src/ui/application-window.vala"
			g_notification_set_default_action_and_target_value (_tmp19_, "app.show-file", _tmp20_);
#line 3812 "application-window.c"
		}
	}
#line 792 "../src/ui/application-window.vala"
	_tmp21_ = message;
#line 792 "../src/ui/application-window.vala"
	_tmp22_ = _tmp21_->str;
#line 792 "../src/ui/application-window.vala"
	g_debug ("application-window.vala:792: Showing desktop notification: %s", _tmp22_);
#line 793 "../src/ui/application-window.vala"
	_tmp23_ = gtk_window_get_application ((GtkWindow*) self);
#line 793 "../src/ui/application-window.vala"
	_tmp24_ = _tmp23_;
#line 793 "../src/ui/application-window.vala"
	_tmp25_ = notification;
#line 793 "../src/ui/application-window.vala"
	g_application_send_notification ((GApplication*) _tmp24_, "peek-file-saved", _tmp25_);
#line 762 "../src/ui/application-window.vala"
	_g_variant_unref0 (parameter);
#line 762 "../src/ui/application-window.vala"
	_g_object_unref0 (notification);
#line 762 "../src/ui/application-window.vala"
	_g_string_free0 (message);
#line 3835 "application-window.c"
}


static GNotification*
peek_ui_application_window_build_standard_notification (const gchar* message)
{
	GNotification* result = NULL;
	GNotification* notification = NULL;
	GNotification* _tmp0_;
#line 796 "../src/ui/application-window.vala"
	g_return_val_if_fail (message != NULL, NULL);
#line 797 "../src/ui/application-window.vala"
	_tmp0_ = g_notification_new (message);
#line 797 "../src/ui/application-window.vala"
	notification = _tmp0_;
#line 799 "../src/ui/application-window.vala"
	if (!peek_desktop_integration_is_cinnamon ()) {
#line 3853 "application-window.c"
		GNotification* _tmp1_;
		GThemedIcon* _tmp2_;
		GThemedIcon* _tmp3_;
#line 800 "../src/ui/application-window.vala"
		_tmp1_ = notification;
#line 800 "../src/ui/application-window.vala"
		_tmp2_ = (GThemedIcon*) g_themed_icon_new (PEEK_APP_ID);
#line 800 "../src/ui/application-window.vala"
		_tmp3_ = _tmp2_;
#line 800 "../src/ui/application-window.vala"
		g_notification_set_icon (_tmp1_, (GIcon*) _tmp3_);
#line 800 "../src/ui/application-window.vala"
		_g_object_unref0 (_tmp3_);
#line 3867 "application-window.c"
	} else {
		GtkIconTheme* icon_theme = NULL;
		GtkIconTheme* _tmp4_;
		GtkIconTheme* _tmp5_;
		GtkIconInfo* icon_info = NULL;
		GtkIconTheme* _tmp6_;
		GtkIconInfo* _tmp7_;
		gchar* icon_path = NULL;
		GtkIconInfo* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
#line 802 "../src/ui/application-window.vala"
		_tmp4_ = gtk_icon_theme_get_default ();
#line 802 "../src/ui/application-window.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 802 "../src/ui/application-window.vala"
		icon_theme = _tmp5_;
#line 803 "../src/ui/application-window.vala"
		_tmp6_ = icon_theme;
#line 803 "../src/ui/application-window.vala"
		_tmp7_ = gtk_icon_theme_lookup_icon (_tmp6_, PEEK_APP_ID, 48, 0);
#line 803 "../src/ui/application-window.vala"
		icon_info = _tmp7_;
#line 804 "../src/ui/application-window.vala"
		_tmp8_ = icon_info;
#line 804 "../src/ui/application-window.vala"
		_tmp9_ = gtk_icon_info_get_filename (_tmp8_);
#line 804 "../src/ui/application-window.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 804 "../src/ui/application-window.vala"
		icon_path = _tmp10_;
#line 805 "../src/ui/application-window.vala"
		_tmp11_ = icon_path;
#line 805 "../src/ui/application-window.vala"
		g_debug ("application-window.vala:805: Using notification icon: %s", _tmp11_);
#line 806 "../src/ui/application-window.vala"
		_tmp12_ = icon_path;
#line 806 "../src/ui/application-window.vala"
		if (_tmp12_ != NULL) {
#line 3909 "application-window.c"
			GFileIcon* icon = NULL;
			const gchar* _tmp13_;
			GFile* _tmp14_;
			GFile* _tmp15_;
			GFileIcon* _tmp16_;
			GFileIcon* _tmp17_;
			GNotification* _tmp18_;
			GFileIcon* _tmp19_;
#line 807 "../src/ui/application-window.vala"
			_tmp13_ = icon_path;
#line 807 "../src/ui/application-window.vala"
			_tmp14_ = g_file_new_for_path (_tmp13_);
#line 807 "../src/ui/application-window.vala"
			_tmp15_ = _tmp14_;
#line 807 "../src/ui/application-window.vala"
			_tmp16_ = (GFileIcon*) g_file_icon_new (_tmp15_);
#line 807 "../src/ui/application-window.vala"
			_tmp17_ = _tmp16_;
#line 807 "../src/ui/application-window.vala"
			_g_object_unref0 (_tmp15_);
#line 807 "../src/ui/application-window.vala"
			icon = _tmp17_;
#line 808 "../src/ui/application-window.vala"
			_tmp18_ = notification;
#line 808 "../src/ui/application-window.vala"
			_tmp19_ = icon;
#line 808 "../src/ui/application-window.vala"
			g_notification_set_icon (_tmp18_, (GIcon*) _tmp19_);
#line 806 "../src/ui/application-window.vala"
			_g_object_unref0 (icon);
#line 3940 "application-window.c"
		}
#line 799 "../src/ui/application-window.vala"
		_g_free0 (icon_path);
#line 799 "../src/ui/application-window.vala"
		_gtk_icon_info_free0 (icon_info);
#line 799 "../src/ui/application-window.vala"
		_g_object_unref0 (icon_theme);
#line 3948 "application-window.c"
	}
#line 812 "../src/ui/application-window.vala"
	result = notification;
#line 812 "../src/ui/application-window.vala"
	return result;
#line 3954 "application-window.c"
}


static gchar*
peek_ui_application_window_load_preferred_save_folder (PeekUiApplicationWindow* self)
{
	gchar* result = NULL;
	gchar* folder = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
#line 815 "../src/ui/application-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 816 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->_save_folder;
#line 816 "../src/ui/application-window.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 816 "../src/ui/application-window.vala"
	folder = _tmp1_;
#line 818 "../src/ui/application-window.vala"
	_tmp4_ = folder;
#line 818 "../src/ui/application-window.vala"
	if (_tmp4_ == NULL) {
#line 818 "../src/ui/application-window.vala"
		_tmp3_ = TRUE;
#line 3982 "application-window.c"
	} else {
		const gchar* _tmp5_;
#line 818 "../src/ui/application-window.vala"
		_tmp5_ = folder;
#line 818 "../src/ui/application-window.vala"
		_tmp3_ = g_strcmp0 (_tmp5_, "") == 0;
#line 3989 "application-window.c"
	}
#line 818 "../src/ui/application-window.vala"
	if (_tmp3_) {
#line 818 "../src/ui/application-window.vala"
		_tmp2_ = TRUE;
#line 3995 "application-window.c"
	} else {
		const gchar* _tmp6_;
#line 819 "../src/ui/application-window.vala"
		_tmp6_ = folder;
#line 819 "../src/ui/application-window.vala"
		_tmp2_ = !g_file_test (_tmp6_, G_FILE_TEST_IS_DIR);
#line 4002 "application-window.c"
	}
#line 818 "../src/ui/application-window.vala"
	if (_tmp2_) {
#line 4006 "application-window.c"
		gchar* _tmp7_;
#line 820 "../src/ui/application-window.vala"
		_tmp7_ = peek_desktop_integration_get_video_folder ();
#line 820 "../src/ui/application-window.vala"
		_g_free0 (folder);
#line 820 "../src/ui/application-window.vala"
		folder = _tmp7_;
#line 4014 "application-window.c"
	}
#line 823 "../src/ui/application-window.vala"
	result = folder;
#line 823 "../src/ui/application-window.vala"
	return result;
#line 4020 "application-window.c"
}


static void
peek_ui_application_window_save_preferred_save_folder (PeekUiApplicationWindow* self,
                                                       GFile* out_file)
{
#line 826 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 826 "../src/ui/application-window.vala"
	g_return_if_fail (out_file != NULL);
#line 827 "../src/ui/application-window.vala"
	if (g_file_has_uri_scheme (out_file, "file")) {
#line 4034 "application-window.c"
		GFile* parent = NULL;
		GFile* _tmp0_;
		gchar* new_folder = NULL;
		GFile* _tmp1_;
		gchar* _tmp2_;
		gchar* default_folder = NULL;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
#line 828 "../src/ui/application-window.vala"
		_tmp0_ = g_file_get_parent (out_file);
#line 828 "../src/ui/application-window.vala"
		parent = _tmp0_;
#line 829 "../src/ui/application-window.vala"
		_tmp1_ = parent;
#line 829 "../src/ui/application-window.vala"
		_tmp2_ = g_file_get_path (_tmp1_);
#line 829 "../src/ui/application-window.vala"
		new_folder = _tmp2_;
#line 830 "../src/ui/application-window.vala"
		_tmp3_ = peek_desktop_integration_get_video_folder ();
#line 830 "../src/ui/application-window.vala"
		default_folder = _tmp3_;
#line 832 "../src/ui/application-window.vala"
		_tmp4_ = new_folder;
#line 832 "../src/ui/application-window.vala"
		_tmp5_ = default_folder;
#line 832 "../src/ui/application-window.vala"
		if (g_strcmp0 (_tmp4_, _tmp5_) != 0) {
#line 4064 "application-window.c"
			const gchar* _tmp6_;
#line 833 "../src/ui/application-window.vala"
			_tmp6_ = new_folder;
#line 833 "../src/ui/application-window.vala"
			peek_ui_application_window_set_save_folder (self, _tmp6_);
#line 4070 "application-window.c"
		}
#line 827 "../src/ui/application-window.vala"
		_g_free0 (default_folder);
#line 827 "../src/ui/application-window.vala"
		_g_free0 (new_folder);
#line 827 "../src/ui/application-window.vala"
		_g_object_unref0 (parent);
#line 4078 "application-window.c"
	}
}


static void
peek_ui_application_window_load_geometry (PeekUiApplicationWindow* self)
{
	GVariant* geom = NULL;
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	gint x = 0;
	gint y = 0;
	gint w = 0;
	gint h = 0;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	GVariant* _tmp6_;
	GVariant* _tmp7_;
	GVariant* _tmp8_;
	GVariant* _tmp9_;
	GVariant* _tmp10_;
	GVariant* _tmp11_;
	GVariant* _tmp12_;
	GVariant* _tmp13_;
	gboolean _tmp14_ = FALSE;
	gint _tmp15_;
	gboolean _tmp17_ = FALSE;
	gint _tmp18_;
	gint _tmp22_;
	gint _tmp23_;
#line 838 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 839 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->settings;
#line 839 "../src/ui/application-window.vala"
	_tmp1_ = g_settings_get_value (_tmp0_, "persist-window-geometry");
#line 839 "../src/ui/application-window.vala"
	geom = _tmp1_;
#line 840 "../src/ui/application-window.vala"
	x = 0;
#line 841 "../src/ui/application-window.vala"
	y = 0;
#line 842 "../src/ui/application-window.vala"
	w = 0;
#line 843 "../src/ui/application-window.vala"
	h = 0;
#line 844 "../src/ui/application-window.vala"
	_tmp2_ = geom;
#line 844 "../src/ui/application-window.vala"
	_tmp3_ = g_variant_get_child_value (_tmp2_, (gsize) 0);
#line 844 "../src/ui/application-window.vala"
	_tmp4_ = _tmp3_;
#line 844 "../src/ui/application-window.vala"
	x = (gint) g_variant_get_int32 (_tmp4_);
#line 844 "../src/ui/application-window.vala"
	_g_variant_unref0 (_tmp4_);
#line 845 "../src/ui/application-window.vala"
	_tmp5_ = geom;
#line 845 "../src/ui/application-window.vala"
	_tmp6_ = g_variant_get_child_value (_tmp5_, (gsize) 1);
#line 845 "../src/ui/application-window.vala"
	_tmp7_ = _tmp6_;
#line 845 "../src/ui/application-window.vala"
	y = (gint) g_variant_get_int32 (_tmp7_);
#line 845 "../src/ui/application-window.vala"
	_g_variant_unref0 (_tmp7_);
#line 846 "../src/ui/application-window.vala"
	_tmp8_ = geom;
#line 846 "../src/ui/application-window.vala"
	_tmp9_ = g_variant_get_child_value (_tmp8_, (gsize) 2);
#line 846 "../src/ui/application-window.vala"
	_tmp10_ = _tmp9_;
#line 846 "../src/ui/application-window.vala"
	w = (gint) g_variant_get_int32 (_tmp10_);
#line 846 "../src/ui/application-window.vala"
	_g_variant_unref0 (_tmp10_);
#line 847 "../src/ui/application-window.vala"
	_tmp11_ = geom;
#line 847 "../src/ui/application-window.vala"
	_tmp12_ = g_variant_get_child_value (_tmp11_, (gsize) 3);
#line 847 "../src/ui/application-window.vala"
	_tmp13_ = _tmp12_;
#line 847 "../src/ui/application-window.vala"
	h = (gint) g_variant_get_int32 (_tmp13_);
#line 847 "../src/ui/application-window.vala"
	_g_variant_unref0 (_tmp13_);
#line 848 "../src/ui/application-window.vala"
	_tmp15_ = w;
#line 848 "../src/ui/application-window.vala"
	if (_tmp15_ == 0) {
#line 848 "../src/ui/application-window.vala"
		_tmp14_ = TRUE;
#line 4173 "application-window.c"
	} else {
		gint _tmp16_;
#line 848 "../src/ui/application-window.vala"
		_tmp16_ = h;
#line 848 "../src/ui/application-window.vala"
		_tmp14_ = _tmp16_ == 0;
#line 4180 "application-window.c"
	}
#line 848 "../src/ui/application-window.vala"
	if (_tmp14_) {
#line 849 "../src/ui/application-window.vala"
		_g_variant_unref0 (geom);
#line 849 "../src/ui/application-window.vala"
		return;
#line 4188 "application-window.c"
	}
#line 851 "../src/ui/application-window.vala"
	_tmp18_ = x;
#line 851 "../src/ui/application-window.vala"
	if (_tmp18_ >= 0) {
#line 4194 "application-window.c"
		gint _tmp19_;
#line 851 "../src/ui/application-window.vala"
		_tmp19_ = y;
#line 851 "../src/ui/application-window.vala"
		_tmp17_ = _tmp19_ >= 0;
#line 4200 "application-window.c"
	} else {
#line 851 "../src/ui/application-window.vala"
		_tmp17_ = FALSE;
#line 4204 "application-window.c"
	}
#line 851 "../src/ui/application-window.vala"
	if (_tmp17_) {
#line 4208 "application-window.c"
		gint _tmp20_;
		gint _tmp21_;
#line 852 "../src/ui/application-window.vala"
		_tmp20_ = x;
#line 852 "../src/ui/application-window.vala"
		_tmp21_ = y;
#line 852 "../src/ui/application-window.vala"
		gtk_window_move ((GtkWindow*) self, _tmp20_, _tmp21_);
#line 4217 "application-window.c"
	}
#line 855 "../src/ui/application-window.vala"
	_tmp22_ = w;
#line 855 "../src/ui/application-window.vala"
	_tmp23_ = h;
#line 855 "../src/ui/application-window.vala"
	gtk_window_resize ((GtkWindow*) self, _tmp22_, _tmp23_);
#line 838 "../src/ui/application-window.vala"
	_g_variant_unref0 (geom);
#line 4227 "application-window.c"
}


static void
peek_ui_application_window_save_geometry (PeekUiApplicationWindow* self)
{
	GVariantBuilder* builder = NULL;
	const GVariantType* _tmp0_;
	GVariantBuilder* _tmp1_;
	gint x = 0;
	gint y = 0;
	gint w = 0;
	gint h = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gint _tmp6_;
	GVariant* _tmp7_;
	GVariant* _tmp8_;
	gint _tmp9_;
	GVariant* _tmp10_;
	GVariant* _tmp11_;
	gint _tmp12_;
	GVariant* _tmp13_;
	GVariant* _tmp14_;
	gint _tmp15_;
	GVariant* _tmp16_;
	GVariant* _tmp17_;
	GSettings* _tmp18_;
	GVariant* _tmp19_;
	GVariant* _tmp20_;
#line 858 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 859 "../src/ui/application-window.vala"
	_tmp0_ = G_VARIANT_TYPE_TUPLE;
#line 859 "../src/ui/application-window.vala"
	_tmp1_ = g_variant_builder_new (_tmp0_);
#line 859 "../src/ui/application-window.vala"
	builder = _tmp1_;
#line 860 "../src/ui/application-window.vala"
	x = 0;
#line 861 "../src/ui/application-window.vala"
	y = 0;
#line 862 "../src/ui/application-window.vala"
	w = 0;
#line 863 "../src/ui/application-window.vala"
	h = 0;
#line 864 "../src/ui/application-window.vala"
	gtk_window_get_position ((GtkWindow*) self, &_tmp2_, &_tmp3_);
#line 864 "../src/ui/application-window.vala"
	x = _tmp2_;
#line 864 "../src/ui/application-window.vala"
	y = _tmp3_;
#line 865 "../src/ui/application-window.vala"
	gtk_window_get_size ((GtkWindow*) self, &_tmp4_, &_tmp5_);
#line 865 "../src/ui/application-window.vala"
	w = _tmp4_;
#line 865 "../src/ui/application-window.vala"
	h = _tmp5_;
#line 866 "../src/ui/application-window.vala"
	_tmp6_ = x;
#line 866 "../src/ui/application-window.vala"
	_tmp7_ = g_variant_new_int32 ((gint32) _tmp6_);
#line 866 "../src/ui/application-window.vala"
	g_variant_ref_sink (_tmp7_);
#line 866 "../src/ui/application-window.vala"
	_tmp8_ = _tmp7_;
#line 866 "../src/ui/application-window.vala"
	g_variant_builder_add_value (builder, _tmp8_);
#line 866 "../src/ui/application-window.vala"
	_g_variant_unref0 (_tmp8_);
#line 867 "../src/ui/application-window.vala"
	_tmp9_ = y;
#line 867 "../src/ui/application-window.vala"
	_tmp10_ = g_variant_new_int32 ((gint32) _tmp9_);
#line 867 "../src/ui/application-window.vala"
	g_variant_ref_sink (_tmp10_);
#line 867 "../src/ui/application-window.vala"
	_tmp11_ = _tmp10_;
#line 867 "../src/ui/application-window.vala"
	g_variant_builder_add_value (builder, _tmp11_);
#line 867 "../src/ui/application-window.vala"
	_g_variant_unref0 (_tmp11_);
#line 868 "../src/ui/application-window.vala"
	_tmp12_ = w;
#line 868 "../src/ui/application-window.vala"
	_tmp13_ = g_variant_new_int32 ((gint32) _tmp12_);
#line 868 "../src/ui/application-window.vala"
	g_variant_ref_sink (_tmp13_);
#line 868 "../src/ui/application-window.vala"
	_tmp14_ = _tmp13_;
#line 868 "../src/ui/application-window.vala"
	g_variant_builder_add_value (builder, _tmp14_);
#line 868 "../src/ui/application-window.vala"
	_g_variant_unref0 (_tmp14_);
#line 869 "../src/ui/application-window.vala"
	_tmp15_ = h;
#line 869 "../src/ui/application-window.vala"
	_tmp16_ = g_variant_new_int32 ((gint32) _tmp15_);
#line 869 "../src/ui/application-window.vala"
	g_variant_ref_sink (_tmp16_);
#line 869 "../src/ui/application-window.vala"
	_tmp17_ = _tmp16_;
#line 869 "../src/ui/application-window.vala"
	g_variant_builder_add_value (builder, _tmp17_);
#line 869 "../src/ui/application-window.vala"
	_g_variant_unref0 (_tmp17_);
#line 870 "../src/ui/application-window.vala"
	_tmp18_ = self->priv->settings;
#line 870 "../src/ui/application-window.vala"
	_tmp19_ = g_variant_builder_end (builder);
#line 870 "../src/ui/application-window.vala"
	g_variant_ref_sink (_tmp19_);
#line 870 "../src/ui/application-window.vala"
	_tmp20_ = _tmp19_;
#line 870 "../src/ui/application-window.vala"
	g_settings_set_value (_tmp18_, "persist-window-geometry", _tmp20_);
#line 870 "../src/ui/application-window.vala"
	_g_variant_unref0 (_tmp20_);
#line 858 "../src/ui/application-window.vala"
	_g_variant_builder_unref0 (builder);
#line 4350 "application-window.c"
}


static gint
peek_ui_application_window_get_window_width (PeekUiApplicationWindow* self)
{
	gint result = 0;
	gint w = 0;
	gint h = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
#line 873 "../src/ui/application-window.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 875 "../src/ui/application-window.vala"
	gtk_window_get_size ((GtkWindow*) self, &_tmp0_, &_tmp1_);
#line 875 "../src/ui/application-window.vala"
	w = _tmp0_;
#line 875 "../src/ui/application-window.vala"
	h = _tmp1_;
#line 876 "../src/ui/application-window.vala"
	result = w;
#line 876 "../src/ui/application-window.vala"
	return result;
#line 4374 "application-window.c"
}


static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1474 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1474 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1474 "glib-2.0.vapi"
	return result;
#line 4394 "application-window.c"
}


static void
peek_ui_application_window_set_close_button_position (PeekUiApplicationWindow* self)
{
	GtkSettings* settings = NULL;
	GtkSettings* _tmp0_;
	GtkSettings* _tmp1_;
	gchar* _tmp2_ = NULL;
	GtkSettings* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* decoration_layout = NULL;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
#line 879 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 880 "../src/ui/application-window.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 880 "../src/ui/application-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 880 "../src/ui/application-window.vala"
	settings = _tmp1_;
#line 881 "../src/ui/application-window.vala"
	_tmp3_ = settings;
#line 881 "../src/ui/application-window.vala"
	g_object_get (_tmp3_, "gtk-decoration-layout", &_tmp4_, NULL);
#line 881 "../src/ui/application-window.vala"
	_tmp5_ = _tmp4_;
#line 881 "../src/ui/application-window.vala"
	_tmp2_ = _tmp5_;
#line 881 "../src/ui/application-window.vala"
	if (_tmp2_ == NULL) {
#line 4430 "application-window.c"
		gchar* _tmp6_;
#line 881 "../src/ui/application-window.vala"
		_tmp6_ = g_strdup ("");
#line 881 "../src/ui/application-window.vala"
		_g_free0 (_tmp2_);
#line 881 "../src/ui/application-window.vala"
		_tmp2_ = _tmp6_;
#line 4438 "application-window.c"
	}
#line 881 "../src/ui/application-window.vala"
	_tmp7_ = _tmp2_;
#line 881 "../src/ui/application-window.vala"
	_tmp2_ = NULL;
#line 881 "../src/ui/application-window.vala"
	decoration_layout = _tmp7_;
#line 882 "../src/ui/application-window.vala"
	_tmp8_ = decoration_layout;
#line 882 "../src/ui/application-window.vala"
	g_debug ("application-window.vala:882: Decoration layout: %s", _tmp8_);
#line 884 "../src/ui/application-window.vala"
	_tmp9_ = decoration_layout;
#line 884 "../src/ui/application-window.vala"
	if (string_contains (_tmp9_, ":")) {
#line 4454 "application-window.c"
		gchar** decoration = NULL;
		const gchar* _tmp10_;
		gchar** _tmp11_;
		gchar** _tmp12_;
		gint decoration_length1;
		gint _decoration_size_;
		gchar** _tmp13_;
		gint _tmp13__length1;
		const gchar* _tmp14_;
#line 885 "../src/ui/application-window.vala"
		_tmp10_ = decoration_layout;
#line 885 "../src/ui/application-window.vala"
		_tmp12_ = _tmp11_ = g_strsplit (_tmp10_, ":", 2);
#line 885 "../src/ui/application-window.vala"
		decoration = _tmp12_;
#line 885 "../src/ui/application-window.vala"
		decoration_length1 = _vala_array_length (_tmp11_);
#line 885 "../src/ui/application-window.vala"
		_decoration_size_ = decoration_length1;
#line 886 "../src/ui/application-window.vala"
		_tmp13_ = decoration;
#line 886 "../src/ui/application-window.vala"
		_tmp13__length1 = decoration_length1;
#line 886 "../src/ui/application-window.vala"
		_tmp14_ = _tmp13_[0];
#line 886 "../src/ui/application-window.vala"
		if (string_contains (_tmp14_, "close")) {
#line 887 "../src/ui/application-window.vala"
			peek_ui_application_window_move_close_button_left (self);
#line 4484 "application-window.c"
		}
#line 884 "../src/ui/application-window.vala"
		decoration = (_vala_array_free (decoration, decoration_length1, (GDestroyNotify) g_free), NULL);
#line 4488 "application-window.c"
	}
#line 879 "../src/ui/application-window.vala"
	_g_free0 (decoration_layout);
#line 879 "../src/ui/application-window.vala"
	_g_free0 (_tmp2_);
#line 879 "../src/ui/application-window.vala"
	_g_object_unref0 (settings);
#line 4496 "application-window.c"
}


static void
peek_ui_application_window_move_close_button_left (PeekUiApplicationWindow* self)
{
	gchar** decoration = NULL;
	GtkHeaderBar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint decoration_length1;
	gint _decoration_size_;
	gboolean _tmp5_ = FALSE;
	gchar** _tmp6_;
	gint _tmp6__length1;
#line 892 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 893 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->headerbar;
#line 893 "../src/ui/application-window.vala"
	_tmp1_ = gtk_header_bar_get_decoration_layout (_tmp0_);
#line 893 "../src/ui/application-window.vala"
	_tmp2_ = _tmp1_;
#line 893 "../src/ui/application-window.vala"
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, ":", 2);
#line 893 "../src/ui/application-window.vala"
	decoration = _tmp4_;
#line 893 "../src/ui/application-window.vala"
	decoration_length1 = _vala_array_length (_tmp3_);
#line 893 "../src/ui/application-window.vala"
	_decoration_size_ = decoration_length1;
#line 894 "../src/ui/application-window.vala"
	_tmp6_ = decoration;
#line 894 "../src/ui/application-window.vala"
	_tmp6__length1 = decoration_length1;
#line 894 "../src/ui/application-window.vala"
	if (_tmp6__length1 == 2) {
#line 4536 "application-window.c"
		gchar** _tmp7_;
		gint _tmp7__length1;
		const gchar* _tmp8_;
#line 894 "../src/ui/application-window.vala"
		_tmp7_ = decoration;
#line 894 "../src/ui/application-window.vala"
		_tmp7__length1 = decoration_length1;
#line 894 "../src/ui/application-window.vala"
		_tmp8_ = _tmp7_[1];
#line 894 "../src/ui/application-window.vala"
		_tmp5_ = string_contains (_tmp8_, "close");
#line 4548 "application-window.c"
	} else {
#line 894 "../src/ui/application-window.vala"
		_tmp5_ = FALSE;
#line 4552 "application-window.c"
	}
#line 894 "../src/ui/application-window.vala"
	if (_tmp5_) {
#line 4556 "application-window.c"
		GtkHeaderBar* _tmp9_;
		gchar** _tmp10_;
		gint _tmp10__length1;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar** _tmp14_;
		gint _tmp14__length1;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 895 "../src/ui/application-window.vala"
		_tmp9_ = self->priv->headerbar;
#line 895 "../src/ui/application-window.vala"
		_tmp10_ = decoration;
#line 895 "../src/ui/application-window.vala"
		_tmp10__length1 = decoration_length1;
#line 895 "../src/ui/application-window.vala"
		_tmp11_ = _tmp10_[1];
#line 895 "../src/ui/application-window.vala"
		_tmp12_ = g_strconcat (_tmp11_, ":", NULL);
#line 895 "../src/ui/application-window.vala"
		_tmp13_ = _tmp12_;
#line 895 "../src/ui/application-window.vala"
		_tmp14_ = decoration;
#line 895 "../src/ui/application-window.vala"
		_tmp14__length1 = decoration_length1;
#line 895 "../src/ui/application-window.vala"
		_tmp15_ = _tmp14_[0];
#line 895 "../src/ui/application-window.vala"
		_tmp16_ = g_strconcat (_tmp13_, _tmp15_, NULL);
#line 895 "../src/ui/application-window.vala"
		_tmp17_ = _tmp16_;
#line 895 "../src/ui/application-window.vala"
		gtk_header_bar_set_decoration_layout (_tmp9_, _tmp17_);
#line 895 "../src/ui/application-window.vala"
		_g_free0 (_tmp17_);
#line 895 "../src/ui/application-window.vala"
		_g_free0 (_tmp13_);
#line 4596 "application-window.c"
	}
#line 892 "../src/ui/application-window.vala"
	decoration = (_vala_array_free (decoration, decoration_length1, (GDestroyNotify) g_free), NULL);
#line 4600 "application-window.c"
}


PeekRecordingScreenRecorder*
peek_ui_application_window_get_recorder (PeekUiApplicationWindow* self)
{
	PeekRecordingScreenRecorder* result;
	PeekRecordingScreenRecorder* _tmp0_;
#line 21 "../src/ui/application-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 21 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->_recorder;
#line 21 "../src/ui/application-window.vala"
	result = _tmp0_;
#line 21 "../src/ui/application-window.vala"
	return result;
#line 4617 "application-window.c"
}


void
peek_ui_application_window_set_recorder (PeekUiApplicationWindow* self,
                                         PeekRecordingScreenRecorder* value)
{
#line 21 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/ui/application-window.vala"
	if (peek_ui_application_window_get_recorder (self) != value) {
#line 4629 "application-window.c"
		PeekRecordingScreenRecorder* _tmp0_;
#line 21 "../src/ui/application-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 21 "../src/ui/application-window.vala"
		_g_object_unref0 (self->priv->_recorder);
#line 21 "../src/ui/application-window.vala"
		self->priv->_recorder = _tmp0_;
#line 21 "../src/ui/application-window.vala"
		g_object_notify_by_pspec ((GObject *) self, peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_RECORDER_PROPERTY]);
#line 4639 "application-window.c"
	}
}


gboolean
peek_ui_application_window_get_open_file_manager (PeekUiApplicationWindow* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 23 "../src/ui/application-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 23 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->_open_file_manager;
#line 23 "../src/ui/application-window.vala"
	result = _tmp0_;
#line 23 "../src/ui/application-window.vala"
	return result;
#line 4657 "application-window.c"
}


void
peek_ui_application_window_set_open_file_manager (PeekUiApplicationWindow* self,
                                                  gboolean value)
{
#line 23 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/ui/application-window.vala"
	if (peek_ui_application_window_get_open_file_manager (self) != value) {
#line 23 "../src/ui/application-window.vala"
		self->priv->_open_file_manager = value;
#line 23 "../src/ui/application-window.vala"
		g_object_notify_by_pspec ((GObject *) self, peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_OPEN_FILE_MANAGER_PROPERTY]);
#line 4673 "application-window.c"
	}
}


gboolean
peek_ui_application_window_get_show_notification (PeekUiApplicationWindow* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 25 "../src/ui/application-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 25 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->_show_notification;
#line 25 "../src/ui/application-window.vala"
	result = _tmp0_;
#line 25 "../src/ui/application-window.vala"
	return result;
#line 4691 "application-window.c"
}


void
peek_ui_application_window_set_show_notification (PeekUiApplicationWindow* self,
                                                  gboolean value)
{
#line 25 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/ui/application-window.vala"
	if (peek_ui_application_window_get_show_notification (self) != value) {
#line 25 "../src/ui/application-window.vala"
		self->priv->_show_notification = value;
#line 25 "../src/ui/application-window.vala"
		g_object_notify_by_pspec ((GObject *) self, peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_SHOW_NOTIFICATION_PROPERTY]);
#line 4707 "application-window.c"
	}
}


gint
peek_ui_application_window_get_size_indicator_delay (PeekUiApplicationWindow* self)
{
	gint result;
	gint _tmp0_;
#line 27 "../src/ui/application-window.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 27 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->_size_indicator_delay;
#line 27 "../src/ui/application-window.vala"
	result = _tmp0_;
#line 27 "../src/ui/application-window.vala"
	return result;
#line 4725 "application-window.c"
}


void
peek_ui_application_window_set_size_indicator_delay (PeekUiApplicationWindow* self,
                                                     gint value)
{
#line 27 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/ui/application-window.vala"
	if (peek_ui_application_window_get_size_indicator_delay (self) != value) {
#line 27 "../src/ui/application-window.vala"
		self->priv->_size_indicator_delay = value;
#line 27 "../src/ui/application-window.vala"
		g_object_notify_by_pspec ((GObject *) self, peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_SIZE_INDICATOR_DELAY_PROPERTY]);
#line 4741 "application-window.c"
	}
}


gint
peek_ui_application_window_get_recording_start_delay (PeekUiApplicationWindow* self)
{
	gint result;
	gint _tmp0_;
#line 29 "../src/ui/application-window.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 29 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->_recording_start_delay;
#line 29 "../src/ui/application-window.vala"
	result = _tmp0_;
#line 29 "../src/ui/application-window.vala"
	return result;
#line 4759 "application-window.c"
}


void
peek_ui_application_window_set_recording_start_delay (PeekUiApplicationWindow* self,
                                                      gint value)
{
#line 29 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/ui/application-window.vala"
	if (peek_ui_application_window_get_recording_start_delay (self) != value) {
#line 29 "../src/ui/application-window.vala"
		self->priv->_recording_start_delay = value;
#line 29 "../src/ui/application-window.vala"
		g_object_notify_by_pspec ((GObject *) self, peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_RECORDING_START_DELAY_PROPERTY]);
#line 4775 "application-window.c"
	}
}


const gchar*
peek_ui_application_window_get_default_file_name_format (PeekUiApplicationWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 31 "../src/ui/application-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->_default_file_name_format;
#line 31 "../src/ui/application-window.vala"
	result = _tmp0_;
#line 31 "../src/ui/application-window.vala"
	return result;
#line 4793 "application-window.c"
}


void
peek_ui_application_window_set_default_file_name_format (PeekUiApplicationWindow* self,
                                                         const gchar* value)
{
#line 31 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/ui/application-window.vala"
	if (g_strcmp0 (value, peek_ui_application_window_get_default_file_name_format (self)) != 0) {
#line 4805 "application-window.c"
		gchar* _tmp0_;
#line 31 "../src/ui/application-window.vala"
		_tmp0_ = g_strdup (value);
#line 31 "../src/ui/application-window.vala"
		_g_free0 (self->priv->_default_file_name_format);
#line 31 "../src/ui/application-window.vala"
		self->priv->_default_file_name_format = _tmp0_;
#line 31 "../src/ui/application-window.vala"
		g_object_notify_by_pspec ((GObject *) self, peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_DEFAULT_FILE_NAME_FORMAT_PROPERTY]);
#line 4815 "application-window.c"
	}
}


const gchar*
peek_ui_application_window_get_save_folder (PeekUiApplicationWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 33 "../src/ui/application-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../src/ui/application-window.vala"
	_tmp0_ = self->priv->_save_folder;
#line 33 "../src/ui/application-window.vala"
	result = _tmp0_;
#line 33 "../src/ui/application-window.vala"
	return result;
#line 4833 "application-window.c"
}


void
peek_ui_application_window_set_save_folder (PeekUiApplicationWindow* self,
                                            const gchar* value)
{
#line 33 "../src/ui/application-window.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/ui/application-window.vala"
	if (g_strcmp0 (value, peek_ui_application_window_get_save_folder (self)) != 0) {
#line 4845 "application-window.c"
		gchar* _tmp0_;
#line 33 "../src/ui/application-window.vala"
		_tmp0_ = g_strdup (value);
#line 33 "../src/ui/application-window.vala"
		_g_free0 (self->priv->_save_folder);
#line 33 "../src/ui/application-window.vala"
		self->priv->_save_folder = _tmp0_;
#line 33 "../src/ui/application-window.vala"
		g_object_notify_by_pspec ((GObject *) self, peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_SAVE_FOLDER_PROPERTY]);
#line 4855 "application-window.c"
	}
}


static void
peek_ui_application_window_class_init (PeekUiApplicationWindowClass * klass)
{
#line 20 "../src/ui/application-window.vala"
	peek_ui_application_window_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/ui/application-window.vala"
	g_type_class_adjust_private_offset (klass, &PeekUiApplicationWindow_private_offset);
#line 20 "../src/ui/application-window.vala"
	((GtkWidgetClass *) klass)->configure_event = (gboolean (*) (GtkWidget*, GdkEventConfigure*)) peek_ui_application_window_real_configure_event;
#line 20 "../src/ui/application-window.vala"
	((GtkWidgetClass *) klass)->delete_event = (gboolean (*) (GtkWidget*, GdkEventAny*)) peek_ui_application_window_real_delete_event;
#line 20 "../src/ui/application-window.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_peek_ui_application_window_get_property;
#line 20 "../src/ui/application-window.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_peek_ui_application_window_set_property;
#line 20 "../src/ui/application-window.vala"
	G_OBJECT_CLASS (klass)->finalize = peek_ui_application_window_finalize;
#line 20 "../src/ui/application-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PEEK_UI_APPLICATION_WINDOW_RECORDER_PROPERTY, peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_RECORDER_PROPERTY] = g_param_spec_object ("recorder", "recorder", "recorder", PEEK_RECORDING_TYPE_SCREEN_RECORDER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 20 "../src/ui/application-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PEEK_UI_APPLICATION_WINDOW_OPEN_FILE_MANAGER_PROPERTY, peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_OPEN_FILE_MANAGER_PROPERTY] = g_param_spec_boolean ("open-file-manager", "open-file-manager", "open-file-manager", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 20 "../src/ui/application-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PEEK_UI_APPLICATION_WINDOW_SHOW_NOTIFICATION_PROPERTY, peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_SHOW_NOTIFICATION_PROPERTY] = g_param_spec_boolean ("show-notification", "show-notification", "show-notification", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 20 "../src/ui/application-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PEEK_UI_APPLICATION_WINDOW_SIZE_INDICATOR_DELAY_PROPERTY, peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_SIZE_INDICATOR_DELAY_PROPERTY] = g_param_spec_int ("size-indicator-delay", "size-indicator-delay", "size-indicator-delay", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 20 "../src/ui/application-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PEEK_UI_APPLICATION_WINDOW_RECORDING_START_DELAY_PROPERTY, peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_RECORDING_START_DELAY_PROPERTY] = g_param_spec_int ("recording-start-delay", "recording-start-delay", "recording-start-delay", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 20 "../src/ui/application-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PEEK_UI_APPLICATION_WINDOW_DEFAULT_FILE_NAME_FORMAT_PROPERTY, peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_DEFAULT_FILE_NAME_FORMAT_PROPERTY] = g_param_spec_string ("default-file-name-format", "default-file-name-format", "default-file-name-format", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 20 "../src/ui/application-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PEEK_UI_APPLICATION_WINDOW_SAVE_FOLDER_PROPERTY, peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_SAVE_FOLDER_PROPERTY] = g_param_spec_string ("save-folder", "save-folder", "save-folder", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 20 "../src/ui/application-window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/com/uploadedlobster/peek/application-window.ui");
#line 20 "../src/ui/application-window.vala"
	peek_ui_application_window_signals[PEEK_UI_APPLICATION_WINDOW_RECORDING_FINISHED_SIGNAL] = g_signal_new ("recording-finished", PEEK_UI_TYPE_APPLICATION_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 20 "../src/ui/application-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "headerbar", FALSE, PeekUiApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekUiApplicationWindowPrivate, headerbar));
#line 20 "../src/ui/application-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "recording_view", FALSE, PeekUiApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekUiApplicationWindowPrivate, recording_view));
#line 20 "../src/ui/application-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "record_button", FALSE, PeekUiApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekUiApplicationWindowPrivate, record_button));
#line 20 "../src/ui/application-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "stop_button", FALSE, PeekUiApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekUiApplicationWindowPrivate, stop_button));
#line 20 "../src/ui/application-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "pop_format", FALSE, PeekUiApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekUiApplicationWindowPrivate, pop_format));
#line 20 "../src/ui/application-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "pop_format_menu", FALSE, PeekUiApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekUiApplicationWindowPrivate, pop_format_menu));
#line 20 "../src/ui/application-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "size_indicator", FALSE, PeekUiApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekUiApplicationWindowPrivate, size_indicator));
#line 20 "../src/ui/application-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "delay_indicator", FALSE, PeekUiApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekUiApplicationWindowPrivate, delay_indicator));
#line 20 "../src/ui/application-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "shortcut_label", FALSE, PeekUiApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekUiApplicationWindowPrivate, shortcut_label));
#line 20 "../src/ui/application-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "pop_menu", FALSE, PeekUiApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekUiApplicationWindowPrivate, pop_menu));
#line 20 "../src/ui/application-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_window_screen_changed", G_CALLBACK(_peek_ui_application_window_on_window_screen_changed_gtk_widget_screen_changed));
#line 20 "../src/ui/application-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_window_draw", G_CALLBACK(_peek_ui_application_window_on_window_draw_gtk_widget_draw));
#line 20 "../src/ui/application-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_recording_view_draw", G_CALLBACK(_peek_ui_application_window_on_recording_view_draw_gtk_widget_draw));
#line 20 "../src/ui/application-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_recording_view_size_allocate", G_CALLBACK(_peek_ui_application_window_on_recording_view_size_allocate_gtk_widget_size_allocate));
#line 20 "../src/ui/application-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_gif_button_clicked", G_CALLBACK(_peek_ui_application_window_on_gif_button_clicked_gtk_button_clicked));
#line 20 "../src/ui/application-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_apng_button_clicked", G_CALLBACK(_peek_ui_application_window_on_apng_button_clicked_gtk_button_clicked));
#line 20 "../src/ui/application-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_webm_button_clicked", G_CALLBACK(_peek_ui_application_window_on_webm_button_clicked_gtk_button_clicked));
#line 20 "../src/ui/application-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_mp4_button_clicked", G_CALLBACK(_peek_ui_application_window_on_mp4_button_clicked_gtk_button_clicked));
#line 20 "../src/ui/application-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_record_button_clicked", G_CALLBACK(_peek_ui_application_window_on_record_button_clicked_gtk_button_clicked));
#line 20 "../src/ui/application-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_stop_button_clicked", G_CALLBACK(_peek_ui_application_window_on_stop_button_clicked_gtk_button_clicked));
#line 20 "../src/ui/application-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_new_window_button_clicked", G_CALLBACK(_peek_ui_application_window_on_new_window_button_clicked_gtk_button_clicked));
#line 20 "../src/ui/application-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_preferences_button_clicked", G_CALLBACK(_peek_ui_application_window_on_preferences_button_clicked_gtk_button_clicked));
#line 20 "../src/ui/application-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_about_button_clicked", G_CALLBACK(_peek_ui_application_window_on_about_button_clicked_gtk_button_clicked));
#line 4941 "application-window.c"
}


static void
peek_ui_application_window_instance_init (PeekUiApplicationWindow * self)
{
#line 20 "../src/ui/application-window.vala"
	self->priv = peek_ui_application_window_get_instance_private (self);
#line 65 "../src/ui/application-window.vala"
	self->priv->start_recording_event_source = (guint) 0;
#line 66 "../src/ui/application-window.vala"
	self->priv->size_indicator_timeout = (guint) 0;
#line 67 "../src/ui/application-window.vala"
	self->priv->delay_indicator_timeout = (guint) 0;
#line 68 "../src/ui/application-window.vala"
	self->priv->time_indicator_timeout = (guint) 0;
#line 69 "../src/ui/application-window.vala"
	self->priv->is_recording = FALSE;
#line 70 "../src/ui/application-window.vala"
	self->priv->is_postprocessing = FALSE;
#line 20 "../src/ui/application-window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 4964 "application-window.c"
}


static void
peek_ui_application_window_finalize (GObject * obj)
{
	PeekUiApplicationWindow * self;
#line 20 "../src/ui/application-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PEEK_UI_TYPE_APPLICATION_WINDOW, PeekUiApplicationWindow);
#line 21 "../src/ui/application-window.vala"
	_g_object_unref0 (self->priv->_recorder);
#line 31 "../src/ui/application-window.vala"
	_g_free0 (self->priv->_default_file_name_format);
#line 33 "../src/ui/application-window.vala"
	_g_free0 (self->priv->_save_folder);
#line 36 "../src/ui/application-window.vala"
	_g_object_unref0 (self->priv->headerbar);
#line 39 "../src/ui/application-window.vala"
	_g_object_unref0 (self->priv->recording_view);
#line 42 "../src/ui/application-window.vala"
	_g_object_unref0 (self->priv->record_button);
#line 45 "../src/ui/application-window.vala"
	_g_object_unref0 (self->priv->stop_button);
#line 48 "../src/ui/application-window.vala"
	_g_object_unref0 (self->priv->pop_format);
#line 51 "../src/ui/application-window.vala"
	_g_object_unref0 (self->priv->pop_format_menu);
#line 54 "../src/ui/application-window.vala"
	_g_object_unref0 (self->priv->size_indicator);
#line 57 "../src/ui/application-window.vala"
	_g_object_unref0 (self->priv->delay_indicator);
#line 60 "../src/ui/application-window.vala"
	_g_object_unref0 (self->priv->shortcut_label);
#line 63 "../src/ui/application-window.vala"
	_g_object_unref0 (self->priv->pop_menu);
#line 71 "../src/ui/application-window.vala"
	_g_object_unref0 (self->priv->in_file);
#line 72 "../src/ui/application-window.vala"
	_g_object_unref0 (self->priv->out_file);
#line 73 "../src/ui/application-window.vala"
	peek_recording_recording_area_destroy (&self->priv->active_recording_area);
#line 74 "../src/ui/application-window.vala"
	_g_free0 (self->priv->stop_button_label);
#line 78 "../src/ui/application-window.vala"
	_g_object_unref0 (self->priv->settings);
#line 20 "../src/ui/application-window.vala"
	G_OBJECT_CLASS (peek_ui_application_window_parent_class)->finalize (obj);
#line 5012 "application-window.c"
}


GType
peek_ui_application_window_get_type (void)
{
	static volatile gsize peek_ui_application_window_type_id__volatile = 0;
	if (g_once_init_enter (&peek_ui_application_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PeekUiApplicationWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) peek_ui_application_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PeekUiApplicationWindow), 0, (GInstanceInitFunc) peek_ui_application_window_instance_init, NULL };
		GType peek_ui_application_window_type_id;
		peek_ui_application_window_type_id = g_type_register_static (gtk_application_window_get_type (), "PeekUiApplicationWindow", &g_define_type_info, 0);
		PeekUiApplicationWindow_private_offset = g_type_add_instance_private (peek_ui_application_window_type_id, sizeof (PeekUiApplicationWindowPrivate));
		g_once_init_leave (&peek_ui_application_window_type_id__volatile, peek_ui_application_window_type_id);
	}
	return peek_ui_application_window_type_id__volatile;
}


static void
_vala_peek_ui_application_window_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	PeekUiApplicationWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PEEK_UI_TYPE_APPLICATION_WINDOW, PeekUiApplicationWindow);
#line 20 "../src/ui/application-window.vala"
	switch (property_id) {
#line 20 "../src/ui/application-window.vala"
		case PEEK_UI_APPLICATION_WINDOW_RECORDER_PROPERTY:
#line 20 "../src/ui/application-window.vala"
		g_value_set_object (value, peek_ui_application_window_get_recorder (self));
#line 20 "../src/ui/application-window.vala"
		break;
#line 20 "../src/ui/application-window.vala"
		case PEEK_UI_APPLICATION_WINDOW_OPEN_FILE_MANAGER_PROPERTY:
#line 20 "../src/ui/application-window.vala"
		g_value_set_boolean (value, peek_ui_application_window_get_open_file_manager (self));
#line 20 "../src/ui/application-window.vala"
		break;
#line 20 "../src/ui/application-window.vala"
		case PEEK_UI_APPLICATION_WINDOW_SHOW_NOTIFICATION_PROPERTY:
#line 20 "../src/ui/application-window.vala"
		g_value_set_boolean (value, peek_ui_application_window_get_show_notification (self));
#line 20 "../src/ui/application-window.vala"
		break;
#line 20 "../src/ui/application-window.vala"
		case PEEK_UI_APPLICATION_WINDOW_SIZE_INDICATOR_DELAY_PROPERTY:
#line 20 "../src/ui/application-window.vala"
		g_value_set_int (value, peek_ui_application_window_get_size_indicator_delay (self));
#line 20 "../src/ui/application-window.vala"
		break;
#line 20 "../src/ui/application-window.vala"
		case PEEK_UI_APPLICATION_WINDOW_RECORDING_START_DELAY_PROPERTY:
#line 20 "../src/ui/application-window.vala"
		g_value_set_int (value, peek_ui_application_window_get_recording_start_delay (self));
#line 20 "../src/ui/application-window.vala"
		break;
#line 20 "../src/ui/application-window.vala"
		case PEEK_UI_APPLICATION_WINDOW_DEFAULT_FILE_NAME_FORMAT_PROPERTY:
#line 20 "../src/ui/application-window.vala"
		g_value_set_string (value, peek_ui_application_window_get_default_file_name_format (self));
#line 20 "../src/ui/application-window.vala"
		break;
#line 20 "../src/ui/application-window.vala"
		case PEEK_UI_APPLICATION_WINDOW_SAVE_FOLDER_PROPERTY:
#line 20 "../src/ui/application-window.vala"
		g_value_set_string (value, peek_ui_application_window_get_save_folder (self));
#line 20 "../src/ui/application-window.vala"
		break;
#line 5083 "application-window.c"
		default:
#line 20 "../src/ui/application-window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/ui/application-window.vala"
		break;
#line 5089 "application-window.c"
	}
}


static void
_vala_peek_ui_application_window_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	PeekUiApplicationWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PEEK_UI_TYPE_APPLICATION_WINDOW, PeekUiApplicationWindow);
#line 20 "../src/ui/application-window.vala"
	switch (property_id) {
#line 20 "../src/ui/application-window.vala"
		case PEEK_UI_APPLICATION_WINDOW_RECORDER_PROPERTY:
#line 20 "../src/ui/application-window.vala"
		peek_ui_application_window_set_recorder (self, g_value_get_object (value));
#line 20 "../src/ui/application-window.vala"
		break;
#line 20 "../src/ui/application-window.vala"
		case PEEK_UI_APPLICATION_WINDOW_OPEN_FILE_MANAGER_PROPERTY:
#line 20 "../src/ui/application-window.vala"
		peek_ui_application_window_set_open_file_manager (self, g_value_get_boolean (value));
#line 20 "../src/ui/application-window.vala"
		break;
#line 20 "../src/ui/application-window.vala"
		case PEEK_UI_APPLICATION_WINDOW_SHOW_NOTIFICATION_PROPERTY:
#line 20 "../src/ui/application-window.vala"
		peek_ui_application_window_set_show_notification (self, g_value_get_boolean (value));
#line 20 "../src/ui/application-window.vala"
		break;
#line 20 "../src/ui/application-window.vala"
		case PEEK_UI_APPLICATION_WINDOW_SIZE_INDICATOR_DELAY_PROPERTY:
#line 20 "../src/ui/application-window.vala"
		peek_ui_application_window_set_size_indicator_delay (self, g_value_get_int (value));
#line 20 "../src/ui/application-window.vala"
		break;
#line 20 "../src/ui/application-window.vala"
		case PEEK_UI_APPLICATION_WINDOW_RECORDING_START_DELAY_PROPERTY:
#line 20 "../src/ui/application-window.vala"
		peek_ui_application_window_set_recording_start_delay (self, g_value_get_int (value));
#line 20 "../src/ui/application-window.vala"
		break;
#line 20 "../src/ui/application-window.vala"
		case PEEK_UI_APPLICATION_WINDOW_DEFAULT_FILE_NAME_FORMAT_PROPERTY:
#line 20 "../src/ui/application-window.vala"
		peek_ui_application_window_set_default_file_name_format (self, g_value_get_string (value));
#line 20 "../src/ui/application-window.vala"
		break;
#line 20 "../src/ui/application-window.vala"
		case PEEK_UI_APPLICATION_WINDOW_SAVE_FOLDER_PROPERTY:
#line 20 "../src/ui/application-window.vala"
		peek_ui_application_window_set_save_folder (self, g_value_get_string (value));
#line 20 "../src/ui/application-window.vala"
		break;
#line 5146 "application-window.c"
		default:
#line 20 "../src/ui/application-window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/ui/application-window.vala"
		break;
#line 5152 "application-window.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



